#version 100 sc_convert_to 300 es
#if defined VERTEX_SHADER
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include <std2_vs.glsl>
#include <std2_fs.glsl>


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END

uniform mat3 cameraTextureTransform;
uniform vec4 leftSampleOffsetSize;
uniform vec4 rightSampleOffsetSize;

varying float varLerp;
varying vec2 varLeftSampleCoord;
varying vec2 varRightSampleCoord;

mat3 _2505;
vec2 _2518;
vec3 _2529;

void main()
{
sc_Vertex_t _2243=sc_LoadVertexAttributes();
vec2 _2454=_2243.texture0;
mat3 _2471=cameraTextureTransform;
_2471[0].x=cameraTextureTransform[0].x*leftSampleOffsetSize.z;
mat3 _2474=_2471;
_2474[1].y=cameraTextureTransform[1].y*leftSampleOffsetSize.w;
mat3 _2477=cameraTextureTransform;
_2477[0].x=cameraTextureTransform[0].x*rightSampleOffsetSize.z;
mat3 _2480=_2477;
_2480[1].y=cameraTextureTransform[1].y*rightSampleOffsetSize.w;
vec3 _2286=vec3((_2454*vec2(2.0))-vec2(1.0),1.0);
varLerp=1.0-_2454.x;
varLeftSampleCoord=(((_2286*_2474).xy+leftSampleOffsetSize.xy)*0.5)+vec2(0.5);
varRightSampleCoord=(((_2286*_2480).xy+rightSampleOffsetSize.xy)*0.5)+vec2(0.5);
sc_Vertex_t param=_2243;
sc_ProcessVertex(param);
}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include <std2_vs.glsl>
#include <std2_fs.glsl>


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END

#ifndef cameraTextureHasSwappedViews
#define cameraTextureHasSwappedViews 0
#elif cameraTextureHasSwappedViews==1
#undef cameraTextureHasSwappedViews
#define cameraTextureHasSwappedViews 1
#endif
#ifndef cameraTextureLayout
#define cameraTextureLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_cameraTexture
#define SC_SOFTWARE_WRAP_MODE_U_cameraTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_cameraTexture
#define SC_SOFTWARE_WRAP_MODE_V_cameraTexture -1
#endif
const ivec2 _1936=ivec2(SC_SOFTWARE_WRAP_MODE_U_cameraTexture,SC_SOFTWARE_WRAP_MODE_V_cameraTexture);
#ifndef SC_USE_UV_MIN_MAX_cameraTexture
#define SC_USE_UV_MIN_MAX_cameraTexture 0
#elif SC_USE_UV_MIN_MAX_cameraTexture==1
#undef SC_USE_UV_MIN_MAX_cameraTexture
#define SC_USE_UV_MIN_MAX_cameraTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_cameraTexture
#define SC_USE_CLAMP_TO_BORDER_cameraTexture 0
#elif SC_USE_CLAMP_TO_BORDER_cameraTexture==1
#undef SC_USE_CLAMP_TO_BORDER_cameraTexture
#define SC_USE_CLAMP_TO_BORDER_cameraTexture 1
#endif
const ivec2 _1960=ivec2(SC_SOFTWARE_WRAP_MODE_U_cameraTexture,SC_SOFTWARE_WRAP_MODE_V_cameraTexture);
const ivec2 _1987=ivec2(SC_SOFTWARE_WRAP_MODE_U_cameraTexture,SC_SOFTWARE_WRAP_MODE_V_cameraTexture);
const ivec2 _2007=ivec2(SC_SOFTWARE_WRAP_MODE_U_cameraTexture,SC_SOFTWARE_WRAP_MODE_V_cameraTexture);

uniform vec4 cameraTextureDims;
uniform mediump sampler2DArray cameraTextureArrSC;
uniform mediump sampler2D cameraTexture;
uniform vec4 cameraTextureUvMinMax;
uniform vec4 cameraTextureBorderColor;

varying vec2 varLeftSampleCoord;
varying vec2 varRightSampleCoord;
varying float varLerp;

int cameraTextureGetStereoViewIndex()
{
#if (cameraTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

void main()
{
vec4 _2243;
#if (cameraTextureLayout==2)
{
vec2 param=cameraTextureDims.xy;
int param_1=cameraTextureLayout;
int param_2=cameraTextureGetStereoViewIndex();
vec2 param_3=varLeftSampleCoord;
bool param_4=false;
mat3 param_5=mat3(vec3(1.0,0.0,0.0),vec3(0.0,1.0,0.0),vec3(0.0,0.0,1.0));
ivec2 param_6=_1936;
bool param_7=(int(SC_USE_UV_MIN_MAX_cameraTexture)!=0);
vec4 param_8=cameraTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_cameraTexture)!=0);
vec4 param_10=cameraTextureBorderColor;
float param_11=0.0;
_2243=sc_SampleTexture(cameraTextureArrSC,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
vec2 param_12=cameraTextureDims.xy;
int param_13=cameraTextureLayout;
int param_14=cameraTextureGetStereoViewIndex();
vec2 param_15=varLeftSampleCoord;
bool param_16=false;
mat3 param_17=mat3(vec3(1.0,0.0,0.0),vec3(0.0,1.0,0.0),vec3(0.0,0.0,1.0));
ivec2 param_18=_1960;
bool param_19=(int(SC_USE_UV_MIN_MAX_cameraTexture)!=0);
vec4 param_20=cameraTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_cameraTexture)!=0);
vec4 param_22=cameraTextureBorderColor;
float param_23=0.0;
_2243=sc_SampleTexture(cameraTexture,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
vec4 _2244;
#if (cameraTextureLayout==2)
{
vec2 param_24=cameraTextureDims.xy;
int param_25=cameraTextureLayout;
int param_26=cameraTextureGetStereoViewIndex();
vec2 param_27=varRightSampleCoord;
bool param_28=false;
mat3 param_29=mat3(vec3(1.0,0.0,0.0),vec3(0.0,1.0,0.0),vec3(0.0,0.0,1.0));
ivec2 param_30=_1987;
bool param_31=(int(SC_USE_UV_MIN_MAX_cameraTexture)!=0);
vec4 param_32=cameraTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_cameraTexture)!=0);
vec4 param_34=cameraTextureBorderColor;
float param_35=0.0;
_2244=sc_SampleTexture(cameraTextureArrSC,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
vec2 param_36=cameraTextureDims.xy;
int param_37=cameraTextureLayout;
int param_38=cameraTextureGetStereoViewIndex();
vec2 param_39=varRightSampleCoord;
bool param_40=false;
mat3 param_41=mat3(vec3(1.0,0.0,0.0),vec3(0.0,1.0,0.0),vec3(0.0,0.0,1.0));
ivec2 param_42=_2007;
bool param_43=(int(SC_USE_UV_MIN_MAX_cameraTexture)!=0);
vec4 param_44=cameraTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_cameraTexture)!=0);
vec4 param_46=cameraTextureBorderColor;
float param_47=0.0;
_2244=sc_SampleTexture(cameraTexture,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
vec4 param_48=vec4(mix(_2243.xyz,_2244.xyz,vec3(varLerp)),1.0);
sc_writeFragData0(param_48);
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
