#pragma once
#if defined VERTEX_SHADER


#define sc_StereoRendering_Disabled 0
#define sc_StereoRendering_InstancedClipped 1
#define sc_StereoRendering_Multiview 2


#ifdef GL_ES
    #define SC_GLES_VERSION_20 2000
    #define SC_GLES_VERSION_30 3000
    #define SC_GLES_VERSION_31 3100
    #define SC_GLES_VERSION_32 3200
#endif 
#ifdef VERTEX_SHADER
    
    #define scOutPos(clipPosition) gl_Position=clipPosition
    
    
    #define MAIN main
#endif 
#ifdef SC_ENABLE_INSTANCED_RENDERING

    
    
    #ifndef sc_EnableInstancing
        #define sc_EnableInstancing 1
    #endif 
#endif 
#define mod(x,y) (x-y*floor((x+1e-6)/y)) 
#if defined(GL_ES)&&(__VERSION__<300)&&!defined(GL_OES_standard_derivatives)
#define dFdx(A) (A)
#define dFdy(A) (A)
#define fwidth(A) (A)
#endif

#ifdef sc_EnableFeatureLevelES3

    
    
    
    #ifdef sc_EnableStereoClipDistance

        #if defined(GL_APPLE_clip_distance)
            #extension GL_APPLE_clip_distance : require
        #elif defined(GL_EXT_clip_cull_distance) 
            #extension GL_EXT_clip_cull_distance : require
        #else 
            
            #error Clip distance is requested but not supported by this device.
        #endif 
    #endif 
#else 
    #ifdef sc_EnableStereoClipDistance
        
        #error Clip distance is requested but not supported by this device.
    #endif 
#endif 
#ifdef sc_EnableFeatureLevelES3

    #ifdef VERTEX_SHADER
        #define attribute in
        #define varying out
    #endif 
    #ifdef FRAGMENT_SHADER
        #define varying in
    #endif 
    #define gl_FragColor sc_FragData0
    #define texture2D texture
    #define texture2DLod textureLod
    #define texture2DLodEXT textureLod
    #define textureCubeLodEXT textureLod
    #define sc_CanUseTextureLod 1

#elif __VERSION__==120

    #ifdef GL_ARB_shader_texture_lod
        #define sc_CanUseTextureLod 1
    #endif

#else

    #ifdef FRAGMENT_SHADER
        #ifdef GL_ARB_shader_texture_lod
            #define sc_CanUseTextureLod 1
        #elif defined(GL_EXT_shader_texture_lod) 
            #extension GL_EXT_shader_texture_lod : require
            #define sc_CanUseTextureLod 1
            #define texture2DLod texture2DLodEXT
            #ifdef GL_ARM_shader_framebuffer_fetch 
                #define textureCubeLod textureCubeLodEXT
            #endif 
        #endif 
    #endif 
#endif 
#if defined(sc_EnableMultiviewStereoRendering)

    #define sc_StereoRenderingMode sc_StereoRendering_Multiview
    #define sc_NumStereoViews 2

    #extension GL_OVR_multiview2 : require

    #ifdef VERTEX_SHADER

        #ifdef sc_EnableInstancingFallback
            
            #define sc_GlobalInstanceID (sc_FallbackInstanceID*2+gl_InstanceID)
        #else 
            #define sc_GlobalInstanceID gl_InstanceID
        #endif 
        #define sc_LocalInstanceID sc_GlobalInstanceID

        
        #define sc_StereoViewID int(gl_ViewID_OVR)

    #endif 
#elif defined(sc_EnableInstancedClippedStereoRendering)

    
    
    
    
    
    #ifndef sc_EnableInstancing
        #error Instanced-clipped stereo rendering requires enabled instancing.
    #endif 
    
    
    
    #ifndef sc_EnableStereoClipDistance
        #define sc_StereoRendering_IsClipDistanceEnabled 0
    #else 
        #define sc_StereoRendering_IsClipDistanceEnabled 1
    #endif 
    #define sc_StereoRenderingMode sc_StereoRendering_InstancedClipped
    #define sc_NumStereoClipPlanes 1
    #define sc_NumStereoViews 2

    #ifdef VERTEX_SHADER

        #ifdef sc_EnableInstancingFallback
            
            #define sc_GlobalInstanceID (sc_FallbackInstanceID*2+gl_InstanceID)
        #else 
            #define sc_GlobalInstanceID gl_InstanceID
        #endif 
        #ifdef sc_EnableFeatureLevelES3
            #define sc_LocalInstanceID (sc_GlobalInstanceID/2)
            #define sc_StereoViewID (sc_GlobalInstanceID%2)
        #else 
            #define sc_LocalInstanceID int(sc_GlobalInstanceID/2.0)
            #define sc_StereoViewID int(mod(sc_GlobalInstanceID,2.0))
        #endif 
    #endif 
#else
    #define sc_StereoRenderingMode sc_StereoRendering_Disabled
#endif

#ifdef VERTEX_SHADER
    #ifdef sc_EnableInstancing

        
        
        
        
        
        
        
        
        #ifdef GL_ES
            
            #if defined(sc_EnableFeatureLevelES2)&&!defined(GL_EXT_draw_instanced)
                #define gl_InstanceID (0)
            #endif 
        #else 
            #if defined(sc_EnableFeatureLevelES2)&&!defined(GL_EXT_draw_instanced)&&!defined(GL_ARB_draw_instanced)&&!defined(GL_EXT_gpu_shader4)
                
                #define gl_InstanceID (0)
            #endif 
        #endif 
        #ifdef GL_ARB_draw_instanced
            
            #extension GL_ARB_draw_instanced : require
            #define gl_InstanceID gl_InstanceIDARB
        #endif 
        #ifdef GL_EXT_draw_instanced
            
            #extension GL_EXT_draw_instanced : require
            #define gl_InstanceID gl_InstanceIDEXT
        #endif 
        
        #ifndef sc_InstanceID
            #define sc_InstanceID gl_InstanceID
        #endif 
        
        
        #ifndef sc_GlobalInstanceID
            #ifdef sc_EnableInstancingFallback
                #define sc_GlobalInstanceID (sc_FallbackInstanceID)
                #define sc_LocalInstanceID (sc_FallbackInstanceID)
            #else 
                #define sc_GlobalInstanceID gl_InstanceID
                #define sc_LocalInstanceID gl_InstanceID
            #endif 
        #endif 
    #endif 
#endif 
#ifdef VERTEX_SHADER
    #if (__VERSION__<300)&&!defined(GL_EXT_gpu_shader4)
        #define gl_VertexID (0)
    #endif 
#endif 
#ifndef GL_ES

    
    
        #extension GL_EXT_gpu_shader4 : enable
    
    #ifdef GL_ARB_shader_texture_lod
        #extension GL_ARB_shader_texture_lod : require
    #endif 
    #define precision
    #define lowp
    #define mediump
    #define highp
    #define sc_FragmentPrecision

#endif 
#ifdef sc_EnableFeatureLevelES3
    #define sc_CanUseSampler2DArray 1
#endif

#if defined(sc_EnableFeatureLevelES2)&&defined(GL_ES)

    #ifdef FRAGMENT_SHADER
        #ifdef GL_OES_standard_derivatives
            #extension GL_OES_standard_derivatives : require
            #define sc_CanUseStandardDerivatives 1
        #endif 
    #endif 
    #ifdef GL_EXT_texture_array
        #extension GL_EXT_texture_array : require
        #define sc_CanUseSampler2DArray 1
    #else
        #define sc_CanUseSampler2DArray 0
    #endif

#endif 
#ifdef GL_ES

    
    
    
    #ifdef sc_FramebufferFetch

        
        
        
        
        
        #if defined(GL_EXT_shader_framebuffer_fetch)
            #extension GL_EXT_shader_framebuffer_fetch : require
            
        #elif defined(GL_ARM_shader_framebuffer_fetch) 
            #extension GL_ARM_shader_framebuffer_fetch : require
            
        #else 
            
            #error Framebuffer fetch is requested but not supported by this device.
        #endif 
    #endif 
    
    
    
    #ifdef GL_FRAGMENT_PRECISION_HIGH
        #define sc_FragmentPrecision highp
    #else 
        #define sc_FragmentPrecision mediump
    #endif 
    precision highp int;
    precision highp float;

#endif 
#ifdef VERTEX_SHADER
    #ifdef sc_EnableMultiviewStereoRendering
        layout(num_views=sc_NumStereoViews) in;
    #endif 
#endif 
#ifdef FRAGMENT_SHADER

    
    
    
    #ifndef GL_ES

        #ifndef sc_FragmentPrecision
        #define sc_FragmentPrecision
        #endif 
        
        
        
        
        #ifdef FRAGMENT_SHADER
            #define sc_FragData0 gl_FragData[0]
            #define sc_FragData1 gl_FragData[1]
            #define sc_FragData2 gl_FragData[2]
            #define sc_FragData3 gl_FragData[3]
        #endif 
        mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
        #define gl_LastFragData (getFragData())

        #ifdef sc_FramebufferFetch
            
            #error Framebuffer fetch is requested but not supported by this device.
        #endif 
    #elif defined(sc_EnableFeatureLevelES3) 
        
        #ifndef sc_FragDataCount
            #ifndef sc_MultipleRenderTarget
                #define sc_FragDataCount 1
            #else 
                #define sc_FragDataCount sc_MultipleRenderTarget
            #endif 
        #endif 
        #define sc_DeclareFragData0(StorageQualifier) layout(location=0) StorageQualifier sc_FragmentPrecision vec4 sc_FragData0

        #if sc_FragDataCount>=2
            #define sc_DeclareFragData1(StorageQualifier) layout(location=1) StorageQualifier sc_FragmentPrecision vec4 sc_FragData1
        #endif 
        #if sc_FragDataCount>=3
            #define sc_DeclareFragData2(StorageQualifier) layout(location=2) StorageQualifier sc_FragmentPrecision vec4 sc_FragData2
        #endif 
        #if sc_FragDataCount>=4
            #define sc_DeclareFragData3(StorageQualifier) layout(location=3) StorageQualifier sc_FragmentPrecision vec4 sc_FragData3
        #endif 
        #ifndef sc_DeclareFragData1
            #define sc_DeclareFragData1(_) const vec4 sc_FragData1=vec4(0.0)
        #endif 
        #ifndef sc_DeclareFragData2
            #define sc_DeclareFragData2(_) const vec4 sc_FragData2=vec4(0.0)
        #endif 
        #ifndef sc_DeclareFragData3
            #define sc_DeclareFragData3(_) const vec4 sc_FragData3=vec4(0.0)
        #endif 
        #ifdef sc_FramebufferFetch

            #ifdef GL_EXT_shader_framebuffer_fetch
                
                
                
                
                
                
                
                sc_DeclareFragData0(inout);
                sc_DeclareFragData1(inout);
                sc_DeclareFragData2(inout);
                sc_DeclareFragData3(inout);
                mediump mat4 getFragData() { return mat4(sc_FragData0,sc_FragData1,sc_FragData2,sc_FragData3); }
                #define gl_LastFragData (getFragData())
            #elif defined(GL_ARM_shader_framebuffer_fetch) 
                
                
                
                
                
                
                
                
                sc_DeclareFragData0(out);
                sc_DeclareFragData1(out);
                sc_DeclareFragData2(out);
                sc_DeclareFragData3(out);
                mediump mat4 getFragData() { return mat4(gl_LastFragColorARM,vec4(0.0),vec4(0.0),vec4(0.0)); }
                #define gl_LastFragData (getFragData())
            #endif 
        #else 
            
            
            
            
            
            #ifdef sc_EnableFeatureLevelES3
                sc_DeclareFragData0(out);
                sc_DeclareFragData1(out);
                sc_DeclareFragData2(out);
                sc_DeclareFragData3(out);
                mediump mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
                #define gl_LastFragData (getFragData())
            #endif 
        #endif 
    #elif defined(sc_EnableFeatureLevelES2) 
        #define sc_FragData0 gl_FragColor
        mediump mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
    #else
        #define sc_FragData0 gl_FragColor
        mediump mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
    #endif 
#endif 
#if __VERSION__>100
    #define SC_INT_FALLBACK_FLOAT int
    #define SC_INTERPOLATION_FLAT flat
    #define SC_INTERPOLATION_CENTROID centroid
#else
    #define SC_INT_FALLBACK_FLOAT float
    #define SC_INTERPOLATION_FLAT
    #define SC_INTERPOLATION_CENTROID
#endif

#ifndef sc_NumStereoViews
    #define sc_NumStereoViews 1
#endif

#ifndef sc_CanUseSampler2DArray
    #define sc_CanUseSampler2DArray 0
#endif




//SG_REFLECTION_BEGIN
//SG_REFLECTION_END

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER


#define sc_StereoRendering_Disabled 0
#define sc_StereoRendering_InstancedClipped 1
#define sc_StereoRendering_Multiview 2


#ifdef GL_ES
    #define SC_GLES_VERSION_20 2000
    #define SC_GLES_VERSION_30 3000
    #define SC_GLES_VERSION_31 3100
    #define SC_GLES_VERSION_32 3200
#endif 
#ifdef VERTEX_SHADER
    
    #define scOutPos(clipPosition) gl_Position=clipPosition
    
    
    #define MAIN main
#endif 
#ifdef SC_ENABLE_INSTANCED_RENDERING

    
    
    #ifndef sc_EnableInstancing
        #define sc_EnableInstancing 1
    #endif 
#endif 
#define mod(x,y) (x-y*floor((x+1e-6)/y)) 
#if defined(GL_ES)&&(__VERSION__<300)&&!defined(GL_OES_standard_derivatives)
#define dFdx(A) (A)
#define dFdy(A) (A)
#define fwidth(A) (A)
#endif

#ifdef sc_EnableFeatureLevelES3

    
    
    
    #ifdef sc_EnableStereoClipDistance

        #if defined(GL_APPLE_clip_distance)
            #extension GL_APPLE_clip_distance : require
        #elif defined(GL_EXT_clip_cull_distance) 
            #extension GL_EXT_clip_cull_distance : require
        #else 
            
            #error Clip distance is requested but not supported by this device.
        #endif 
    #endif 
#else 
    #ifdef sc_EnableStereoClipDistance
        
        #error Clip distance is requested but not supported by this device.
    #endif 
#endif 
#ifdef sc_EnableFeatureLevelES3

    #ifdef VERTEX_SHADER
        #define attribute in
        #define varying out
    #endif 
    #ifdef FRAGMENT_SHADER
        #define varying in
    #endif 
    #define gl_FragColor sc_FragData0
    #define texture2D texture
    #define texture2DLod textureLod
    #define texture2DLodEXT textureLod
    #define textureCubeLodEXT textureLod
    #define sc_CanUseTextureLod 1

#elif __VERSION__==120

    #ifdef GL_ARB_shader_texture_lod
        #define sc_CanUseTextureLod 1
    #endif

#else

    #ifdef FRAGMENT_SHADER
        #ifdef GL_ARB_shader_texture_lod
            #define sc_CanUseTextureLod 1
        #elif defined(GL_EXT_shader_texture_lod) 
            #extension GL_EXT_shader_texture_lod : require
            #define sc_CanUseTextureLod 1
            #define texture2DLod texture2DLodEXT
            #ifdef GL_ARM_shader_framebuffer_fetch 
                #define textureCubeLod textureCubeLodEXT
            #endif 
        #endif 
    #endif 
#endif 
#if defined(sc_EnableMultiviewStereoRendering)

    #define sc_StereoRenderingMode sc_StereoRendering_Multiview
    #define sc_NumStereoViews 2

    #extension GL_OVR_multiview2 : require

    #ifdef VERTEX_SHADER

        #ifdef sc_EnableInstancingFallback
            
            #define sc_GlobalInstanceID (sc_FallbackInstanceID*2+gl_InstanceID)
        #else 
            #define sc_GlobalInstanceID gl_InstanceID
        #endif 
        #define sc_LocalInstanceID sc_GlobalInstanceID

        
        #define sc_StereoViewID int(gl_ViewID_OVR)

    #endif 
#elif defined(sc_EnableInstancedClippedStereoRendering)

    
    
    
    
    
    #ifndef sc_EnableInstancing
        #error Instanced-clipped stereo rendering requires enabled instancing.
    #endif 
    
    
    
    #ifndef sc_EnableStereoClipDistance
        #define sc_StereoRendering_IsClipDistanceEnabled 0
    #else 
        #define sc_StereoRendering_IsClipDistanceEnabled 1
    #endif 
    #define sc_StereoRenderingMode sc_StereoRendering_InstancedClipped
    #define sc_NumStereoClipPlanes 1
    #define sc_NumStereoViews 2

    #ifdef VERTEX_SHADER

        #ifdef sc_EnableInstancingFallback
            
            #define sc_GlobalInstanceID (sc_FallbackInstanceID*2+gl_InstanceID)
        #else 
            #define sc_GlobalInstanceID gl_InstanceID
        #endif 
        #ifdef sc_EnableFeatureLevelES3
            #define sc_LocalInstanceID (sc_GlobalInstanceID/2)
            #define sc_StereoViewID (sc_GlobalInstanceID%2)
        #else 
            #define sc_LocalInstanceID int(sc_GlobalInstanceID/2.0)
            #define sc_StereoViewID int(mod(sc_GlobalInstanceID,2.0))
        #endif 
    #endif 
#else
    #define sc_StereoRenderingMode sc_StereoRendering_Disabled
#endif

#ifdef VERTEX_SHADER
    #ifdef sc_EnableInstancing

        
        
        
        
        
        
        
        
        #ifdef GL_ES
            
            #if defined(sc_EnableFeatureLevelES2)&&!defined(GL_EXT_draw_instanced)
                #define gl_InstanceID (0)
            #endif 
        #else 
            #if defined(sc_EnableFeatureLevelES2)&&!defined(GL_EXT_draw_instanced)&&!defined(GL_ARB_draw_instanced)&&!defined(GL_EXT_gpu_shader4)
                
                #define gl_InstanceID (0)
            #endif 
        #endif 
        #ifdef GL_ARB_draw_instanced
            
            #extension GL_ARB_draw_instanced : require
            #define gl_InstanceID gl_InstanceIDARB
        #endif 
        #ifdef GL_EXT_draw_instanced
            
            #extension GL_EXT_draw_instanced : require
            #define gl_InstanceID gl_InstanceIDEXT
        #endif 
        
        #ifndef sc_InstanceID
            #define sc_InstanceID gl_InstanceID
        #endif 
        
        
        #ifndef sc_GlobalInstanceID
            #ifdef sc_EnableInstancingFallback
                #define sc_GlobalInstanceID (sc_FallbackInstanceID)
                #define sc_LocalInstanceID (sc_FallbackInstanceID)
            #else 
                #define sc_GlobalInstanceID gl_InstanceID
                #define sc_LocalInstanceID gl_InstanceID
            #endif 
        #endif 
    #endif 
#endif 
#ifdef VERTEX_SHADER
    #if (__VERSION__<300)&&!defined(GL_EXT_gpu_shader4)
        #define gl_VertexID (0)
    #endif 
#endif 
#ifndef GL_ES

    
    
        #extension GL_EXT_gpu_shader4 : enable
    
    #ifdef GL_ARB_shader_texture_lod
        #extension GL_ARB_shader_texture_lod : require
    #endif 
    #define precision
    #define lowp
    #define mediump
    #define highp
    #define sc_FragmentPrecision

#endif 
#ifdef sc_EnableFeatureLevelES3
    #define sc_CanUseSampler2DArray 1
#endif

#if defined(sc_EnableFeatureLevelES2)&&defined(GL_ES)

    #ifdef FRAGMENT_SHADER
        #ifdef GL_OES_standard_derivatives
            #extension GL_OES_standard_derivatives : require
            #define sc_CanUseStandardDerivatives 1
        #endif 
    #endif 
    #ifdef GL_EXT_texture_array
        #extension GL_EXT_texture_array : require
        #define sc_CanUseSampler2DArray 1
    #else
        #define sc_CanUseSampler2DArray 0
    #endif

#endif 
#ifdef GL_ES

    
    
    
    #ifdef sc_FramebufferFetch

        
        
        
        
        
        #if defined(GL_EXT_shader_framebuffer_fetch)
            #extension GL_EXT_shader_framebuffer_fetch : require
            
        #elif defined(GL_ARM_shader_framebuffer_fetch) 
            #extension GL_ARM_shader_framebuffer_fetch : require
            
        #else 
            
            #error Framebuffer fetch is requested but not supported by this device.
        #endif 
    #endif 
    
    
    
    #ifdef GL_FRAGMENT_PRECISION_HIGH
        #define sc_FragmentPrecision highp
    #else 
        #define sc_FragmentPrecision mediump
    #endif 
    precision highp int;
    precision highp float;

#endif 
#ifdef VERTEX_SHADER
    #ifdef sc_EnableMultiviewStereoRendering
        layout(num_views=sc_NumStereoViews) in;
    #endif 
#endif 
#ifdef FRAGMENT_SHADER

    
    
    
    #ifndef GL_ES

        #ifndef sc_FragmentPrecision
        #define sc_FragmentPrecision
        #endif 
        
        
        
        
        #ifdef FRAGMENT_SHADER
            #define sc_FragData0 gl_FragData[0]
            #define sc_FragData1 gl_FragData[1]
            #define sc_FragData2 gl_FragData[2]
            #define sc_FragData3 gl_FragData[3]
        #endif 
        mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
        #define gl_LastFragData (getFragData())

        #ifdef sc_FramebufferFetch
            
            #error Framebuffer fetch is requested but not supported by this device.
        #endif 
    #elif defined(sc_EnableFeatureLevelES3) 
        
        #ifndef sc_FragDataCount
            #ifndef sc_MultipleRenderTarget
                #define sc_FragDataCount 1
            #else 
                #define sc_FragDataCount sc_MultipleRenderTarget
            #endif 
        #endif 
        #define sc_DeclareFragData0(StorageQualifier) layout(location=0) StorageQualifier sc_FragmentPrecision vec4 sc_FragData0

        #if sc_FragDataCount>=2
            #define sc_DeclareFragData1(StorageQualifier) layout(location=1) StorageQualifier sc_FragmentPrecision vec4 sc_FragData1
        #endif 
        #if sc_FragDataCount>=3
            #define sc_DeclareFragData2(StorageQualifier) layout(location=2) StorageQualifier sc_FragmentPrecision vec4 sc_FragData2
        #endif 
        #if sc_FragDataCount>=4
            #define sc_DeclareFragData3(StorageQualifier) layout(location=3) StorageQualifier sc_FragmentPrecision vec4 sc_FragData3
        #endif 
        #ifndef sc_DeclareFragData1
            #define sc_DeclareFragData1(_) const vec4 sc_FragData1=vec4(0.0)
        #endif 
        #ifndef sc_DeclareFragData2
            #define sc_DeclareFragData2(_) const vec4 sc_FragData2=vec4(0.0)
        #endif 
        #ifndef sc_DeclareFragData3
            #define sc_DeclareFragData3(_) const vec4 sc_FragData3=vec4(0.0)
        #endif 
        #ifdef sc_FramebufferFetch

            #ifdef GL_EXT_shader_framebuffer_fetch
                
                
                
                
                
                
                
                sc_DeclareFragData0(inout);
                sc_DeclareFragData1(inout);
                sc_DeclareFragData2(inout);
                sc_DeclareFragData3(inout);
                mediump mat4 getFragData() { return mat4(sc_FragData0,sc_FragData1,sc_FragData2,sc_FragData3); }
                #define gl_LastFragData (getFragData())
            #elif defined(GL_ARM_shader_framebuffer_fetch) 
                
                
                
                
                
                
                
                
                sc_DeclareFragData0(out);
                sc_DeclareFragData1(out);
                sc_DeclareFragData2(out);
                sc_DeclareFragData3(out);
                mediump mat4 getFragData() { return mat4(gl_LastFragColorARM,vec4(0.0),vec4(0.0),vec4(0.0)); }
                #define gl_LastFragData (getFragData())
            #endif 
        #else 
            
            
            
            
            
            #ifdef sc_EnableFeatureLevelES3
                sc_DeclareFragData0(out);
                sc_DeclareFragData1(out);
                sc_DeclareFragData2(out);
                sc_DeclareFragData3(out);
                mediump mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
                #define gl_LastFragData (getFragData())
            #endif 
        #endif 
    #elif defined(sc_EnableFeatureLevelES2) 
        #define sc_FragData0 gl_FragColor
        mediump mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
    #else
        #define sc_FragData0 gl_FragColor
        mediump mat4 getFragData() { return mat4(vec4(0.0),vec4(0.0),vec4(0.0),vec4(0.0)); }
    #endif 
#endif 
#if __VERSION__>100
    #define SC_INT_FALLBACK_FLOAT int
    #define SC_INTERPOLATION_FLAT flat
    #define SC_INTERPOLATION_CENTROID centroid
#else
    #define SC_INT_FALLBACK_FLOAT float
    #define SC_INTERPOLATION_FLAT
    #define SC_INTERPOLATION_CENTROID
#endif

#ifndef sc_NumStereoViews
    #define sc_NumStereoViews 1
#endif

#ifndef sc_CanUseSampler2DArray
    #define sc_CanUseSampler2DArray 0
#endif




//SG_REFLECTION_BEGIN
//SG_REFLECTION_END

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
