#pragma once
#if defined VERTEX_SHADER
#include <std2.glsl>


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END




#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
    #if sc_StereoRenderingMode==sc_StereoRendering_InstancedClipped&&!sc_StereoRendering_IsClipDistanceEnabled
        
        #define sc_StereoFragmentMain main
        #define sc_MainInjector MAIN(); void sc_MainInjected
    #else
        
        #define MAIN sc_MainInjector
    #endif

#include <std2.glsl>


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END

#ifndef sc_UseFramebufferFetchMarker
#define sc_UseFramebufferFetchMarker 0
#elif sc_UseFramebufferFetchMarker==1
#undef sc_UseFramebufferFetchMarker
#define sc_UseFramebufferFetchMarker 1
#endif
#ifndef sc_GetFramebufferColorInvalidUsageMarker
#define sc_GetFramebufferColorInvalidUsageMarker 0
#elif sc_GetFramebufferColorInvalidUsageMarker==1
#undef sc_GetFramebufferColorInvalidUsageMarker
#define sc_GetFramebufferColorInvalidUsageMarker 1
#endif
#ifndef sc_FragDataCount
#define sc_FragDataCount 0
#endif



void sc_writeFragData0(vec4 col)
{
    sc_FragData0=col;

}

void sc_writeFragData1(vec4 col)
{
#if sc_FragDataCount>1
    sc_FragData1=col;
#endif

}

void sc_writeFragData2(vec4 col)
{
#if sc_FragDataCount>2
    sc_FragData2=col;
#endif

}

void sc_writeFragData3(vec4 col)
{
#if sc_FragDataCount>3
    sc_FragData3=col;
#endif

}

vec4 sc_readFragData0_Platform()
{
    return getFragData()[0];

}

vec4 sc_readFragData1_Platform()
{
    return getFragData()[1];

}

vec4 sc_readFragData2_Platform()
{
    return getFragData()[2];

}

vec4 sc_readFragData3_Platform()
{
    return getFragData()[3];

}

vec4 sc_readFragData0()
{
vec4 result=sc_readFragData0_Platform();
#if (sc_UseFramebufferFetchMarker)
{
result.x+=_sc_framebufferFetchMarker;
}
#endif
return result;
}

vec4 sc_readFragData1()
{
vec4 result=sc_readFragData1_Platform();
#if (sc_UseFramebufferFetchMarker)
{
result.x+=_sc_framebufferFetchMarker;
}
#endif
return result;
}

vec4 sc_readFragData2()
{
vec4 result=sc_readFragData2_Platform();
#if (sc_UseFramebufferFetchMarker)
{
result.x+=_sc_framebufferFetchMarker;
}
#endif
return result;
}

vec4 sc_readFragData3()
{
vec4 result=sc_readFragData3_Platform();
#if (sc_UseFramebufferFetchMarker)
{
result.x+=_sc_framebufferFetchMarker;
}
#endif
return result;
}

vec2 sc_GetGlobalScreenCoords()
{
return (gl_FragCoord.xy*sc_WindowToViewportTransform.xy)+sc_WindowToViewportTransform.zw;
}

vec2 sc_GetViewScreenCoords()
{
vec2 param=sc_GetGlobalScreenCoords();
return sc_ScreenCoordsGlobalToView(param);
}

vec2 getScreenUV()
{
return sc_GetViewScreenCoords();
}

vec4 sc_GetFramebufferColor()
{
vec4 result;
#if (sc_FramebufferFetch)
{
result=sc_readFragData0();
}
#else
{
vec2 param=sc_GetViewScreenCoords();
result=sc_ScreenTextureSampleView(param);
}
#endif
#if (((sc_IsEditor&&sc_GetFramebufferColorInvalidUsageMarker)&&(!sc_BlendMode_Software))&&(!sc_BlendMode_ColoredGlass))
{
result.x+=_sc_GetFramebufferColorInvalidUsageMarker;
}
#endif
return result;
}

vec4 getFramebufferColor()
{
return sc_GetFramebufferColor();
}

vec4 sc_ApplyBlendModeModifications(vec4 color)
{
#if (sc_BlendMode_MultiplyOriginal)
{
return vec4(mix(vec3(1.0),color.xyz,vec3(color.w)),color.w);
}
#else
{
#if (sc_BlendMode_Screen||sc_BlendMode_PremultipliedAlphaHardware)
{
return vec4(color.xyz*color.w,color.w);
}
#else
{
return color;
}
#endif
}
#endif
}

void sc_DiscardStereoFragment()
{
#if ((sc_StereoRenderingMode==1)&&(sc_StereoRendering_IsClipDistanceEnabled==1))
{
if (varClipDistance<0.0)
{
discard;
}
}
#endif
}

vec4 getPixelRenderingCost()
{
#if (sc_ShaderComplexityAnalyzer)
{
return vec4(shaderComplexityValue/255.0,0.0,0.0,1.0);
}
#else
{
return vec4(0.0);
}
#endif
}

void sc_MainInjector()
{
}

void sc_CallLensFragmentMain()
{
    #if sc_StereoRenderingMode==sc_StereoRendering_InstancedClipped&&!sc_StereoRendering_IsClipDistanceEnabled
        MAIN();
    #endif

}

void sc_StereoFragmentMain()
{
sc_DiscardStereoFragment();
sc_CallLensFragmentMain();
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
