#pragma once
#if defined VERTEX_SHADER
#include <std2.glsl>


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END



varying vec2 varShadowTex;

vec2 getProjectedTexCoords(vec4 vertexPosition)
{
vec4 worldPos=vertexPosition;
#if (sc_RenderingSpace==1)
{
worldPos=sc_ModelMatrix*vertexPosition;
}
#endif
vec4 projectedUVs=sc_ProjectorMatrix*worldPos;
return ((projectedUVs.xy/vec2(projectedUVs.w))*0.5)+vec2(0.5);
}

#elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
#include <std2.glsl>


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END



varying vec2 varShadowTex;

float getShadowAlpha(vec4 color)
{
float shadowAlpha=1.0;
#if ((sc_BlendMode_Normal||sc_BlendMode_AlphaToCoverage)||sc_BlendMode_PremultipliedAlphaHardware)
{
shadowAlpha=color.w;
}
#else
{
#if (sc_BlendMode_PremultipliedAlpha)
{
shadowAlpha=clamp(color.w*2.0,0.0,1.0);
}
#else
{
#if (sc_BlendMode_AddWithAlphaFactor)
{
shadowAlpha=clamp(dot(color.xyz,vec3(color.w)),0.0,1.0);
}
#else
{
#if (sc_BlendMode_AlphaTest)
{
shadowAlpha=1.0;
}
#else
{
#if (sc_BlendMode_Multiply)
{
shadowAlpha=(1.0-dot(color.xyz,vec3(0.33333)))*color.w;
}
#else
{
#if (sc_BlendMode_MultiplyOriginal)
{
shadowAlpha=(1.0-clamp(dot(color.xyz,vec3(1.0)),0.0,1.0))*color.w;
}
#else
{
#if (sc_BlendMode_ColoredGlass)
{
shadowAlpha=clamp(dot(color.xyz,vec3(1.0)),0.0,1.0)*color.w;
}
#else
{
#if (sc_BlendMode_Add)
{
shadowAlpha=clamp(dot(color.xyz,vec3(1.0)),0.0,1.0);
}
#else
{
#if (sc_BlendMode_AddWithAlphaFactor)
{
shadowAlpha=clamp(dot(color.xyz,vec3(1.0)),0.0,1.0)*color.w;
}
#else
{
#if (sc_BlendMode_Screen)
{
shadowAlpha=dot(color.xyz,vec3(0.33333))*color.w;
}
#else
{
#if (sc_BlendMode_Min)
{
shadowAlpha=1.0-clamp(dot(color.xyz,vec3(1.0)),0.0,1.0);
}
#else
{
#if (sc_BlendMode_Max)
{
shadowAlpha=clamp(dot(color.xyz,vec3(1.0)),0.0,1.0);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
return shadowAlpha;
}

vec4 evaluateShadowCasterColor(vec4 shadowCasterColor)
{
vec4 param=shadowCasterColor;
float alpha=getShadowAlpha(param);
float shadowTerm=sc_ShadowDensity*alpha;
vec3 shadowColor=mix(sc_ShadowColor.xyz,sc_ShadowColor.xyz*shadowCasterColor.xyz,vec3(sc_ShadowColor.w));
return vec4(shadowColor.x,shadowColor.y,shadowColor.z,shadowTerm);
}

float getShadowTexClipFactor()
{
vec2 uv=abs(varShadowTex-vec2(0.5));
float clipFactor=max(uv.x,uv.y);
return step(clipFactor,0.5);
}

vec3 evaluateShadow()
{
vec2 param=varShadowTex;
vec4 shadowSample=sc_ShadowTextureSampleView(param)*getShadowTexClipFactor();
vec3 shadowColor=mix(sc_ShadowColor.xyz,sc_ShadowColor.xyz*shadowSample.xyz,vec3(sc_ShadowColor.w));
float shadowDensity=shadowSample.w*sc_ShadowDensity;
return mix(vec3(1.0),shadowColor,vec3(shadowDensity));
}

#endif // #elif defined FRAGMENT_SHADER // #if defined VERTEX_SHADER
