#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:552 {
//float4 inputTextureSize:0
//float4 inputTextureDims:16
//float4 inputTextureDimsRecip:32
//float4 inputTextureView:48
//float3x3 inputTextureTransform:64
//float4 inputTextureUvMinMax:112
//float4 inputTextureBorderColor:128
//float4 maskTextureSize:144
//float4 maskTextureDims:160
//float4 maskTextureDimsRecip:176
//float4 maskTextureView:192
//float3x3 maskTextureTransform:208
//float4 maskTextureUvMinMax:256
//float4 maskTextureBorderColor:272
//float4 backTextureSize:288
//float4 backTextureDims:304
//float4 backTextureDimsRecip:320
//float4 backTextureView:336
//float3x3 backTextureTransform:352
//float4 backTextureUvMinMax:400
//float4 backTextureBorderColor:416
//float3x3 maskTransform:432
//float3x3 backTransform:480
//float4 backColorMult:528
//float2 inputTextureScale:544
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureDimsRecip;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureDimsRecip;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float4 backTextureSize;
float4 backTextureDims;
float4 backTextureDimsRecip;
float4 backTextureView;
float3x3 backTextureTransform;
float4 backTextureUvMinMax;
float4 backTextureBorderColor;
float3x3 maskTransform;
float3x3 backTransform;
float4 backColorMult;
float2 inputTextureScale;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef backTextureHasSwappedViews
#define backTextureHasSwappedViews 0
#elif backTextureHasSwappedViews==1
#undef backTextureHasSwappedViews
#define backTextureHasSwappedViews 1
#endif
#ifndef backTextureLayout
#define backTextureLayout 0
#endif
#ifndef FXAA
#define FXAA 0
#elif FXAA==1
#undef FXAA
#define FXAA 1
#endif
#ifndef MASK
#define MASK 0
#elif MASK==1
#undef MASK
#define MASK 1
#endif
#ifndef MASK_CHANNEL
#define MASK_CHANNEL 0
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
#ifndef backTextureUV
#define backTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 0
#elif SC_USE_UV_TRANSFORM_backTexture==1
#undef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_backTexture
#define SC_SOFTWARE_WRAP_MODE_U_backTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backTexture
#define SC_SOFTWARE_WRAP_MODE_V_backTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 0
#elif SC_USE_UV_MIN_MAX_backTexture==1
#undef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varTexMaskAndBack [[user(locn10)]];
float4 varTex12 [[user(locn11)]];
float4 varTex34 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float3 origTex0=float3(v.texture0,1.0);
v.texture0=float2((userUniformsObj.inputTextureTransform*origTex0).xy);
#if (FXAA)
{
float2 _2681=v.texture0+(float2(-1.0)*userUniformsObj.inputTextureScale);
out.varTex12=float4(_2681.x,_2681.y,out.varTex12.z,out.varTex12.w);
float2 _2690=v.texture0+(float2(1.0,-1.0)*userUniformsObj.inputTextureScale);
out.varTex12=float4(out.varTex12.x,out.varTex12.y,_2690.x,_2690.y);
float2 _2700=v.texture0+(float2(-1.0,1.0)*userUniformsObj.inputTextureScale);
out.varTex34=float4(_2700.x,_2700.y,out.varTex34.z,out.varTex34.w);
float2 _2709=v.texture0+(float2(1.0)*userUniformsObj.inputTextureScale);
out.varTex34=float4(out.varTex34.x,out.varTex34.y,_2709.x,_2709.y);
}
#endif
#if (MASK)
{
float2 _2722=float2((userUniformsObj.maskTransform*origTex0).xy);
out.varTexMaskAndBack=float4(_2722.x,_2722.y,out.varTexMaskAndBack.z,out.varTexMaskAndBack.w);
float2 _2731=float2((userUniformsObj.backTransform*origTex0).xy);
out.varTexMaskAndBack=float4(out.varTexMaskAndBack.x,out.varTexMaskAndBack.y,_2731.x,_2731.y);
}
#endif
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:552 {
//float4 inputTextureSize:0
//float4 inputTextureDims:16
//float4 inputTextureDimsRecip:32
//float4 inputTextureView:48
//float3x3 inputTextureTransform:64
//float4 inputTextureUvMinMax:112
//float4 inputTextureBorderColor:128
//float4 maskTextureSize:144
//float4 maskTextureDims:160
//float4 maskTextureDimsRecip:176
//float4 maskTextureView:192
//float3x3 maskTextureTransform:208
//float4 maskTextureUvMinMax:256
//float4 maskTextureBorderColor:272
//float4 backTextureSize:288
//float4 backTextureDims:304
//float4 backTextureDimsRecip:320
//float4 backTextureView:336
//float3x3 backTextureTransform:352
//float4 backTextureUvMinMax:400
//float4 backTextureBorderColor:416
//float3x3 maskTransform:432
//float3x3 backTransform:480
//float4 backColorMult:528
//float2 inputTextureScale:544
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureDimsRecip;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureDimsRecip;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float4 backTextureSize;
float4 backTextureDims;
float4 backTextureDimsRecip;
float4 backTextureView;
float3x3 backTextureTransform;
float4 backTextureUvMinMax;
float4 backTextureBorderColor;
float3x3 maskTransform;
float3x3 backTransform;
float4 backColorMult;
float2 inputTextureScale;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef backTextureHasSwappedViews
#define backTextureHasSwappedViews 0
#elif backTextureHasSwappedViews==1
#undef backTextureHasSwappedViews
#define backTextureHasSwappedViews 1
#endif
#ifndef backTextureLayout
#define backTextureLayout 0
#endif
#ifndef FXAA
#define FXAA 0
#elif FXAA==1
#undef FXAA
#define FXAA 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _2458=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
constant int2 _2485=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2514=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2537=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2567=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2590=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2619=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2642=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2672=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2695=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2837=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2865=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2898=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2926=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2958=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2984=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _3015=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _3041=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _3093=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _3116=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef MASK
#define MASK 0
#elif MASK==1
#undef MASK
#define MASK 1
#endif
#ifndef MASK_CHANNEL
#define MASK_CHANNEL 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
constant int2 _3154=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
constant int2 _3181=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
constant int2 _3213=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
constant int2 _3236=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
constant int2 _3267=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
constant int2 _3290=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_SOFTWARE_WRAP_MODE_U_backTexture
#define SC_SOFTWARE_WRAP_MODE_U_backTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backTexture
#define SC_SOFTWARE_WRAP_MODE_V_backTexture -1
#endif
constant int2 _3320=int2(SC_SOFTWARE_WRAP_MODE_U_backTexture,SC_SOFTWARE_WRAP_MODE_V_backTexture);
#ifndef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 0
#elif SC_USE_UV_MIN_MAX_backTexture==1
#undef SC_USE_UV_MIN_MAX_backTexture
#define SC_USE_UV_MIN_MAX_backTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backTexture
#define SC_USE_CLAMP_TO_BORDER_backTexture 1
#endif
constant int2 _3347=int2(SC_SOFTWARE_WRAP_MODE_U_backTexture,SC_SOFTWARE_WRAP_MODE_V_backTexture);
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef backTextureUV
#define backTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 0
#elif SC_USE_UV_TRANSFORM_backTexture==1
#undef SC_USE_UV_TRANSFORM_backTexture
#define SC_USE_UV_TRANSFORM_backTexture 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varTexMaskAndBack [[user(locn10)]];
float4 varTex12 [[user(locn11)]];
float4 varTex34 [[user(locn12)]];
};

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 maskTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.maskTextureDims.xy;
}

int maskTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (maskTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 backTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.backTextureDims.xy;
}

int backTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (backTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> inputTexture [[texture(0)]],texture2d_array<float> inputTextureArrSC [[texture(1)]],texture2d<float> maskTexture [[texture(2)]],texture2d_array<float> maskTextureArrSC [[texture(3)]],texture2d<float> backTexture [[texture(4)]],texture2d_array<float> backTextureArrSC [[texture(5)]],sampler inputTextureSmplr [[sampler(0)]],sampler inputTextureArrSCSmplr [[sampler(1)]],sampler maskTextureSmplr [[sampler(2)]],sampler maskTextureArrSCSmplr [[sampler(3)]],sampler backTextureSmplr [[sampler(4)]],sampler backTextureArrSCSmplr [[sampler(5)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 result=float4(0.0);
#if (FXAA)
{
float FXAA_SPAN_MAX=8.0;
float FXAA_REDUCE_MUL=0.125;
float FXAA_REDUCE_MIN=0.0078125;
float4 inputTextureSample;
#if (inputTextureLayout==2)
{
float2 param=inputTextureGetDims2D(userUniformsObj);
int param_1=inputTextureLayout;
int param_2=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varTex12.xy;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_2458;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_8=userUniformsObj.inputTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_10=userUniformsObj.inputTextureBorderColor;
float param_11=0.0;
inputTextureSample=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=inputTextureGetDims2D(userUniformsObj);
int param_13=inputTextureLayout;
int param_14=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varTex12.xy;
bool param_16=false;
float3x3 param_17=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_18=_2485;
bool param_19=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_20=userUniformsObj.inputTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_22=userUniformsObj.inputTextureBorderColor;
float param_23=0.0;
inputTextureSample=sc_SampleTexture(inputTexture,inputTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float3 rgbNW=inputTextureSample.xyz;
float4 inputTextureSample_1;
#if (inputTextureLayout==2)
{
float2 param_24=inputTextureGetDims2D(userUniformsObj);
int param_25=inputTextureLayout;
int param_26=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varTex12.zw;
bool param_28=false;
float3x3 param_29=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_30=_2514;
bool param_31=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_32=userUniformsObj.inputTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_34=userUniformsObj.inputTextureBorderColor;
float param_35=0.0;
inputTextureSample_1=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=inputTextureGetDims2D(userUniformsObj);
int param_37=inputTextureLayout;
int param_38=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varTex12.zw;
bool param_40=false;
float3x3 param_41=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_42=_2537;
bool param_43=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_44=userUniformsObj.inputTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_46=userUniformsObj.inputTextureBorderColor;
float param_47=0.0;
inputTextureSample_1=sc_SampleTexture(inputTexture,inputTextureSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
float3 rgbNE=inputTextureSample_1.xyz;
float4 inputTextureSample_2;
#if (inputTextureLayout==2)
{
float2 param_48=inputTextureGetDims2D(userUniformsObj);
int param_49=inputTextureLayout;
int param_50=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_51=in.varTex34.xy;
bool param_52=false;
float3x3 param_53=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_54=_2567;
bool param_55=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_56=userUniformsObj.inputTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_58=userUniformsObj.inputTextureBorderColor;
float param_59=0.0;
inputTextureSample_2=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
}
#else
{
float2 param_60=inputTextureGetDims2D(userUniformsObj);
int param_61=inputTextureLayout;
int param_62=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_63=in.varTex34.xy;
bool param_64=false;
float3x3 param_65=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_66=_2590;
bool param_67=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_68=userUniformsObj.inputTextureUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_70=userUniformsObj.inputTextureBorderColor;
float param_71=0.0;
inputTextureSample_2=sc_SampleTexture(inputTexture,inputTextureSmplr,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
}
#endif
float3 rgbSW=inputTextureSample_2.xyz;
float4 inputTextureSample_3;
#if (inputTextureLayout==2)
{
float2 param_72=inputTextureGetDims2D(userUniformsObj);
int param_73=inputTextureLayout;
int param_74=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_75=in.varTex34.zw;
bool param_76=false;
float3x3 param_77=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_78=_2619;
bool param_79=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_80=userUniformsObj.inputTextureUvMinMax;
bool param_81=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_82=userUniformsObj.inputTextureBorderColor;
float param_83=0.0;
inputTextureSample_3=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83);
}
#else
{
float2 param_84=inputTextureGetDims2D(userUniformsObj);
int param_85=inputTextureLayout;
int param_86=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_87=in.varTex34.zw;
bool param_88=false;
float3x3 param_89=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_90=_2642;
bool param_91=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_92=userUniformsObj.inputTextureUvMinMax;
bool param_93=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_94=userUniformsObj.inputTextureBorderColor;
float param_95=0.0;
inputTextureSample_3=sc_SampleTexture(inputTexture,inputTextureSmplr,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95);
}
#endif
float3 rgbSE=inputTextureSample_3.xyz;
float4 inputTextureSample_4;
#if (inputTextureLayout==2)
{
float2 param_96=inputTextureGetDims2D(userUniformsObj);
int param_97=inputTextureLayout;
int param_98=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_99=in.varPackedTex.xy;
bool param_100=false;
float3x3 param_101=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_102=_2672;
bool param_103=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_104=userUniformsObj.inputTextureUvMinMax;
bool param_105=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_106=userUniformsObj.inputTextureBorderColor;
float param_107=0.0;
inputTextureSample_4=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106,param_107);
}
#else
{
float2 param_108=inputTextureGetDims2D(userUniformsObj);
int param_109=inputTextureLayout;
int param_110=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_111=in.varPackedTex.xy;
bool param_112=false;
float3x3 param_113=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_114=_2695;
bool param_115=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_116=userUniformsObj.inputTextureUvMinMax;
bool param_117=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_118=userUniformsObj.inputTextureBorderColor;
float param_119=0.0;
inputTextureSample_4=sc_SampleTexture(inputTexture,inputTextureSmplr,param_108,param_109,param_110,param_111,param_112,param_113,param_114,param_115,param_116,param_117,param_118,param_119);
}
#endif
float3 rgbM=inputTextureSample_4.xyz;
float3 luma=float3(0.299,0.587,0.114);
float lumaNW=dot(rgbNW,luma);
float lumaNE=dot(rgbNE,luma);
float lumaSW=dot(rgbSW,luma);
float lumaSE=dot(rgbSE,luma);
float lumaM=dot(rgbM,luma);
float lumaMin=fast::min(lumaM,fast::min(fast::min(lumaNW,lumaNE),fast::min(lumaSW,lumaSE)));
float lumaMax=fast::max(lumaM,fast::max(fast::max(lumaNW,lumaNE),fast::max(lumaSW,lumaSE)));
float2 dir;
dir.x=-((lumaNW+lumaNE)-(lumaSW+lumaSE));
dir.y=(lumaNW+lumaSW)-(lumaNE+lumaSE);
float dirReduce=fast::max((((lumaNW+lumaNE)+lumaSW)+lumaSE)*(0.25*FXAA_REDUCE_MUL),FXAA_REDUCE_MIN);
float rcpDirMin=1.0/(fast::min(abs(dir.x),abs(dir.y))+dirReduce);
dir=fast::min(float2(FXAA_SPAN_MAX,FXAA_SPAN_MAX),fast::max(float2(-FXAA_SPAN_MAX,-FXAA_SPAN_MAX),dir*rcpDirMin))*userUniformsObj.inputTextureScale;
float4 inputTextureSample_5;
#if (inputTextureLayout==2)
{
float2 param_120=inputTextureGetDims2D(userUniformsObj);
int param_121=inputTextureLayout;
int param_122=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_123=in.varPackedTex.xy-((dir*1.0)/float2(6.0));
bool param_124=false;
float3x3 param_125=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_126=_2837;
bool param_127=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_128=userUniformsObj.inputTextureUvMinMax;
bool param_129=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_130=userUniformsObj.inputTextureBorderColor;
float param_131=0.0;
inputTextureSample_5=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_120,param_121,param_122,param_123,param_124,param_125,param_126,param_127,param_128,param_129,param_130,param_131);
}
#else
{
float2 param_132=inputTextureGetDims2D(userUniformsObj);
int param_133=inputTextureLayout;
int param_134=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_135=in.varPackedTex.xy-((dir*1.0)/float2(6.0));
bool param_136=false;
float3x3 param_137=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_138=_2865;
bool param_139=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_140=userUniformsObj.inputTextureUvMinMax;
bool param_141=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_142=userUniformsObj.inputTextureBorderColor;
float param_143=0.0;
inputTextureSample_5=sc_SampleTexture(inputTexture,inputTextureSmplr,param_132,param_133,param_134,param_135,param_136,param_137,param_138,param_139,param_140,param_141,param_142,param_143);
}
#endif
float4 colorA=inputTextureSample_5;
float4 inputTextureSample_6;
#if (inputTextureLayout==2)
{
float2 param_144=inputTextureGetDims2D(userUniformsObj);
int param_145=inputTextureLayout;
int param_146=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_147=in.varPackedTex.xy+((dir*1.0)/float2(6.0));
bool param_148=false;
float3x3 param_149=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_150=_2898;
bool param_151=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_152=userUniformsObj.inputTextureUvMinMax;
bool param_153=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_154=userUniformsObj.inputTextureBorderColor;
float param_155=0.0;
inputTextureSample_6=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_144,param_145,param_146,param_147,param_148,param_149,param_150,param_151,param_152,param_153,param_154,param_155);
}
#else
{
float2 param_156=inputTextureGetDims2D(userUniformsObj);
int param_157=inputTextureLayout;
int param_158=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_159=in.varPackedTex.xy+((dir*1.0)/float2(6.0));
bool param_160=false;
float3x3 param_161=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_162=_2926;
bool param_163=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_164=userUniformsObj.inputTextureUvMinMax;
bool param_165=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_166=userUniformsObj.inputTextureBorderColor;
float param_167=0.0;
inputTextureSample_6=sc_SampleTexture(inputTexture,inputTextureSmplr,param_156,param_157,param_158,param_159,param_160,param_161,param_162,param_163,param_164,param_165,param_166,param_167);
}
#endif
colorA+=inputTextureSample_6;
float4 inputTextureSample_7;
#if (inputTextureLayout==2)
{
float2 param_168=inputTextureGetDims2D(userUniformsObj);
int param_169=inputTextureLayout;
int param_170=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_171=in.varPackedTex.xy-(dir*0.5);
bool param_172=false;
float3x3 param_173=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_174=_2958;
bool param_175=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_176=userUniformsObj.inputTextureUvMinMax;
bool param_177=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_178=userUniformsObj.inputTextureBorderColor;
float param_179=0.0;
inputTextureSample_7=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_168,param_169,param_170,param_171,param_172,param_173,param_174,param_175,param_176,param_177,param_178,param_179);
}
#else
{
float2 param_180=inputTextureGetDims2D(userUniformsObj);
int param_181=inputTextureLayout;
int param_182=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_183=in.varPackedTex.xy-(dir*0.5);
bool param_184=false;
float3x3 param_185=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_186=_2984;
bool param_187=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_188=userUniformsObj.inputTextureUvMinMax;
bool param_189=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_190=userUniformsObj.inputTextureBorderColor;
float param_191=0.0;
inputTextureSample_7=sc_SampleTexture(inputTexture,inputTextureSmplr,param_180,param_181,param_182,param_183,param_184,param_185,param_186,param_187,param_188,param_189,param_190,param_191);
}
#endif
float4 colorB=inputTextureSample_7;
float4 inputTextureSample_8;
#if (inputTextureLayout==2)
{
float2 param_192=inputTextureGetDims2D(userUniformsObj);
int param_193=inputTextureLayout;
int param_194=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_195=in.varPackedTex.xy+(dir*0.5);
bool param_196=false;
float3x3 param_197=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_198=_3015;
bool param_199=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_200=userUniformsObj.inputTextureUvMinMax;
bool param_201=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_202=userUniformsObj.inputTextureBorderColor;
float param_203=0.0;
inputTextureSample_8=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_192,param_193,param_194,param_195,param_196,param_197,param_198,param_199,param_200,param_201,param_202,param_203);
}
#else
{
float2 param_204=inputTextureGetDims2D(userUniformsObj);
int param_205=inputTextureLayout;
int param_206=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_207=in.varPackedTex.xy+(dir*0.5);
bool param_208=false;
float3x3 param_209=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_210=_3041;
bool param_211=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_212=userUniformsObj.inputTextureUvMinMax;
bool param_213=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_214=userUniformsObj.inputTextureBorderColor;
float param_215=0.0;
inputTextureSample_8=sc_SampleTexture(inputTexture,inputTextureSmplr,param_204,param_205,param_206,param_207,param_208,param_209,param_210,param_211,param_212,param_213,param_214,param_215);
}
#endif
colorB+=inputTextureSample_8;
colorA*=0.5;
colorB=(colorA*0.5)+(colorB*0.25);
float lumaB=dot(colorB.xyz,luma);
if ((lumaB<lumaMin)||(lumaB>lumaMax))
{
result=colorA;
}
else
{
result=colorB;
}
}
#else
{
float4 inputTextureSample_9;
#if (inputTextureLayout==2)
{
float2 param_216=inputTextureGetDims2D(userUniformsObj);
int param_217=inputTextureLayout;
int param_218=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_219=in.varPackedTex.xy;
bool param_220=false;
float3x3 param_221=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_222=_3093;
bool param_223=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_224=userUniformsObj.inputTextureUvMinMax;
bool param_225=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_226=userUniformsObj.inputTextureBorderColor;
float param_227=0.0;
inputTextureSample_9=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_216,param_217,param_218,param_219,param_220,param_221,param_222,param_223,param_224,param_225,param_226,param_227);
}
#else
{
float2 param_228=inputTextureGetDims2D(userUniformsObj);
int param_229=inputTextureLayout;
int param_230=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_231=in.varPackedTex.xy;
bool param_232=false;
float3x3 param_233=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_234=_3116;
bool param_235=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_236=userUniformsObj.inputTextureUvMinMax;
bool param_237=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_238=userUniformsObj.inputTextureBorderColor;
float param_239=0.0;
inputTextureSample_9=sc_SampleTexture(inputTexture,inputTextureSmplr,param_228,param_229,param_230,param_231,param_232,param_233,param_234,param_235,param_236,param_237,param_238,param_239);
}
#endif
result=inputTextureSample_9;
}
#endif
#if (MASK)
{
float4 mask=float4(0.0);
#if (MASK_CHANNEL==0)
{
float4 maskTextureSample;
#if (maskTextureLayout==2)
{
float2 param_240=maskTextureGetDims2D(userUniformsObj);
int param_241=maskTextureLayout;
int param_242=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_243=in.varTexMaskAndBack.xy;
bool param_244=false;
float3x3 param_245=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_246=_3154;
bool param_247=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_248=userUniformsObj.maskTextureUvMinMax;
bool param_249=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_250=userUniformsObj.maskTextureBorderColor;
float param_251=0.0;
maskTextureSample=sc_SampleTexture(maskTextureArrSC,maskTextureArrSCSmplr,param_240,param_241,param_242,param_243,param_244,param_245,param_246,param_247,param_248,param_249,param_250,param_251);
}
#else
{
float2 param_252=maskTextureGetDims2D(userUniformsObj);
int param_253=maskTextureLayout;
int param_254=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_255=in.varTexMaskAndBack.xy;
bool param_256=false;
float3x3 param_257=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_258=_3181;
bool param_259=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_260=userUniformsObj.maskTextureUvMinMax;
bool param_261=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_262=userUniformsObj.maskTextureBorderColor;
float param_263=0.0;
maskTextureSample=sc_SampleTexture(maskTexture,maskTextureSmplr,param_252,param_253,param_254,param_255,param_256,param_257,param_258,param_259,param_260,param_261,param_262,param_263);
}
#endif
mask=maskTextureSample.xxxx;
}
#else
{
#if (MASK_CHANNEL==1)
{
float4 maskTextureSample_1;
#if (maskTextureLayout==2)
{
float2 param_264=maskTextureGetDims2D(userUniformsObj);
int param_265=maskTextureLayout;
int param_266=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_267=in.varTexMaskAndBack.xy;
bool param_268=false;
float3x3 param_269=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_270=_3213;
bool param_271=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_272=userUniformsObj.maskTextureUvMinMax;
bool param_273=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_274=userUniformsObj.maskTextureBorderColor;
float param_275=0.0;
maskTextureSample_1=sc_SampleTexture(maskTextureArrSC,maskTextureArrSCSmplr,param_264,param_265,param_266,param_267,param_268,param_269,param_270,param_271,param_272,param_273,param_274,param_275);
}
#else
{
float2 param_276=maskTextureGetDims2D(userUniformsObj);
int param_277=maskTextureLayout;
int param_278=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_279=in.varTexMaskAndBack.xy;
bool param_280=false;
float3x3 param_281=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_282=_3236;
bool param_283=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_284=userUniformsObj.maskTextureUvMinMax;
bool param_285=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_286=userUniformsObj.maskTextureBorderColor;
float param_287=0.0;
maskTextureSample_1=sc_SampleTexture(maskTexture,maskTextureSmplr,param_276,param_277,param_278,param_279,param_280,param_281,param_282,param_283,param_284,param_285,param_286,param_287);
}
#endif
mask=maskTextureSample_1;
}
#else
{
#if (MASK_CHANNEL==2)
{
float4 maskTextureSample_2;
#if (maskTextureLayout==2)
{
float2 param_288=maskTextureGetDims2D(userUniformsObj);
int param_289=maskTextureLayout;
int param_290=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_291=in.varTexMaskAndBack.xy;
bool param_292=false;
float3x3 param_293=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_294=_3267;
bool param_295=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_296=userUniformsObj.maskTextureUvMinMax;
bool param_297=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_298=userUniformsObj.maskTextureBorderColor;
float param_299=0.0;
maskTextureSample_2=sc_SampleTexture(maskTextureArrSC,maskTextureArrSCSmplr,param_288,param_289,param_290,param_291,param_292,param_293,param_294,param_295,param_296,param_297,param_298,param_299);
}
#else
{
float2 param_300=maskTextureGetDims2D(userUniformsObj);
int param_301=maskTextureLayout;
int param_302=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_303=in.varTexMaskAndBack.xy;
bool param_304=false;
float3x3 param_305=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_306=_3290;
bool param_307=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_308=userUniformsObj.maskTextureUvMinMax;
bool param_309=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_310=userUniformsObj.maskTextureBorderColor;
float param_311=0.0;
maskTextureSample_2=sc_SampleTexture(maskTexture,maskTextureSmplr,param_300,param_301,param_302,param_303,param_304,param_305,param_306,param_307,param_308,param_309,param_310,param_311);
}
#endif
mask=maskTextureSample_2.wwww;
}
#endif
}
#endif
}
#endif
float4 backTextureSample;
#if (backTextureLayout==2)
{
float2 param_312=backTextureGetDims2D(userUniformsObj);
int param_313=backTextureLayout;
int param_314=backTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_315=in.varTexMaskAndBack.zw;
bool param_316=false;
float3x3 param_317=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_318=_3320;
bool param_319=(int(SC_USE_UV_MIN_MAX_backTexture)!=0);
float4 param_320=userUniformsObj.backTextureUvMinMax;
bool param_321=(int(SC_USE_CLAMP_TO_BORDER_backTexture)!=0);
float4 param_322=userUniformsObj.backTextureBorderColor;
float param_323=0.0;
backTextureSample=sc_SampleTexture(backTextureArrSC,backTextureArrSCSmplr,param_312,param_313,param_314,param_315,param_316,param_317,param_318,param_319,param_320,param_321,param_322,param_323);
}
#else
{
float2 param_324=backTextureGetDims2D(userUniformsObj);
int param_325=backTextureLayout;
int param_326=backTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_327=in.varTexMaskAndBack.zw;
bool param_328=false;
float3x3 param_329=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_330=_3347;
bool param_331=(int(SC_USE_UV_MIN_MAX_backTexture)!=0);
float4 param_332=userUniformsObj.backTextureUvMinMax;
bool param_333=(int(SC_USE_CLAMP_TO_BORDER_backTexture)!=0);
float4 param_334=userUniformsObj.backTextureBorderColor;
float param_335=0.0;
backTextureSample=sc_SampleTexture(backTexture,backTextureSmplr,param_324,param_325,param_326,param_327,param_328,param_329,param_330,param_331,param_332,param_333,param_334,param_335);
}
#endif
float4 back=backTextureSample*userUniformsObj.backColorMult;
result=mix(back,result,mask);
}
#endif
float4 param_336=result;
sc_writeFragData0(param_336,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
