#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:288 {
//float4 yTextureSize:0
//float4 yTextureDims:16
//float4 yTextureDimsRecip:32
//float4 yTextureView:48
//float3x3 yTextureTransform:64
//float4 yTextureUvMinMax:112
//float4 yTextureBorderColor:128
//float4 uvTextureSize:144
//float4 uvTextureDims:160
//float4 uvTextureDimsRecip:176
//float4 uvTextureView:192
//float3x3 uvTextureTransform:208
//float4 uvTextureUvMinMax:256
//float4 uvTextureBorderColor:272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 yTextureSize;
float4 yTextureDims;
float4 yTextureDimsRecip;
float4 yTextureView;
float3x3 yTextureTransform;
float4 yTextureUvMinMax;
float4 yTextureBorderColor;
float4 uvTextureSize;
float4 uvTextureDims;
float4 uvTextureDimsRecip;
float4 uvTextureView;
float3x3 uvTextureTransform;
float4 uvTextureUvMinMax;
float4 uvTextureBorderColor;
};

#ifndef yTextureHasSwappedViews
#define yTextureHasSwappedViews 0
#elif yTextureHasSwappedViews==1
#undef yTextureHasSwappedViews
#define yTextureHasSwappedViews 1
#endif
#ifndef yTextureLayout
#define yTextureLayout 0
#endif
#ifndef uvTextureHasSwappedViews
#define uvTextureHasSwappedViews 0
#elif uvTextureHasSwappedViews==1
#undef uvTextureHasSwappedViews
#define uvTextureHasSwappedViews 1
#endif
#ifndef uvTextureLayout
#define uvTextureLayout 0
#endif
#ifndef FORMAT_NV12
#define FORMAT_NV12 0
#elif FORMAT_NV12==1
#undef FORMAT_NV12
#define FORMAT_NV12 1
#endif
#ifndef FORMAT_NV21
#define FORMAT_NV21 0
#elif FORMAT_NV21==1
#undef FORMAT_NV21
#define FORMAT_NV21 1
#endif
#ifndef yTextureUV
#define yTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_yTexture
#define SC_USE_UV_TRANSFORM_yTexture 0
#elif SC_USE_UV_TRANSFORM_yTexture==1
#undef SC_USE_UV_TRANSFORM_yTexture
#define SC_USE_UV_TRANSFORM_yTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_yTexture
#define SC_SOFTWARE_WRAP_MODE_U_yTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_yTexture
#define SC_SOFTWARE_WRAP_MODE_V_yTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_yTexture
#define SC_USE_UV_MIN_MAX_yTexture 0
#elif SC_USE_UV_MIN_MAX_yTexture==1
#undef SC_USE_UV_MIN_MAX_yTexture
#define SC_USE_UV_MIN_MAX_yTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_yTexture
#define SC_USE_CLAMP_TO_BORDER_yTexture 0
#elif SC_USE_CLAMP_TO_BORDER_yTexture==1
#undef SC_USE_CLAMP_TO_BORDER_yTexture
#define SC_USE_CLAMP_TO_BORDER_yTexture 1
#endif
#ifndef uvTextureUV
#define uvTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_uvTexture
#define SC_USE_UV_TRANSFORM_uvTexture 0
#elif SC_USE_UV_TRANSFORM_uvTexture==1
#undef SC_USE_UV_TRANSFORM_uvTexture
#define SC_USE_UV_TRANSFORM_uvTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_uvTexture
#define SC_SOFTWARE_WRAP_MODE_U_uvTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_uvTexture
#define SC_SOFTWARE_WRAP_MODE_V_uvTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_uvTexture
#define SC_USE_UV_MIN_MAX_uvTexture 0
#elif SC_USE_UV_MIN_MAX_uvTexture==1
#undef SC_USE_UV_MIN_MAX_uvTexture
#define SC_USE_UV_MIN_MAX_uvTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_uvTexture
#define SC_USE_CLAMP_TO_BORDER_uvTexture 0
#elif SC_USE_CLAMP_TO_BORDER_uvTexture==1
#undef SC_USE_CLAMP_TO_BORDER_uvTexture
#define SC_USE_CLAMP_TO_BORDER_uvTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:288 {
//float4 yTextureSize:0
//float4 yTextureDims:16
//float4 yTextureDimsRecip:32
//float4 yTextureView:48
//float3x3 yTextureTransform:64
//float4 yTextureUvMinMax:112
//float4 yTextureBorderColor:128
//float4 uvTextureSize:144
//float4 uvTextureDims:160
//float4 uvTextureDimsRecip:176
//float4 uvTextureView:192
//float3x3 uvTextureTransform:208
//float4 uvTextureUvMinMax:256
//float4 uvTextureBorderColor:272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 yTextureSize;
float4 yTextureDims;
float4 yTextureDimsRecip;
float4 yTextureView;
float3x3 yTextureTransform;
float4 yTextureUvMinMax;
float4 yTextureBorderColor;
float4 uvTextureSize;
float4 uvTextureDims;
float4 uvTextureDimsRecip;
float4 uvTextureView;
float3x3 uvTextureTransform;
float4 uvTextureUvMinMax;
float4 uvTextureBorderColor;
};

#ifndef yTextureHasSwappedViews
#define yTextureHasSwappedViews 0
#elif yTextureHasSwappedViews==1
#undef yTextureHasSwappedViews
#define yTextureHasSwappedViews 1
#endif
#ifndef yTextureLayout
#define yTextureLayout 0
#endif
#ifndef uvTextureHasSwappedViews
#define uvTextureHasSwappedViews 0
#elif uvTextureHasSwappedViews==1
#undef uvTextureHasSwappedViews
#define uvTextureHasSwappedViews 1
#endif
#ifndef uvTextureLayout
#define uvTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_yTexture
#define SC_USE_UV_TRANSFORM_yTexture 0
#elif SC_USE_UV_TRANSFORM_yTexture==1
#undef SC_USE_UV_TRANSFORM_yTexture
#define SC_USE_UV_TRANSFORM_yTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_yTexture
#define SC_SOFTWARE_WRAP_MODE_U_yTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_yTexture
#define SC_SOFTWARE_WRAP_MODE_V_yTexture -1
#endif
constant int2 _2264=int2(SC_SOFTWARE_WRAP_MODE_U_yTexture,SC_SOFTWARE_WRAP_MODE_V_yTexture);
#ifndef SC_USE_UV_MIN_MAX_yTexture
#define SC_USE_UV_MIN_MAX_yTexture 0
#elif SC_USE_UV_MIN_MAX_yTexture==1
#undef SC_USE_UV_MIN_MAX_yTexture
#define SC_USE_UV_MIN_MAX_yTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_yTexture
#define SC_USE_CLAMP_TO_BORDER_yTexture 0
#elif SC_USE_CLAMP_TO_BORDER_yTexture==1
#undef SC_USE_CLAMP_TO_BORDER_yTexture
#define SC_USE_CLAMP_TO_BORDER_yTexture 1
#endif
constant int2 _2294=int2(SC_SOFTWARE_WRAP_MODE_U_yTexture,SC_SOFTWARE_WRAP_MODE_V_yTexture);
#ifndef SC_USE_UV_TRANSFORM_uvTexture
#define SC_USE_UV_TRANSFORM_uvTexture 0
#elif SC_USE_UV_TRANSFORM_uvTexture==1
#undef SC_USE_UV_TRANSFORM_uvTexture
#define SC_USE_UV_TRANSFORM_uvTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_uvTexture
#define SC_SOFTWARE_WRAP_MODE_U_uvTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_uvTexture
#define SC_SOFTWARE_WRAP_MODE_V_uvTexture -1
#endif
constant int2 _2326=int2(SC_SOFTWARE_WRAP_MODE_U_uvTexture,SC_SOFTWARE_WRAP_MODE_V_uvTexture);
#ifndef SC_USE_UV_MIN_MAX_uvTexture
#define SC_USE_UV_MIN_MAX_uvTexture 0
#elif SC_USE_UV_MIN_MAX_uvTexture==1
#undef SC_USE_UV_MIN_MAX_uvTexture
#define SC_USE_UV_MIN_MAX_uvTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_uvTexture
#define SC_USE_CLAMP_TO_BORDER_uvTexture 0
#elif SC_USE_CLAMP_TO_BORDER_uvTexture==1
#undef SC_USE_CLAMP_TO_BORDER_uvTexture
#define SC_USE_CLAMP_TO_BORDER_uvTexture 1
#endif
constant int2 _2355=int2(SC_SOFTWARE_WRAP_MODE_U_uvTexture,SC_SOFTWARE_WRAP_MODE_V_uvTexture);
#ifndef FORMAT_NV12
#define FORMAT_NV12 0
#elif FORMAT_NV12==1
#undef FORMAT_NV12
#define FORMAT_NV12 1
#endif
#ifndef FORMAT_NV21
#define FORMAT_NV21 0
#elif FORMAT_NV21==1
#undef FORMAT_NV21
#define FORMAT_NV21 1
#endif
#ifndef yTextureUV
#define yTextureUV 0
#endif
#ifndef uvTextureUV
#define uvTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 yTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.yTextureDims.xy;
}

int yTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (yTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 uvTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.uvTextureDims.xy;
}

int uvTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (uvTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float3 getRGB(thread const float3& yuv)
{
return (float3x3(float3(1.0),float3(0.0,-0.337633,1.73245),float3(1.37071,-0.698001,0.0))*yuv)+float3(-0.685353,0.517817,-0.866223);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> yTexture [[texture(0)]],texture2d_array<float> yTextureArrSC [[texture(1)]],texture2d<float> uvTexture [[texture(2)]],texture2d_array<float> uvTextureArrSC [[texture(3)]],sampler yTextureSmplr [[sampler(0)]],sampler yTextureArrSCSmplr [[sampler(1)]],sampler uvTextureSmplr [[sampler(2)]],sampler uvTextureArrSCSmplr [[sampler(3)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 yTextureSample;
#if (yTextureLayout==2)
{
float2 param=yTextureGetDims2D(userUniformsObj);
int param_1=yTextureLayout;
int param_2=yTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_yTexture)!=0);
float3x3 param_5=userUniformsObj.yTextureTransform;
int2 param_6=_2264;
bool param_7=(int(SC_USE_UV_MIN_MAX_yTexture)!=0);
float4 param_8=userUniformsObj.yTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_yTexture)!=0);
float4 param_10=userUniformsObj.yTextureBorderColor;
float param_11=0.0;
yTextureSample=sc_SampleTexture(yTextureArrSC,yTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=yTextureGetDims2D(userUniformsObj);
int param_13=yTextureLayout;
int param_14=yTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_yTexture)!=0);
float3x3 param_17=userUniformsObj.yTextureTransform;
int2 param_18=_2294;
bool param_19=(int(SC_USE_UV_MIN_MAX_yTexture)!=0);
float4 param_20=userUniformsObj.yTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_yTexture)!=0);
float4 param_22=userUniformsObj.yTextureBorderColor;
float param_23=0.0;
yTextureSample=sc_SampleTexture(yTexture,yTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float4 uvTextureSample;
#if (uvTextureLayout==2)
{
float2 param_24=uvTextureGetDims2D(userUniformsObj);
int param_25=uvTextureLayout;
int param_26=uvTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varPackedTex.xy;
bool param_28=(int(SC_USE_UV_TRANSFORM_uvTexture)!=0);
float3x3 param_29=userUniformsObj.uvTextureTransform;
int2 param_30=_2326;
bool param_31=(int(SC_USE_UV_MIN_MAX_uvTexture)!=0);
float4 param_32=userUniformsObj.uvTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_uvTexture)!=0);
float4 param_34=userUniformsObj.uvTextureBorderColor;
float param_35=0.0;
uvTextureSample=sc_SampleTexture(uvTextureArrSC,uvTextureArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=uvTextureGetDims2D(userUniformsObj);
int param_37=uvTextureLayout;
int param_38=uvTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varPackedTex.xy;
bool param_40=(int(SC_USE_UV_TRANSFORM_uvTexture)!=0);
float3x3 param_41=userUniformsObj.uvTextureTransform;
int2 param_42=_2355;
bool param_43=(int(SC_USE_UV_MIN_MAX_uvTexture)!=0);
float4 param_44=userUniformsObj.uvTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_uvTexture)!=0);
float4 param_46=userUniformsObj.uvTextureBorderColor;
float param_47=0.0;
uvTextureSample=sc_SampleTexture(uvTexture,uvTextureSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
float yVal=yTextureSample.x;
float2 uv=uvTextureSample.xy;
float3 rgb=float3(0.0);
#if (FORMAT_NV12)
{
float3 param_48=float3(yVal,uv.x,uv.y);
rgb=getRGB(param_48);
}
#else
{
#if (FORMAT_NV21)
{
float3 param_49=float3(yVal,uv.y,uv.x);
rgb=getRGB(param_49);
}
#endif
}
#endif
float4 param_50=float4(rgb,1.0);
sc_writeFragData0(param_50,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
