#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:288 {
//float4 sc_OITAlpha0Size:0
//float4 sc_OITAlpha0Dims:16
//float4 sc_OITAlpha0DimsRecip:32
//float4 sc_OITAlpha0View:48
//float3x3 sc_OITAlpha0Transform:64
//float4 sc_OITAlpha0UvMinMax:112
//float4 sc_OITAlpha0BorderColor:128
//float4 sc_OITAlpha1Size:144
//float4 sc_OITAlpha1Dims:160
//float4 sc_OITAlpha1DimsRecip:176
//float4 sc_OITAlpha1View:192
//float3x3 sc_OITAlpha1Transform:208
//float4 sc_OITAlpha1UvMinMax:256
//float4 sc_OITAlpha1BorderColor:272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 sc_OITAlpha0Size;
float4 sc_OITAlpha0Dims;
float4 sc_OITAlpha0DimsRecip;
float4 sc_OITAlpha0View;
float3x3 sc_OITAlpha0Transform;
float4 sc_OITAlpha0UvMinMax;
float4 sc_OITAlpha0BorderColor;
float4 sc_OITAlpha1Size;
float4 sc_OITAlpha1Dims;
float4 sc_OITAlpha1DimsRecip;
float4 sc_OITAlpha1View;
float3x3 sc_OITAlpha1Transform;
float4 sc_OITAlpha1UvMinMax;
float4 sc_OITAlpha1BorderColor;
};

#ifndef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 0
#elif sc_OITAlpha0HasSwappedViews==1
#undef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 1
#endif
#ifndef sc_OITAlpha0Layout
#define sc_OITAlpha0Layout 0
#endif
#ifndef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 0
#elif sc_OITAlpha1HasSwappedViews==1
#undef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 1
#endif
#ifndef sc_OITAlpha1Layout
#define sc_OITAlpha1Layout 0
#endif
#ifndef sc_OITAlpha0UV
#define sc_OITAlpha0UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha0==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha0==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 1
#endif
#ifndef sc_OITAlpha1UV
#define sc_OITAlpha1UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha1==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha1==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 _2488=(v.position.xy*0.5)+float2(0.5);
out.varPackedTex=float4(_2488.x,_2488.y,out.varPackedTex.z,out.varPackedTex.w);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:288 {
//float4 sc_OITAlpha0Size:0
//float4 sc_OITAlpha0Dims:16
//float4 sc_OITAlpha0DimsRecip:32
//float4 sc_OITAlpha0View:48
//float3x3 sc_OITAlpha0Transform:64
//float4 sc_OITAlpha0UvMinMax:112
//float4 sc_OITAlpha0BorderColor:128
//float4 sc_OITAlpha1Size:144
//float4 sc_OITAlpha1Dims:160
//float4 sc_OITAlpha1DimsRecip:176
//float4 sc_OITAlpha1View:192
//float3x3 sc_OITAlpha1Transform:208
//float4 sc_OITAlpha1UvMinMax:256
//float4 sc_OITAlpha1BorderColor:272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 sc_OITAlpha0Size;
float4 sc_OITAlpha0Dims;
float4 sc_OITAlpha0DimsRecip;
float4 sc_OITAlpha0View;
float3x3 sc_OITAlpha0Transform;
float4 sc_OITAlpha0UvMinMax;
float4 sc_OITAlpha0BorderColor;
float4 sc_OITAlpha1Size;
float4 sc_OITAlpha1Dims;
float4 sc_OITAlpha1DimsRecip;
float4 sc_OITAlpha1View;
float3x3 sc_OITAlpha1Transform;
float4 sc_OITAlpha1UvMinMax;
float4 sc_OITAlpha1BorderColor;
};

#ifndef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 0
#elif sc_OITAlpha0HasSwappedViews==1
#undef sc_OITAlpha0HasSwappedViews
#define sc_OITAlpha0HasSwappedViews 1
#endif
#ifndef sc_OITAlpha0Layout
#define sc_OITAlpha0Layout 0
#endif
#ifndef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 0
#elif sc_OITAlpha1HasSwappedViews==1
#undef sc_OITAlpha1HasSwappedViews
#define sc_OITAlpha1HasSwappedViews 1
#endif
#ifndef sc_OITAlpha1Layout
#define sc_OITAlpha1Layout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha0==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha0
#define SC_USE_UV_TRANSFORM_sc_OITAlpha0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0 -1
#endif
constant int2 _2293=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0);
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha0==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha0
#define SC_USE_UV_MIN_MAX_sc_OITAlpha0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0 1
#endif
constant int2 _2323=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0);
constant int2 _2407=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0);
constant int2 _2432=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha0,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha0);
#ifndef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 0
#elif SC_USE_UV_TRANSFORM_sc_OITAlpha1==1
#undef SC_USE_UV_TRANSFORM_sc_OITAlpha1
#define SC_USE_UV_TRANSFORM_sc_OITAlpha1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1 -1
#endif
constant int2 _2472=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1);
#ifndef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 0
#elif SC_USE_UV_MIN_MAX_sc_OITAlpha1==1
#undef SC_USE_UV_MIN_MAX_sc_OITAlpha1
#define SC_USE_UV_MIN_MAX_sc_OITAlpha1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1
#define SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1 1
#endif
constant int2 _2501=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITAlpha1,SC_SOFTWARE_WRAP_MODE_V_sc_OITAlpha1);
#ifndef sc_OITAlpha0UV
#define sc_OITAlpha0UV 0
#endif
#ifndef sc_OITAlpha1UV
#define sc_OITAlpha1UV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

// Implementation of the GLSL mod() function,which is slightly different than Metal fmod()
template<typename Tx,typename Ty>
Tx mod(Tx x,Ty y)
{
return x-y*floor(x/y);
}

// Implementation of an array copy function to cover GLSL's ability to copy an array via assignment.
template<typename T,uint N>
void spvArrayCopyFromStack1(thread T (&dst)[N],thread const T (&src)[N])
{
for (uint i=0; i<N; dst[i]=src[i],i++);
}

template<typename T,uint N>
void spvArrayCopyFromConstant1(thread T (&dst)[N],constant T (&src)[N])
{
for (uint i=0; i<N; dst[i]=src[i],i++);
}

float2 sc_OITAlpha0GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.sc_OITAlpha0Dims.xy;
}

int sc_OITAlpha0GetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_OITAlpha0HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 sc_OITAlpha1GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.sc_OITAlpha1Dims.xy;
}

int sc_OITAlpha1GetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_OITAlpha1HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

void unpackValues(thread float& channel,thread const int& passIndex,thread int (&values)[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4])
{
channel=floor((channel*255.0)+0.5);
for (int i=((passIndex+1)*4)-1; i>=(passIndex*4); i--)
{
values[i]=(values[i]*4)+int(floor(mod(channel,4.0)));
channel=floor(channel/4.0);
}
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> sc_OITAlpha0 [[texture(0)]],texture2d_array<float> sc_OITAlpha0ArrSC [[texture(1)]],texture2d<float> sc_OITAlpha1 [[texture(2)]],texture2d_array<float> sc_OITAlpha1ArrSC [[texture(3)]],sampler sc_OITAlpha0Smplr [[sampler(0)]],sampler sc_OITAlpha0ArrSCSmplr [[sampler(1)]],sampler sc_OITAlpha1Smplr [[sampler(2)]],sampler sc_OITAlpha1ArrSCSmplr [[sampler(3)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
#if (sc_OITMaxLayersVisualizeLayerCount)
{
float4 sc_OITAlpha0Sample;
#if (sc_OITAlpha0Layout==2)
{
float2 param=sc_OITAlpha0GetDims2D(userUniformsObj);
int param_1=sc_OITAlpha0Layout;
int param_2=sc_OITAlpha0GetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha0)!=0);
float3x3 param_5=userUniformsObj.sc_OITAlpha0Transform;
int2 param_6=_2293;
bool param_7=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha0)!=0);
float4 param_8=userUniformsObj.sc_OITAlpha0UvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0)!=0);
float4 param_10=userUniformsObj.sc_OITAlpha0BorderColor;
float param_11=0.0;
sc_OITAlpha0Sample=sc_SampleTexture(sc_OITAlpha0ArrSC,sc_OITAlpha0ArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=sc_OITAlpha0GetDims2D(userUniformsObj);
int param_13=sc_OITAlpha0Layout;
int param_14=sc_OITAlpha0GetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha0)!=0);
float3x3 param_17=userUniformsObj.sc_OITAlpha0Transform;
int2 param_18=_2323;
bool param_19=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha0)!=0);
float4 param_20=userUniformsObj.sc_OITAlpha0UvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0)!=0);
float4 param_22=userUniformsObj.sc_OITAlpha0BorderColor;
float param_23=0.0;
sc_OITAlpha0Sample=sc_SampleTexture(sc_OITAlpha0,sc_OITAlpha0Smplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float4 alphaSample=sc_OITAlpha0Sample;
float4 result=float4(0.0);
if (alphaSample.x==0.0)
{
result=float4(0.0,0.0,0.0,1.0);
}
else
{
if (alphaSample.x<=0.0156863)
{
result=float4(0.0,1.0,0.0,1.0);
}
else
{
if (alphaSample.x<=0.0313726)
{
result=float4(1.0,1.0,0.0,1.0);
}
else
{
result=float4(1.0,0.0,0.0,1.0);
}
}
}
float4 param_24=result;
sc_writeFragData0(param_24,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
#endif
int alphas[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
for (int i=0; i<(((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4); i++)
{
alphas[i]=0;
}
float4 sc_OITAlpha0Sample_1;
float4 alphaSample_1;
float4 sc_OITAlpha1Sample;
for (int pass=0; pass<((int(sc_OITMaxLayers8)!=0) ? 2 : 1); pass++)
{
if (pass==0)
{
#if (sc_OITAlpha0Layout==2)
{
float2 param_25=sc_OITAlpha0GetDims2D(userUniformsObj);
int param_26=sc_OITAlpha0Layout;
int param_27=sc_OITAlpha0GetStereoViewIndex(in.varStereoViewID);
float2 param_28=in.varPackedTex.xy;
bool param_29=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha0)!=0);
float3x3 param_30=userUniformsObj.sc_OITAlpha0Transform;
int2 param_31=_2407;
bool param_32=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha0)!=0);
float4 param_33=userUniformsObj.sc_OITAlpha0UvMinMax;
bool param_34=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0)!=0);
float4 param_35=userUniformsObj.sc_OITAlpha0BorderColor;
float param_36=0.0;
sc_OITAlpha0Sample_1=sc_SampleTexture(sc_OITAlpha0ArrSC,sc_OITAlpha0ArrSCSmplr,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36);
}
#else
{
float2 param_37=sc_OITAlpha0GetDims2D(userUniformsObj);
int param_38=sc_OITAlpha0Layout;
int param_39=sc_OITAlpha0GetStereoViewIndex(in.varStereoViewID);
float2 param_40=in.varPackedTex.xy;
bool param_41=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha0)!=0);
float3x3 param_42=userUniformsObj.sc_OITAlpha0Transform;
int2 param_43=_2432;
bool param_44=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha0)!=0);
float4 param_45=userUniformsObj.sc_OITAlpha0UvMinMax;
bool param_46=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha0)!=0);
float4 param_47=userUniformsObj.sc_OITAlpha0BorderColor;
float param_48=0.0;
sc_OITAlpha0Sample_1=sc_SampleTexture(sc_OITAlpha0,sc_OITAlpha0Smplr,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48);
}
#endif
alphaSample_1=sc_OITAlpha0Sample_1;
}
else
{
if ((int(sc_OITMaxLayers8)!=0)&&(pass==1))
{
#if (sc_OITAlpha1Layout==2)
{
float2 param_49=sc_OITAlpha1GetDims2D(userUniformsObj);
int param_50=sc_OITAlpha1Layout;
int param_51=sc_OITAlpha1GetStereoViewIndex(in.varStereoViewID);
float2 param_52=in.varPackedTex.xy;
bool param_53=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha1)!=0);
float3x3 param_54=userUniformsObj.sc_OITAlpha1Transform;
int2 param_55=_2472;
bool param_56=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha1)!=0);
float4 param_57=userUniformsObj.sc_OITAlpha1UvMinMax;
bool param_58=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1)!=0);
float4 param_59=userUniformsObj.sc_OITAlpha1BorderColor;
float param_60=0.0;
sc_OITAlpha1Sample=sc_SampleTexture(sc_OITAlpha1ArrSC,sc_OITAlpha1ArrSCSmplr,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60);
}
#else
{
float2 param_61=sc_OITAlpha1GetDims2D(userUniformsObj);
int param_62=sc_OITAlpha1Layout;
int param_63=sc_OITAlpha1GetStereoViewIndex(in.varStereoViewID);
float2 param_64=in.varPackedTex.xy;
bool param_65=(int(SC_USE_UV_TRANSFORM_sc_OITAlpha1)!=0);
float3x3 param_66=userUniformsObj.sc_OITAlpha1Transform;
int2 param_67=_2501;
bool param_68=(int(SC_USE_UV_MIN_MAX_sc_OITAlpha1)!=0);
float4 param_69=userUniformsObj.sc_OITAlpha1UvMinMax;
bool param_70=(int(SC_USE_CLAMP_TO_BORDER_sc_OITAlpha1)!=0);
float4 param_71=userUniformsObj.sc_OITAlpha1BorderColor;
float param_72=0.0;
sc_OITAlpha1Sample=sc_SampleTexture(sc_OITAlpha1,sc_OITAlpha1Smplr,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71,param_72);
}
#endif
alphaSample_1=sc_OITAlpha1Sample;
}
}
float param_73=alphaSample_1.w;
int param_74=pass;
int param_75[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_75,alphas);
unpackValues(param_73,param_74,param_75);
spvArrayCopyFromStack1(alphas,param_75);
float param_76=alphaSample_1.z;
int param_77=pass;
int param_78[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_78,alphas);
unpackValues(param_76,param_77,param_78);
spvArrayCopyFromStack1(alphas,param_78);
float param_79=alphaSample_1.y;
int param_80=pass;
int param_81[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_81,alphas);
unpackValues(param_79,param_80,param_81);
spvArrayCopyFromStack1(alphas,param_81);
float param_82=alphaSample_1.x;
int param_83=pass;
int param_84[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
spvArrayCopyFromStack1(param_84,alphas);
unpackValues(param_82,param_83,param_84);
spvArrayCopyFromStack1(alphas,param_84);
}
float alphas_normalized[((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4];
for (int i_1=0; i_1<(((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4); i_1++)
{
alphas_normalized[i_1]=float(alphas[i_1])/255.0;
}
float backgroundAlpha=1.0;
for (int i_2=0; i_2<(((int(sc_OITMaxLayers8)!=0) ? 2 : 1)*4); i_2++)
{
backgroundAlpha=(1.0-alphas_normalized[i_2])*backgroundAlpha;
}
float4 param_85=float4(backgroundAlpha,backgroundAlpha,backgroundAlpha,1.0);
sc_writeFragData0(param_85,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
