#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:144 {
//float4 sc_OITDepthBoundsTextureSize:0
//float4 sc_OITDepthBoundsTextureDims:16
//float4 sc_OITDepthBoundsTextureDimsRecip:32
//float4 sc_OITDepthBoundsTextureView:48
//float3x3 sc_OITDepthBoundsTextureTransform:64
//float4 sc_OITDepthBoundsTextureUvMinMax:112
//float4 sc_OITDepthBoundsTextureBorderColor:128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 sc_OITDepthBoundsTextureSize;
float4 sc_OITDepthBoundsTextureDims;
float4 sc_OITDepthBoundsTextureDimsRecip;
float4 sc_OITDepthBoundsTextureView;
float3x3 sc_OITDepthBoundsTextureTransform;
float4 sc_OITDepthBoundsTextureUvMinMax;
float4 sc_OITDepthBoundsTextureBorderColor;
};

#ifndef sc_OITDepthBoundsTextureHasSwappedViews
#define sc_OITDepthBoundsTextureHasSwappedViews 0
#elif sc_OITDepthBoundsTextureHasSwappedViews==1
#undef sc_OITDepthBoundsTextureHasSwappedViews
#define sc_OITDepthBoundsTextureHasSwappedViews 1
#endif
#ifndef sc_OITDepthBoundsTextureLayout
#define sc_OITDepthBoundsTextureLayout 0
#endif
#ifndef sc_DepthBoundsTextureSize
#define sc_DepthBoundsTextureSize 128
#endif
#ifndef sc_OITDepthBoundsTextureUV
#define sc_OITDepthBoundsTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture
#define SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture 0
#elif SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture==1
#undef SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture
#define SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITDepthBoundsTexture
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITDepthBoundsTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITDepthBoundsTexture
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITDepthBoundsTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture
#define SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture 0
#elif SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture==1
#undef SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture
#define SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture
#define SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture
#define SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 _2315=(v.position.xy*0.5)+float2(0.5);
out.varPackedTex=float4(_2315.x,_2315.y,out.varPackedTex.z,out.varPackedTex.w);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:144 {
//float4 sc_OITDepthBoundsTextureSize:0
//float4 sc_OITDepthBoundsTextureDims:16
//float4 sc_OITDepthBoundsTextureDimsRecip:32
//float4 sc_OITDepthBoundsTextureView:48
//float3x3 sc_OITDepthBoundsTextureTransform:64
//float4 sc_OITDepthBoundsTextureUvMinMax:112
//float4 sc_OITDepthBoundsTextureBorderColor:128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 sc_OITDepthBoundsTextureSize;
float4 sc_OITDepthBoundsTextureDims;
float4 sc_OITDepthBoundsTextureDimsRecip;
float4 sc_OITDepthBoundsTextureView;
float3x3 sc_OITDepthBoundsTextureTransform;
float4 sc_OITDepthBoundsTextureUvMinMax;
float4 sc_OITDepthBoundsTextureBorderColor;
};

#ifndef sc_OITDepthBoundsTextureHasSwappedViews
#define sc_OITDepthBoundsTextureHasSwappedViews 0
#elif sc_OITDepthBoundsTextureHasSwappedViews==1
#undef sc_OITDepthBoundsTextureHasSwappedViews
#define sc_OITDepthBoundsTextureHasSwappedViews 1
#endif
#ifndef sc_OITDepthBoundsTextureLayout
#define sc_OITDepthBoundsTextureLayout 0
#endif
#ifndef sc_DepthBoundsTextureSize
#define sc_DepthBoundsTextureSize 128
#endif
#ifndef SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture
#define SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture 0
#elif SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture==1
#undef SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture
#define SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_sc_OITDepthBoundsTexture
#define SC_SOFTWARE_WRAP_MODE_U_sc_OITDepthBoundsTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_sc_OITDepthBoundsTexture
#define SC_SOFTWARE_WRAP_MODE_V_sc_OITDepthBoundsTexture -1
#endif
constant int2 _2055=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITDepthBoundsTexture,SC_SOFTWARE_WRAP_MODE_V_sc_OITDepthBoundsTexture);
#ifndef SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture
#define SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture 0
#elif SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture==1
#undef SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture
#define SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture
#define SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture 0
#elif SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture==1
#undef SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture
#define SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture 1
#endif
constant int2 _2089=int2(SC_SOFTWARE_WRAP_MODE_U_sc_OITDepthBoundsTexture,SC_SOFTWARE_WRAP_MODE_V_sc_OITDepthBoundsTexture);
#ifndef sc_OITDepthBoundsTextureUV
#define sc_OITDepthBoundsTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 sc_OITDepthBoundsTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.sc_OITDepthBoundsTextureDims.xy;
}

int sc_OITDepthBoundsTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_OITDepthBoundsTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 sampleDepthBounds(thread float2& depthBounds,thread const float2& screenUV,thread const float2& offset,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d_array<float> sc_OITDepthBoundsTextureArrSC,thread const sampler sc_OITDepthBoundsTextureArrSCSmplr,thread texture2d<float> sc_OITDepthBoundsTexture,thread const sampler sc_OITDepthBoundsTextureSmplr)
{
float4 sc_OITDepthBoundsTextureSample;
#if (sc_OITDepthBoundsTextureLayout==2)
{
float2 param=sc_OITDepthBoundsTextureGetDims2D(userUniformsObj);
int param_1=sc_OITDepthBoundsTextureLayout;
int param_2=sc_OITDepthBoundsTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=screenUV+(offset/float2(float(sc_DepthBoundsTextureSize)));
bool param_4=(int(SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture)!=0);
float3x3 param_5=userUniformsObj.sc_OITDepthBoundsTextureTransform;
int2 param_6=_2055;
bool param_7=(int(SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture)!=0);
float4 param_8=userUniformsObj.sc_OITDepthBoundsTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture)!=0);
float4 param_10=userUniformsObj.sc_OITDepthBoundsTextureBorderColor;
float param_11=0.0;
sc_OITDepthBoundsTextureSample=sc_SampleTexture(sc_OITDepthBoundsTextureArrSC,sc_OITDepthBoundsTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=sc_OITDepthBoundsTextureGetDims2D(userUniformsObj);
int param_13=sc_OITDepthBoundsTextureLayout;
int param_14=sc_OITDepthBoundsTextureGetStereoViewIndex(varStereoViewID);
float2 param_15=screenUV+(offset/float2(float(sc_DepthBoundsTextureSize)));
bool param_16=(int(SC_USE_UV_TRANSFORM_sc_OITDepthBoundsTexture)!=0);
float3x3 param_17=userUniformsObj.sc_OITDepthBoundsTextureTransform;
int2 param_18=_2089;
bool param_19=(int(SC_USE_UV_MIN_MAX_sc_OITDepthBoundsTexture)!=0);
float4 param_20=userUniformsObj.sc_OITDepthBoundsTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_sc_OITDepthBoundsTexture)!=0);
float4 param_22=userUniformsObj.sc_OITDepthBoundsTextureBorderColor;
float param_23=0.0;
sc_OITDepthBoundsTextureSample=sc_SampleTexture(sc_OITDepthBoundsTexture,sc_OITDepthBoundsTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float2 oitDepthSample=sc_OITDepthBoundsTextureSample.xy;
depthBounds=float2(fast::max(depthBounds.x,oitDepthSample.x),fast::max(depthBounds.y,oitDepthSample.y));
return depthBounds;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> sc_OITDepthBoundsTexture [[texture(0)]],texture2d_array<float> sc_OITDepthBoundsTextureArrSC [[texture(1)]],sampler sc_OITDepthBoundsTextureSmplr [[sampler(0)]],sampler sc_OITDepthBoundsTextureArrSCSmplr [[sampler(1)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 depthBounds=float2(0.0);
float2 param=depthBounds;
float2 param_1=in.varPackedTex.xy;
float2 param_2=float2(0.0);
float2 _2135=sampleDepthBounds(param,param_1,param_2,in.varStereoViewID,userUniformsObj,sc_OITDepthBoundsTextureArrSC,sc_OITDepthBoundsTextureArrSCSmplr,sc_OITDepthBoundsTexture,sc_OITDepthBoundsTextureSmplr);
depthBounds=_2135;
float2 param_3=depthBounds;
float2 param_4=in.varPackedTex.xy;
float2 param_5=float2(-1.0,0.0);
float2 _2144=sampleDepthBounds(param_3,param_4,param_5,in.varStereoViewID,userUniformsObj,sc_OITDepthBoundsTextureArrSC,sc_OITDepthBoundsTextureArrSCSmplr,sc_OITDepthBoundsTexture,sc_OITDepthBoundsTextureSmplr);
depthBounds=_2144;
float2 param_6=depthBounds;
float2 param_7=in.varPackedTex.xy;
float2 param_8=float2(1.0,0.0);
float2 _2152=sampleDepthBounds(param_6,param_7,param_8,in.varStereoViewID,userUniformsObj,sc_OITDepthBoundsTextureArrSC,sc_OITDepthBoundsTextureArrSCSmplr,sc_OITDepthBoundsTexture,sc_OITDepthBoundsTextureSmplr);
depthBounds=_2152;
float2 param_9=depthBounds;
float2 param_10=in.varPackedTex.xy;
float2 param_11=float2(0.0,-1.0);
float2 _2160=sampleDepthBounds(param_9,param_10,param_11,in.varStereoViewID,userUniformsObj,sc_OITDepthBoundsTextureArrSC,sc_OITDepthBoundsTextureArrSCSmplr,sc_OITDepthBoundsTexture,sc_OITDepthBoundsTextureSmplr);
depthBounds=_2160;
float2 param_12=depthBounds;
float2 param_13=in.varPackedTex.xy;
float2 param_14=float2(0.0,1.0);
float2 _2168=sampleDepthBounds(param_12,param_13,param_14,in.varStereoViewID,userUniformsObj,sc_OITDepthBoundsTextureArrSC,sc_OITDepthBoundsTextureArrSCSmplr,sc_OITDepthBoundsTexture,sc_OITDepthBoundsTextureSmplr);
depthBounds=_2168;
float4 param_15=float4(depthBounds.x,depthBounds.y,0.0,0.0);
sc_writeFragData0(param_15,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
