#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//attribute vec4 color:15:
//attribute vec2 inputTextureCoordinate0:16:
//attribute vec2 inputTextureCoordinate1:17:
//attribute vec2 inputTextureCoordinate2:18:
//attribute vec2 inputTextureCoordinate3:19:
//ubo float UserUniforms:vs21:576 {
//float4 particlesTexture0Size:0
//float4 particlesTexture0Dims:16
//float4 particlesTexture0DimsRecip:32
//float4 particlesTexture0View:48
//float3x3 particlesTexture0Transform:64
//float4 particlesTexture0UvMinMax:112
//float4 particlesTexture0BorderColor:128
//float4 particlesTexture1Size:144
//float4 particlesTexture1Dims:160
//float4 particlesTexture1DimsRecip:176
//float4 particlesTexture1View:192
//float3x3 particlesTexture1Transform:208
//float4 particlesTexture1UvMinMax:256
//float4 particlesTexture1BorderColor:272
//float4 particlesTexture2Size:288
//float4 particlesTexture2Dims:304
//float4 particlesTexture2DimsRecip:320
//float4 particlesTexture2View:336
//float3x3 particlesTexture2Transform:352
//float4 particlesTexture2UvMinMax:400
//float4 particlesTexture2BorderColor:416
//float4 particlesTexture3Size:432
//float4 particlesTexture3Dims:448
//float4 particlesTexture3DimsRecip:464
//float4 particlesTexture3View:480
//float3x3 particlesTexture3Transform:496
//float4 particlesTexture3UvMinMax:544
//float4 particlesTexture3BorderColor:560
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 particlesTexture0Size;
float4 particlesTexture0Dims;
float4 particlesTexture0DimsRecip;
float4 particlesTexture0View;
float3x3 particlesTexture0Transform;
float4 particlesTexture0UvMinMax;
float4 particlesTexture0BorderColor;
float4 particlesTexture1Size;
float4 particlesTexture1Dims;
float4 particlesTexture1DimsRecip;
float4 particlesTexture1View;
float3x3 particlesTexture1Transform;
float4 particlesTexture1UvMinMax;
float4 particlesTexture1BorderColor;
float4 particlesTexture2Size;
float4 particlesTexture2Dims;
float4 particlesTexture2DimsRecip;
float4 particlesTexture2View;
float3x3 particlesTexture2Transform;
float4 particlesTexture2UvMinMax;
float4 particlesTexture2BorderColor;
float4 particlesTexture3Size;
float4 particlesTexture3Dims;
float4 particlesTexture3DimsRecip;
float4 particlesTexture3View;
float3x3 particlesTexture3Transform;
float4 particlesTexture3UvMinMax;
float4 particlesTexture3BorderColor;
};

#ifndef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 0
#elif particlesTexture0HasSwappedViews==1
#undef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 1
#endif
#ifndef particlesTexture0Layout
#define particlesTexture0Layout 0
#endif
#ifndef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 0
#elif particlesTexture1HasSwappedViews==1
#undef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 1
#endif
#ifndef particlesTexture1Layout
#define particlesTexture1Layout 0
#endif
#ifndef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 0
#elif particlesTexture2HasSwappedViews==1
#undef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 1
#endif
#ifndef particlesTexture2Layout
#define particlesTexture2Layout 0
#endif
#ifndef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 0
#elif particlesTexture3HasSwappedViews==1
#undef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 1
#endif
#ifndef particlesTexture3Layout
#define particlesTexture3Layout 0
#endif
#ifndef NUM_COLORS
#define NUM_COLORS 0
#endif
#ifndef NUM_TEXTURES
#define NUM_TEXTURES 0
#endif
#ifndef ALPHATEST
#define ALPHATEST 0
#elif ALPHATEST==1
#undef ALPHATEST
#define ALPHATEST 1
#endif
#ifndef NUM_STAGES
#define NUM_STAGES 0
#endif
#ifndef STAGE0_RGB_OP
#define STAGE0_RGB_OP 0
#endif
#ifndef STAGE0_ALPHA_OP
#define STAGE0_ALPHA_OP 0
#endif
#ifndef STAGE0_RGB_ARG1
#define STAGE0_RGB_ARG1 0
#endif
#ifndef STAGE0_ALPHA_ARG1
#define STAGE0_ALPHA_ARG1 0
#endif
#ifndef STAGE0_RGB_ARG2
#define STAGE0_RGB_ARG2 0
#endif
#ifndef STAGE0_ALPHA_ARG2
#define STAGE0_ALPHA_ARG2 0
#endif
#ifndef STAGE1_RGB_OP
#define STAGE1_RGB_OP 0
#endif
#ifndef STAGE1_ALPHA_OP
#define STAGE1_ALPHA_OP 0
#endif
#ifndef STAGE1_RGB_ARG1
#define STAGE1_RGB_ARG1 0
#endif
#ifndef STAGE1_ALPHA_ARG1
#define STAGE1_ALPHA_ARG1 0
#endif
#ifndef STAGE1_RGB_ARG2
#define STAGE1_RGB_ARG2 0
#endif
#ifndef STAGE1_ALPHA_ARG2
#define STAGE1_ALPHA_ARG2 0
#endif
#ifndef STAGE2_RGB_OP
#define STAGE2_RGB_OP 0
#endif
#ifndef STAGE2_ALPHA_OP
#define STAGE2_ALPHA_OP 0
#endif
#ifndef STAGE2_RGB_ARG1
#define STAGE2_RGB_ARG1 0
#endif
#ifndef STAGE2_ALPHA_ARG1
#define STAGE2_ALPHA_ARG1 0
#endif
#ifndef STAGE2_RGB_ARG2
#define STAGE2_RGB_ARG2 0
#endif
#ifndef STAGE2_ALPHA_ARG2
#define STAGE2_ALPHA_ARG2 0
#endif
#ifndef STAGE3_RGB_OP
#define STAGE3_RGB_OP 0
#endif
#ifndef STAGE3_ALPHA_OP
#define STAGE3_ALPHA_OP 0
#endif
#ifndef STAGE3_RGB_ARG1
#define STAGE3_RGB_ARG1 0
#endif
#ifndef STAGE3_ALPHA_ARG1
#define STAGE3_ALPHA_ARG1 0
#endif
#ifndef STAGE3_RGB_ARG2
#define STAGE3_RGB_ARG2 0
#endif
#ifndef STAGE3_ALPHA_ARG2
#define STAGE3_ALPHA_ARG2 0
#endif
#ifndef particlesTexture0UV
#define particlesTexture0UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 0
#elif SC_USE_UV_TRANSFORM_particlesTexture0==1
#undef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture0 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 0
#elif SC_USE_UV_MIN_MAX_particlesTexture0==1
#undef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture0==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 1
#endif
#ifndef particlesTexture1UV
#define particlesTexture1UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 0
#elif SC_USE_UV_TRANSFORM_particlesTexture1==1
#undef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture1 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 0
#elif SC_USE_UV_MIN_MAX_particlesTexture1==1
#undef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture1==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 1
#endif
#ifndef particlesTexture2UV
#define particlesTexture2UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 0
#elif SC_USE_UV_TRANSFORM_particlesTexture2==1
#undef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture2 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture2 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 0
#elif SC_USE_UV_MIN_MAX_particlesTexture2==1
#undef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture2==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 1
#endif
#ifndef particlesTexture3UV
#define particlesTexture3UV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 0
#elif SC_USE_UV_TRANSFORM_particlesTexture3==1
#undef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture3 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture3 -1
#endif
#ifndef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 0
#elif SC_USE_UV_MIN_MAX_particlesTexture3==1
#undef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture3==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varColor [[user(locn10)]];
float2 varTex2 [[user(locn11)]];
float2 varTex3 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
float4 color [[attribute(15)]];
float2 inputTextureCoordinate0 [[attribute(16)]];
float2 inputTextureCoordinate1 [[attribute(17)]];
float2 inputTextureCoordinate2 [[attribute(18)]];
float2 inputTextureCoordinate3 [[attribute(19)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
#if (NUM_COLORS>0)
{
out.varColor=in.color;
}
#endif
#if (NUM_TEXTURES>0)
{
float2 _2848=float2(in.inputTextureCoordinate0.x,1.0-in.inputTextureCoordinate0.y);
out.varPackedTex=float4(_2848.x,_2848.y,out.varPackedTex.z,out.varPackedTex.w);
}
#endif
#if (NUM_TEXTURES>1)
{
float2 _2860=float2(in.inputTextureCoordinate1.x,1.0-in.inputTextureCoordinate1.y);
out.varPackedTex=float4(out.varPackedTex.x,out.varPackedTex.y,_2860.x,_2860.y);
}
#endif
#if (NUM_TEXTURES>2)
{
out.varTex2=float2(in.inputTextureCoordinate2.x,1.0-in.inputTextureCoordinate2.y);
}
#endif
#if (NUM_TEXTURES>3)
{
out.varTex3=float2(in.inputTextureCoordinate3.x,1.0-in.inputTextureCoordinate3.y);
}
#endif
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:576 {
//float4 particlesTexture0Size:0
//float4 particlesTexture0Dims:16
//float4 particlesTexture0DimsRecip:32
//float4 particlesTexture0View:48
//float3x3 particlesTexture0Transform:64
//float4 particlesTexture0UvMinMax:112
//float4 particlesTexture0BorderColor:128
//float4 particlesTexture1Size:144
//float4 particlesTexture1Dims:160
//float4 particlesTexture1DimsRecip:176
//float4 particlesTexture1View:192
//float3x3 particlesTexture1Transform:208
//float4 particlesTexture1UvMinMax:256
//float4 particlesTexture1BorderColor:272
//float4 particlesTexture2Size:288
//float4 particlesTexture2Dims:304
//float4 particlesTexture2DimsRecip:320
//float4 particlesTexture2View:336
//float3x3 particlesTexture2Transform:352
//float4 particlesTexture2UvMinMax:400
//float4 particlesTexture2BorderColor:416
//float4 particlesTexture3Size:432
//float4 particlesTexture3Dims:448
//float4 particlesTexture3DimsRecip:464
//float4 particlesTexture3View:480
//float3x3 particlesTexture3Transform:496
//float4 particlesTexture3UvMinMax:544
//float4 particlesTexture3BorderColor:560
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 particlesTexture0Size;
float4 particlesTexture0Dims;
float4 particlesTexture0DimsRecip;
float4 particlesTexture0View;
float3x3 particlesTexture0Transform;
float4 particlesTexture0UvMinMax;
float4 particlesTexture0BorderColor;
float4 particlesTexture1Size;
float4 particlesTexture1Dims;
float4 particlesTexture1DimsRecip;
float4 particlesTexture1View;
float3x3 particlesTexture1Transform;
float4 particlesTexture1UvMinMax;
float4 particlesTexture1BorderColor;
float4 particlesTexture2Size;
float4 particlesTexture2Dims;
float4 particlesTexture2DimsRecip;
float4 particlesTexture2View;
float3x3 particlesTexture2Transform;
float4 particlesTexture2UvMinMax;
float4 particlesTexture2BorderColor;
float4 particlesTexture3Size;
float4 particlesTexture3Dims;
float4 particlesTexture3DimsRecip;
float4 particlesTexture3View;
float3x3 particlesTexture3Transform;
float4 particlesTexture3UvMinMax;
float4 particlesTexture3BorderColor;
};

#ifndef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 0
#elif particlesTexture0HasSwappedViews==1
#undef particlesTexture0HasSwappedViews
#define particlesTexture0HasSwappedViews 1
#endif
#ifndef particlesTexture0Layout
#define particlesTexture0Layout 0
#endif
#ifndef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 0
#elif particlesTexture1HasSwappedViews==1
#undef particlesTexture1HasSwappedViews
#define particlesTexture1HasSwappedViews 1
#endif
#ifndef particlesTexture1Layout
#define particlesTexture1Layout 0
#endif
#ifndef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 0
#elif particlesTexture2HasSwappedViews==1
#undef particlesTexture2HasSwappedViews
#define particlesTexture2HasSwappedViews 1
#endif
#ifndef particlesTexture2Layout
#define particlesTexture2Layout 0
#endif
#ifndef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 0
#elif particlesTexture3HasSwappedViews==1
#undef particlesTexture3HasSwappedViews
#define particlesTexture3HasSwappedViews 1
#endif
#ifndef particlesTexture3Layout
#define particlesTexture3Layout 0
#endif
#ifndef NUM_STAGES
#define NUM_STAGES 0
#endif
#ifndef STAGE0_RGB_ARG1
#define STAGE0_RGB_ARG1 0
#endif
#ifndef STAGE0_ALPHA_ARG1
#define STAGE0_ALPHA_ARG1 0
#endif
#ifndef STAGE0_RGB_ARG2
#define STAGE0_RGB_ARG2 0
#endif
#ifndef STAGE0_ALPHA_ARG2
#define STAGE0_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 0
#elif SC_USE_UV_TRANSFORM_particlesTexture0==1
#undef SC_USE_UV_TRANSFORM_particlesTexture0
#define SC_USE_UV_TRANSFORM_particlesTexture0 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture0 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture0
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture0 -1
#endif
constant int2 _2669=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture0,SC_SOFTWARE_WRAP_MODE_V_particlesTexture0);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 0
#elif SC_USE_UV_MIN_MAX_particlesTexture0==1
#undef SC_USE_UV_MIN_MAX_particlesTexture0
#define SC_USE_UV_MIN_MAX_particlesTexture0 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture0==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture0
#define SC_USE_CLAMP_TO_BORDER_particlesTexture0 1
#endif
constant int2 _2699=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture0,SC_SOFTWARE_WRAP_MODE_V_particlesTexture0);
#ifndef STAGE0_RGB_OP
#define STAGE0_RGB_OP 0
#endif
#ifndef STAGE0_ALPHA_OP
#define STAGE0_ALPHA_OP 0
#endif
#ifndef STAGE1_RGB_ARG1
#define STAGE1_RGB_ARG1 0
#endif
#ifndef STAGE1_ALPHA_ARG1
#define STAGE1_ALPHA_ARG1 0
#endif
#ifndef STAGE1_RGB_ARG2
#define STAGE1_RGB_ARG2 0
#endif
#ifndef STAGE1_ALPHA_ARG2
#define STAGE1_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 0
#elif SC_USE_UV_TRANSFORM_particlesTexture1==1
#undef SC_USE_UV_TRANSFORM_particlesTexture1
#define SC_USE_UV_TRANSFORM_particlesTexture1 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture1 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture1
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture1 -1
#endif
constant int2 _2974=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture1,SC_SOFTWARE_WRAP_MODE_V_particlesTexture1);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 0
#elif SC_USE_UV_MIN_MAX_particlesTexture1==1
#undef SC_USE_UV_MIN_MAX_particlesTexture1
#define SC_USE_UV_MIN_MAX_particlesTexture1 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture1==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture1
#define SC_USE_CLAMP_TO_BORDER_particlesTexture1 1
#endif
constant int2 _3003=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture1,SC_SOFTWARE_WRAP_MODE_V_particlesTexture1);
#ifndef STAGE1_RGB_OP
#define STAGE1_RGB_OP 0
#endif
#ifndef STAGE1_ALPHA_OP
#define STAGE1_ALPHA_OP 0
#endif
#ifndef STAGE2_RGB_ARG1
#define STAGE2_RGB_ARG1 0
#endif
#ifndef STAGE2_ALPHA_ARG1
#define STAGE2_ALPHA_ARG1 0
#endif
#ifndef STAGE2_RGB_ARG2
#define STAGE2_RGB_ARG2 0
#endif
#ifndef STAGE2_ALPHA_ARG2
#define STAGE2_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 0
#elif SC_USE_UV_TRANSFORM_particlesTexture2==1
#undef SC_USE_UV_TRANSFORM_particlesTexture2
#define SC_USE_UV_TRANSFORM_particlesTexture2 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture2 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture2
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture2 -1
#endif
constant int2 _3275=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture2,SC_SOFTWARE_WRAP_MODE_V_particlesTexture2);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 0
#elif SC_USE_UV_MIN_MAX_particlesTexture2==1
#undef SC_USE_UV_MIN_MAX_particlesTexture2
#define SC_USE_UV_MIN_MAX_particlesTexture2 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture2==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture2
#define SC_USE_CLAMP_TO_BORDER_particlesTexture2 1
#endif
constant int2 _3303=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture2,SC_SOFTWARE_WRAP_MODE_V_particlesTexture2);
#ifndef STAGE2_RGB_OP
#define STAGE2_RGB_OP 0
#endif
#ifndef STAGE2_ALPHA_OP
#define STAGE2_ALPHA_OP 0
#endif
#ifndef STAGE3_RGB_ARG1
#define STAGE3_RGB_ARG1 0
#endif
#ifndef STAGE3_ALPHA_ARG1
#define STAGE3_ALPHA_ARG1 0
#endif
#ifndef STAGE3_RGB_ARG2
#define STAGE3_RGB_ARG2 0
#endif
#ifndef STAGE3_ALPHA_ARG2
#define STAGE3_ALPHA_ARG2 0
#endif
#ifndef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 0
#elif SC_USE_UV_TRANSFORM_particlesTexture3==1
#undef SC_USE_UV_TRANSFORM_particlesTexture3
#define SC_USE_UV_TRANSFORM_particlesTexture3 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_U_particlesTexture3 -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_particlesTexture3
#define SC_SOFTWARE_WRAP_MODE_V_particlesTexture3 -1
#endif
constant int2 _3574=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture3,SC_SOFTWARE_WRAP_MODE_V_particlesTexture3);
#ifndef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 0
#elif SC_USE_UV_MIN_MAX_particlesTexture3==1
#undef SC_USE_UV_MIN_MAX_particlesTexture3
#define SC_USE_UV_MIN_MAX_particlesTexture3 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 0
#elif SC_USE_CLAMP_TO_BORDER_particlesTexture3==1
#undef SC_USE_CLAMP_TO_BORDER_particlesTexture3
#define SC_USE_CLAMP_TO_BORDER_particlesTexture3 1
#endif
constant int2 _3602=int2(SC_SOFTWARE_WRAP_MODE_U_particlesTexture3,SC_SOFTWARE_WRAP_MODE_V_particlesTexture3);
#ifndef STAGE3_RGB_OP
#define STAGE3_RGB_OP 0
#endif
#ifndef STAGE3_ALPHA_OP
#define STAGE3_ALPHA_OP 0
#endif
#ifndef ALPHATEST
#define ALPHATEST 0
#elif ALPHATEST==1
#undef ALPHATEST
#define ALPHATEST 1
#endif
#ifndef NUM_COLORS
#define NUM_COLORS 0
#endif
#ifndef NUM_TEXTURES
#define NUM_TEXTURES 0
#endif
#ifndef particlesTexture0UV
#define particlesTexture0UV 0
#endif
#ifndef particlesTexture1UV
#define particlesTexture1UV 0
#endif
#ifndef particlesTexture2UV
#define particlesTexture2UV 0
#endif
#ifndef particlesTexture3UV
#define particlesTexture3UV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varColor [[user(locn10)]];
float2 varTex2 [[user(locn11)]];
float2 varTex3 [[user(locn12)]];
};

float2 particlesTexture0GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture0Dims.xy;
}

int particlesTexture0GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture0HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 particlesTexture1GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture1Dims.xy;
}

int particlesTexture1GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture1HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 particlesTexture2GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture2Dims.xy;
}

int particlesTexture2GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture2HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 particlesTexture3GetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.particlesTexture3Dims.xy;
}

int particlesTexture3GetStereoViewIndex(thread int& varStereoViewID)
{
#if (particlesTexture3HasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> particlesTexture0 [[texture(0)]],texture2d_array<float> particlesTexture0ArrSC [[texture(1)]],texture2d<float> particlesTexture1 [[texture(2)]],texture2d_array<float> particlesTexture1ArrSC [[texture(3)]],texture2d<float> particlesTexture2 [[texture(4)]],texture2d_array<float> particlesTexture2ArrSC [[texture(5)]],texture2d<float> particlesTexture3 [[texture(6)]],texture2d_array<float> particlesTexture3ArrSC [[texture(7)]],sampler particlesTexture0Smplr [[sampler(0)]],sampler particlesTexture0ArrSCSmplr [[sampler(1)]],sampler particlesTexture1Smplr [[sampler(2)]],sampler particlesTexture1ArrSCSmplr [[sampler(3)]],sampler particlesTexture2Smplr [[sampler(4)]],sampler particlesTexture2ArrSCSmplr [[sampler(5)]],sampler particlesTexture3Smplr [[sampler(6)]],sampler particlesTexture3ArrSCSmplr [[sampler(7)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 color;
#if (NUM_STAGES==0)
{
color=in.varColor;
}
#endif
float4 colorTex;
float4 arg1;
float4 arg2;
#if (NUM_STAGES>0)
{
#if ((((STAGE0_RGB_ARG1==2)||(STAGE0_ALPHA_ARG1==2))||(STAGE0_RGB_ARG2==2))||(STAGE0_ALPHA_ARG2==2))
{
float4 particlesTexture0Sample;
#if (particlesTexture0Layout==2)
{
float2 param=particlesTexture0GetDims2D(userUniformsObj);
int param_1=particlesTexture0Layout;
int param_2=particlesTexture0GetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_particlesTexture0)!=0);
float3x3 param_5=userUniformsObj.particlesTexture0Transform;
int2 param_6=_2669;
bool param_7=(int(SC_USE_UV_MIN_MAX_particlesTexture0)!=0);
float4 param_8=userUniformsObj.particlesTexture0UvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture0)!=0);
float4 param_10=userUniformsObj.particlesTexture0BorderColor;
float param_11=0.0;
particlesTexture0Sample=sc_SampleTexture(particlesTexture0ArrSC,particlesTexture0ArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=particlesTexture0GetDims2D(userUniformsObj);
int param_13=particlesTexture0Layout;
int param_14=particlesTexture0GetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_particlesTexture0)!=0);
float3x3 param_17=userUniformsObj.particlesTexture0Transform;
int2 param_18=_2699;
bool param_19=(int(SC_USE_UV_MIN_MAX_particlesTexture0)!=0);
float4 param_20=userUniformsObj.particlesTexture0UvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture0)!=0);
float4 param_22=userUniformsObj.particlesTexture0BorderColor;
float param_23=0.0;
particlesTexture0Sample=sc_SampleTexture(particlesTexture0,particlesTexture0Smplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
colorTex=particlesTexture0Sample;
}
#endif
#if (STAGE0_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE0_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE0_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE0_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE0_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE0_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE0_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE0_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE0_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE0_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE0_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE0_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE0_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==1)
{
float3 _2827=arg1.xyz+arg2.xyz;
color=float4(_2827.x,_2827.y,_2827.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==2)
{
float3 _2838=arg1.xyz-arg2.xyz;
color=float4(_2838.x,_2838.y,_2838.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==3)
{
float3 _2849=arg1.xyz*arg2.xyz;
color=float4(_2849.x,_2849.y,_2849.z,color.w);
}
#else
{
#if (STAGE0_RGB_OP==4)
{
float3 _2860=arg1.xyz*arg2.xyz;
color=float4(_2860.x,_2860.y,_2860.z,color.w);
float3 _2867=color.xyz+color.xyz;
color=float4(_2867.x,_2867.y,_2867.z,color.w);
}
#else
{
float3 _2875=arg1.xyz*arg2.xyz;
color=float4(_2875.x,_2875.y,_2875.z,color.w);
float3 _2881=color.xyz*4.0;
color=float4(_2881.x,_2881.y,_2881.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE0_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE0_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE0_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE0_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE0_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (NUM_STAGES>1)
{
#if ((((STAGE1_RGB_ARG1==2)||(STAGE1_ALPHA_ARG1==2))||(STAGE1_RGB_ARG2==2))||(STAGE1_ALPHA_ARG2==2))
{
float4 particlesTexture1Sample;
#if (particlesTexture1Layout==2)
{
float2 param_24=particlesTexture1GetDims2D(userUniformsObj);
int param_25=particlesTexture1Layout;
int param_26=particlesTexture1GetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varPackedTex.zw;
bool param_28=(int(SC_USE_UV_TRANSFORM_particlesTexture1)!=0);
float3x3 param_29=userUniformsObj.particlesTexture1Transform;
int2 param_30=_2974;
bool param_31=(int(SC_USE_UV_MIN_MAX_particlesTexture1)!=0);
float4 param_32=userUniformsObj.particlesTexture1UvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture1)!=0);
float4 param_34=userUniformsObj.particlesTexture1BorderColor;
float param_35=0.0;
particlesTexture1Sample=sc_SampleTexture(particlesTexture1ArrSC,particlesTexture1ArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=particlesTexture1GetDims2D(userUniformsObj);
int param_37=particlesTexture1Layout;
int param_38=particlesTexture1GetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varPackedTex.zw;
bool param_40=(int(SC_USE_UV_TRANSFORM_particlesTexture1)!=0);
float3x3 param_41=userUniformsObj.particlesTexture1Transform;
int2 param_42=_3003;
bool param_43=(int(SC_USE_UV_MIN_MAX_particlesTexture1)!=0);
float4 param_44=userUniformsObj.particlesTexture1UvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture1)!=0);
float4 param_46=userUniformsObj.particlesTexture1BorderColor;
float param_47=0.0;
particlesTexture1Sample=sc_SampleTexture(particlesTexture1,particlesTexture1Smplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
colorTex=particlesTexture1Sample;
}
#endif
#if (STAGE1_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE1_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE1_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE1_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE1_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE1_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE1_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE1_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE1_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE1_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE1_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE1_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE1_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==1)
{
float3 _3128=arg1.xyz+arg2.xyz;
color=float4(_3128.x,_3128.y,_3128.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==2)
{
float3 _3139=arg1.xyz-arg2.xyz;
color=float4(_3139.x,_3139.y,_3139.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==3)
{
float3 _3150=arg1.xyz*arg2.xyz;
color=float4(_3150.x,_3150.y,_3150.z,color.w);
}
#else
{
#if (STAGE1_RGB_OP==4)
{
float3 _3161=arg1.xyz*arg2.xyz;
color=float4(_3161.x,_3161.y,_3161.z,color.w);
float3 _3168=color.xyz+color.xyz;
color=float4(_3168.x,_3168.y,_3168.z,color.w);
}
#else
{
float3 _3176=arg1.xyz*arg2.xyz;
color=float4(_3176.x,_3176.y,_3176.z,color.w);
float3 _3181=color.xyz*4.0;
color=float4(_3181.x,_3181.y,_3181.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE1_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE1_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE1_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE1_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE1_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (NUM_STAGES>2)
{
#if ((((STAGE2_RGB_ARG1==2)||(STAGE2_ALPHA_ARG1==2))||(STAGE2_RGB_ARG2==2))||(STAGE2_ALPHA_ARG2==2))
{
float4 particlesTexture2Sample;
#if (particlesTexture2Layout==2)
{
float2 param_48=particlesTexture2GetDims2D(userUniformsObj);
int param_49=particlesTexture2Layout;
int param_50=particlesTexture2GetStereoViewIndex(in.varStereoViewID);
float2 param_51=in.varTex2;
bool param_52=(int(SC_USE_UV_TRANSFORM_particlesTexture2)!=0);
float3x3 param_53=userUniformsObj.particlesTexture2Transform;
int2 param_54=_3275;
bool param_55=(int(SC_USE_UV_MIN_MAX_particlesTexture2)!=0);
float4 param_56=userUniformsObj.particlesTexture2UvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture2)!=0);
float4 param_58=userUniformsObj.particlesTexture2BorderColor;
float param_59=0.0;
particlesTexture2Sample=sc_SampleTexture(particlesTexture2ArrSC,particlesTexture2ArrSCSmplr,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
}
#else
{
float2 param_60=particlesTexture2GetDims2D(userUniformsObj);
int param_61=particlesTexture2Layout;
int param_62=particlesTexture2GetStereoViewIndex(in.varStereoViewID);
float2 param_63=in.varTex2;
bool param_64=(int(SC_USE_UV_TRANSFORM_particlesTexture2)!=0);
float3x3 param_65=userUniformsObj.particlesTexture2Transform;
int2 param_66=_3303;
bool param_67=(int(SC_USE_UV_MIN_MAX_particlesTexture2)!=0);
float4 param_68=userUniformsObj.particlesTexture2UvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture2)!=0);
float4 param_70=userUniformsObj.particlesTexture2BorderColor;
float param_71=0.0;
particlesTexture2Sample=sc_SampleTexture(particlesTexture2,particlesTexture2Smplr,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
}
#endif
colorTex=particlesTexture2Sample;
}
#endif
#if (STAGE2_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE2_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE2_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE2_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE2_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE2_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE2_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE2_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE2_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE2_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE2_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE2_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE2_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==1)
{
float3 _3427=arg1.xyz+arg2.xyz;
color=float4(_3427.x,_3427.y,_3427.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==2)
{
float3 _3438=arg1.xyz-arg2.xyz;
color=float4(_3438.x,_3438.y,_3438.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==3)
{
float3 _3449=arg1.xyz*arg2.xyz;
color=float4(_3449.x,_3449.y,_3449.z,color.w);
}
#else
{
#if (STAGE2_RGB_OP==4)
{
float3 _3460=arg1.xyz*arg2.xyz;
color=float4(_3460.x,_3460.y,_3460.z,color.w);
float3 _3467=color.xyz+color.xyz;
color=float4(_3467.x,_3467.y,_3467.z,color.w);
}
#else
{
float3 _3475=arg1.xyz*arg2.xyz;
color=float4(_3475.x,_3475.y,_3475.z,color.w);
float3 _3480=color.xyz*4.0;
color=float4(_3480.x,_3480.y,_3480.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE2_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE2_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE2_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE2_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE2_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (NUM_STAGES>3)
{
#if ((((STAGE3_RGB_ARG1==2)||(STAGE3_ALPHA_ARG1==2))||(STAGE3_RGB_ARG2==2))||(STAGE3_ALPHA_ARG2==2))
{
float4 particlesTexture3Sample;
#if (particlesTexture3Layout==2)
{
float2 param_72=particlesTexture3GetDims2D(userUniformsObj);
int param_73=particlesTexture3Layout;
int param_74=particlesTexture3GetStereoViewIndex(in.varStereoViewID);
float2 param_75=in.varTex3;
bool param_76=(int(SC_USE_UV_TRANSFORM_particlesTexture3)!=0);
float3x3 param_77=userUniformsObj.particlesTexture3Transform;
int2 param_78=_3574;
bool param_79=(int(SC_USE_UV_MIN_MAX_particlesTexture3)!=0);
float4 param_80=userUniformsObj.particlesTexture3UvMinMax;
bool param_81=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture3)!=0);
float4 param_82=userUniformsObj.particlesTexture3BorderColor;
float param_83=0.0;
particlesTexture3Sample=sc_SampleTexture(particlesTexture3ArrSC,particlesTexture3ArrSCSmplr,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83);
}
#else
{
float2 param_84=particlesTexture3GetDims2D(userUniformsObj);
int param_85=particlesTexture3Layout;
int param_86=particlesTexture3GetStereoViewIndex(in.varStereoViewID);
float2 param_87=in.varTex3;
bool param_88=(int(SC_USE_UV_TRANSFORM_particlesTexture3)!=0);
float3x3 param_89=userUniformsObj.particlesTexture3Transform;
int2 param_90=_3602;
bool param_91=(int(SC_USE_UV_MIN_MAX_particlesTexture3)!=0);
float4 param_92=userUniformsObj.particlesTexture3UvMinMax;
bool param_93=(int(SC_USE_CLAMP_TO_BORDER_particlesTexture3)!=0);
float4 param_94=userUniformsObj.particlesTexture3BorderColor;
float param_95=0.0;
particlesTexture3Sample=sc_SampleTexture(particlesTexture3,particlesTexture3Smplr,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95);
}
#endif
colorTex=particlesTexture3Sample;
}
#endif
#if (STAGE3_RGB_ARG1==0)
{
arg1=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg1.w);
}
#else
{
#if (STAGE3_RGB_ARG1==1)
{
arg1=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg1.w);
}
#else
{
#if (STAGE3_RGB_ARG1==2)
{
arg1=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg1.w);
}
#endif
}
#endif
}
#endif
#if (STAGE3_ALPHA_ARG1==0)
{
arg1.w=color.w;
}
#else
{
#if (STAGE3_ALPHA_ARG1==1)
{
arg1.w=in.varColor.w;
}
#else
{
#if (STAGE3_ALPHA_ARG1==2)
{
arg1.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE3_RGB_ARG2==0)
{
arg2=float4(color.xyz.x,color.xyz.y,color.xyz.z,arg2.w);
}
#else
{
#if (STAGE3_RGB_ARG2==1)
{
arg2=float4(in.varColor.xyz.x,in.varColor.xyz.y,in.varColor.xyz.z,arg2.w);
}
#else
{
#if (STAGE3_RGB_ARG2==2)
{
arg2=float4(colorTex.xyz.x,colorTex.xyz.y,colorTex.xyz.z,arg2.w);
}
#endif
}
#endif
}
#endif
#if (STAGE3_ALPHA_ARG2==0)
{
arg2.w=color.w;
}
#else
{
#if (STAGE3_ALPHA_ARG2==1)
{
arg2.w=in.varColor.w;
}
#else
{
#if (STAGE3_ALPHA_ARG2==2)
{
arg2.w=colorTex.w;
}
#endif
}
#endif
}
#endif
#if (STAGE3_RGB_OP==0)
{
color=float4(arg1.xyz.x,arg1.xyz.y,arg1.xyz.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==1)
{
float3 _3726=arg1.xyz+arg2.xyz;
color=float4(_3726.x,_3726.y,_3726.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==2)
{
float3 _3737=arg1.xyz-arg2.xyz;
color=float4(_3737.x,_3737.y,_3737.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==3)
{
float3 _3748=arg1.xyz*arg2.xyz;
color=float4(_3748.x,_3748.y,_3748.z,color.w);
}
#else
{
#if (STAGE3_RGB_OP==4)
{
float3 _3759=arg1.xyz*arg2.xyz;
color=float4(_3759.x,_3759.y,_3759.z,color.w);
float3 _3766=color.xyz+color.xyz;
color=float4(_3766.x,_3766.y,_3766.z,color.w);
}
#else
{
float3 _3774=arg1.xyz*arg2.xyz;
color=float4(_3774.x,_3774.y,_3774.z,color.w);
float3 _3779=color.xyz*4.0;
color=float4(_3779.x,_3779.y,_3779.z,color.w);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
#if (STAGE3_ALPHA_OP==0)
{
color.w=arg1.w;
}
#else
{
#if (STAGE3_ALPHA_OP==1)
{
color.w=arg1.w+arg2.w;
}
#else
{
#if (STAGE3_ALPHA_OP==2)
{
color.w=arg1.w-arg2.w;
}
#else
{
#if (STAGE3_ALPHA_OP==3)
{
color.w=arg1.w*arg2.w;
}
#else
{
#if (STAGE3_ALPHA_OP==4)
{
color.w=arg1.w*arg2.w;
color.w+=color.w;
}
#else
{
color.w=arg1.w*arg2.w;
color.w*=4.0;
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
bool _3852;
#if (ALPHATEST)
{
_3852=color.w==0.0;
}
#else
{
_3852=(int(ALPHATEST)!=0);
}
#endif
if (_3852)
{
discard_fragment();
}
float4 param_96=color;
sc_writeFragData0(param_96,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
