#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:144 {
//float4 rectTextureSize:0
//float4 rectTextureDims:16
//float4 rectTextureDimsRecip:32
//float4 rectTextureView:48
//float3x3 rectTextureTransform:64
//float4 rectTextureUvMinMax:112
//float4 rectTextureBorderColor:128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 rectTextureSize;
float4 rectTextureDims;
float4 rectTextureDimsRecip;
float4 rectTextureView;
float3x3 rectTextureTransform;
float4 rectTextureUvMinMax;
float4 rectTextureBorderColor;
};

#ifndef rectTextureHasSwappedViews
#define rectTextureHasSwappedViews 0
#elif rectTextureHasSwappedViews==1
#undef rectTextureHasSwappedViews
#define rectTextureHasSwappedViews 1
#endif
#ifndef rectTextureLayout
#define rectTextureLayout 0
#endif
#ifndef rectTextureUV
#define rectTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_rectTexture
#define SC_USE_UV_TRANSFORM_rectTexture 0
#elif SC_USE_UV_TRANSFORM_rectTexture==1
#undef SC_USE_UV_TRANSFORM_rectTexture
#define SC_USE_UV_TRANSFORM_rectTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_rectTexture
#define SC_SOFTWARE_WRAP_MODE_U_rectTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_rectTexture
#define SC_SOFTWARE_WRAP_MODE_V_rectTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_rectTexture
#define SC_USE_UV_MIN_MAX_rectTexture 0
#elif SC_USE_UV_MIN_MAX_rectTexture==1
#undef SC_USE_UV_MIN_MAX_rectTexture
#define SC_USE_UV_MIN_MAX_rectTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_rectTexture
#define SC_USE_CLAMP_TO_BORDER_rectTexture 0
#elif SC_USE_CLAMP_TO_BORDER_rectTexture==1
#undef SC_USE_CLAMP_TO_BORDER_rectTexture
#define SC_USE_CLAMP_TO_BORDER_rectTexture 1
#endif

struct main_vert_out
{
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
out.gl_Position=float4(v.position.xy,0.0,1.0);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:144 {
//float4 rectTextureSize:0
//float4 rectTextureDims:16
//float4 rectTextureDimsRecip:32
//float4 rectTextureView:48
//float3x3 rectTextureTransform:64
//float4 rectTextureUvMinMax:112
//float4 rectTextureBorderColor:128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 rectTextureSize;
float4 rectTextureDims;
float4 rectTextureDimsRecip;
float4 rectTextureView;
float3x3 rectTextureTransform;
float4 rectTextureUvMinMax;
float4 rectTextureBorderColor;
};

#ifndef rectTextureHasSwappedViews
#define rectTextureHasSwappedViews 0
#elif rectTextureHasSwappedViews==1
#undef rectTextureHasSwappedViews
#define rectTextureHasSwappedViews 1
#endif
#ifndef rectTextureLayout
#define rectTextureLayout 0
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_rectTexture
#define SC_SOFTWARE_WRAP_MODE_U_rectTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_rectTexture
#define SC_SOFTWARE_WRAP_MODE_V_rectTexture -1
#endif
constant int2 _2046=int2(SC_SOFTWARE_WRAP_MODE_U_rectTexture,SC_SOFTWARE_WRAP_MODE_V_rectTexture);
#ifndef SC_USE_UV_MIN_MAX_rectTexture
#define SC_USE_UV_MIN_MAX_rectTexture 0
#elif SC_USE_UV_MIN_MAX_rectTexture==1
#undef SC_USE_UV_MIN_MAX_rectTexture
#define SC_USE_UV_MIN_MAX_rectTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_rectTexture
#define SC_USE_CLAMP_TO_BORDER_rectTexture 0
#elif SC_USE_CLAMP_TO_BORDER_rectTexture==1
#undef SC_USE_CLAMP_TO_BORDER_rectTexture
#define SC_USE_CLAMP_TO_BORDER_rectTexture 1
#endif
constant int2 _2073=int2(SC_SOFTWARE_WRAP_MODE_U_rectTexture,SC_SOFTWARE_WRAP_MODE_V_rectTexture);
#ifndef rectTextureUV
#define rectTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_rectTexture
#define SC_USE_UV_TRANSFORM_rectTexture 0
#elif SC_USE_UV_TRANSFORM_rectTexture==1
#undef SC_USE_UV_TRANSFORM_rectTexture
#define SC_USE_UV_TRANSFORM_rectTexture 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 rectTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.rectTextureDims.xy;
}

int rectTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (rectTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> rectTexture [[texture(0)]],texture2d_array<float> rectTextureArrSC [[texture(1)]],sampler rectTextureSmplr [[sampler(0)]],sampler rectTextureArrSCSmplr [[sampler(1)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 rectTextureSample;
#if (rectTextureLayout==2)
{
float2 param=rectTextureGetDims2D(userUniformsObj);
int param_1=rectTextureLayout;
int param_2=rectTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_2046;
bool param_7=(int(SC_USE_UV_MIN_MAX_rectTexture)!=0);
float4 param_8=userUniformsObj.rectTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_rectTexture)!=0);
float4 param_10=userUniformsObj.rectTextureBorderColor;
float param_11=0.0;
rectTextureSample=sc_SampleTexture(rectTextureArrSC,rectTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=rectTextureGetDims2D(userUniformsObj);
int param_13=rectTextureLayout;
int param_14=rectTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=false;
float3x3 param_17=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_18=_2073;
bool param_19=(int(SC_USE_UV_MIN_MAX_rectTexture)!=0);
float4 param_20=userUniformsObj.rectTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_rectTexture)!=0);
float4 param_22=userUniformsObj.rectTextureBorderColor;
float param_23=0.0;
rectTextureSample=sc_SampleTexture(rectTexture,rectTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float4 param_24=rectTextureSample;
sc_writeFragData0(param_24,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
