#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:288 {
//float4 segmentationMaskSize:0
//float4 segmentationMaskDims:16
//float4 segmentationMaskDimsRecip:32
//float4 segmentationMaskView:48
//float3x3 segmentationMaskTransform:64
//float4 segmentationMaskUvMinMax:112
//float4 segmentationMaskBorderColor:128
//float4 mainTextureSize:144
//float4 mainTextureDims:160
//float4 mainTextureDimsRecip:176
//float4 mainTextureView:192
//float3x3 mainTextureTransform:208
//float4 mainTextureUvMinMax:256
//float4 mainTextureBorderColor:272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 segmentationMaskSize;
float4 segmentationMaskDims;
float4 segmentationMaskDimsRecip;
float4 segmentationMaskView;
float3x3 segmentationMaskTransform;
float4 segmentationMaskUvMinMax;
float4 segmentationMaskBorderColor;
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureDimsRecip;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 0
#elif segmentationMaskHasSwappedViews==1
#undef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 1
#endif
#ifndef segmentationMaskLayout
#define segmentationMaskLayout 0
#endif
#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef RG_RB_GB
#define RG_RB_GB 0
#elif RG_RB_GB==1
#undef RG_RB_GB
#define RG_RB_GB 1
#endif
#ifndef RR_GG_BB
#define RR_GG_BB 0
#elif RR_GG_BB==1
#undef RR_GG_BB
#define RR_GG_BB 1
#endif
#ifndef R_G_B
#define R_G_B 0
#elif R_G_B==1
#undef R_G_B
#define R_G_B 1
#endif
#ifndef RY_GY_BY_Y
#define RY_GY_BY_Y 0
#elif RY_GY_BY_Y==1
#undef RY_GY_BY_Y
#define RY_GY_BY_Y 1
#endif
#ifndef GRAY_SCALE
#define GRAY_SCALE 0
#elif GRAY_SCALE==1
#undef GRAY_SCALE
#define GRAY_SCALE 1
#endif
#ifndef segmentationMaskUV
#define segmentationMaskUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 0
#elif SC_USE_UV_TRANSFORM_segmentationMask==1
#undef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_U_segmentationMask -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_V_segmentationMask -1
#endif
#ifndef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 0
#elif SC_USE_UV_MIN_MAX_segmentationMask==1
#undef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 0
#elif SC_USE_CLAMP_TO_BORDER_segmentationMask==1
#undef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 texPos=(v.position.xy*0.5)+float2(0.5);
float2 _2495=float2(texPos.x,1.0-texPos.y);
out.varPackedTex=float4(out.varPackedTex.x,out.varPackedTex.y,_2495.x,_2495.y);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:288 {
//float4 segmentationMaskSize:0
//float4 segmentationMaskDims:16
//float4 segmentationMaskDimsRecip:32
//float4 segmentationMaskView:48
//float3x3 segmentationMaskTransform:64
//float4 segmentationMaskUvMinMax:112
//float4 segmentationMaskBorderColor:128
//float4 mainTextureSize:144
//float4 mainTextureDims:160
//float4 mainTextureDimsRecip:176
//float4 mainTextureView:192
//float3x3 mainTextureTransform:208
//float4 mainTextureUvMinMax:256
//float4 mainTextureBorderColor:272
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 segmentationMaskSize;
float4 segmentationMaskDims;
float4 segmentationMaskDimsRecip;
float4 segmentationMaskView;
float3x3 segmentationMaskTransform;
float4 segmentationMaskUvMinMax;
float4 segmentationMaskBorderColor;
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureDimsRecip;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
};

#ifndef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 0
#elif segmentationMaskHasSwappedViews==1
#undef segmentationMaskHasSwappedViews
#define segmentationMaskHasSwappedViews 1
#endif
#ifndef segmentationMaskLayout
#define segmentationMaskLayout 0
#endif
#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _2256=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
constant int2 _2286=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef GRAY_SCALE
#define GRAY_SCALE 0
#elif GRAY_SCALE==1
#undef GRAY_SCALE
#define GRAY_SCALE 1
#endif
#ifndef RG_RB_GB
#define RG_RB_GB 0
#elif RG_RB_GB==1
#undef RG_RB_GB
#define RG_RB_GB 1
#endif
#ifndef RR_GG_BB
#define RR_GG_BB 0
#elif RR_GG_BB==1
#undef RR_GG_BB
#define RR_GG_BB 1
#endif
#ifndef R_G_B
#define R_G_B 0
#elif R_G_B==1
#undef R_G_B
#define R_G_B 1
#endif
#ifndef RY_GY_BY_Y
#define RY_GY_BY_Y 0
#elif RY_GY_BY_Y==1
#undef RY_GY_BY_Y
#define RY_GY_BY_Y 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_U_segmentationMask -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_segmentationMask
#define SC_SOFTWARE_WRAP_MODE_V_segmentationMask -1
#endif
constant int2 _2368=int2(SC_SOFTWARE_WRAP_MODE_U_segmentationMask,SC_SOFTWARE_WRAP_MODE_V_segmentationMask);
#ifndef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 0
#elif SC_USE_UV_MIN_MAX_segmentationMask==1
#undef SC_USE_UV_MIN_MAX_segmentationMask
#define SC_USE_UV_MIN_MAX_segmentationMask 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 0
#elif SC_USE_CLAMP_TO_BORDER_segmentationMask==1
#undef SC_USE_CLAMP_TO_BORDER_segmentationMask
#define SC_USE_CLAMP_TO_BORDER_segmentationMask 1
#endif
constant int2 _2395=int2(SC_SOFTWARE_WRAP_MODE_U_segmentationMask,SC_SOFTWARE_WRAP_MODE_V_segmentationMask);
constant int2 _2435=int2(SC_SOFTWARE_WRAP_MODE_U_segmentationMask,SC_SOFTWARE_WRAP_MODE_V_segmentationMask);
constant int2 _2458=int2(SC_SOFTWARE_WRAP_MODE_U_segmentationMask,SC_SOFTWARE_WRAP_MODE_V_segmentationMask);
#ifndef segmentationMaskUV
#define segmentationMaskUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 0
#elif SC_USE_UV_TRANSFORM_segmentationMask==1
#undef SC_USE_UV_TRANSFORM_segmentationMask
#define SC_USE_UV_TRANSFORM_segmentationMask 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float grayscale(thread const float3& color)
{
return dot(color,float3(0.2126,0.7152,0.0722));
}

float2 segmentationMaskGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.segmentationMaskDims.xy;
}

int segmentationMaskGetStereoViewIndex(thread int& varStereoViewID)
{
#if (segmentationMaskHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> segmentationMask [[texture(0)]],texture2d_array<float> segmentationMaskArrSC [[texture(1)]],texture2d<float> mainTexture [[texture(2)]],texture2d_array<float> mainTextureArrSC [[texture(3)]],sampler segmentationMaskSmplr [[sampler(0)]],sampler segmentationMaskArrSCSmplr [[sampler(1)]],sampler mainTextureSmplr [[sampler(2)]],sampler mainTextureArrSCSmplr [[sampler(3)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 mainTextureSample;
#if (mainTextureLayout==2)
{
float2 param=mainTextureGetDims2D(userUniformsObj);
int param_1=mainTextureLayout;
int param_2=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_5=userUniformsObj.mainTextureTransform;
int2 param_6=_2256;
bool param_7=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_8=userUniformsObj.mainTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureBorderColor;
float param_11=0.0;
mainTextureSample=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=mainTextureGetDims2D(userUniformsObj);
int param_13=mainTextureLayout;
int param_14=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_17=userUniformsObj.mainTextureTransform;
int2 param_18=_2286;
bool param_19=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_20=userUniformsObj.mainTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_22=userUniformsObj.mainTextureBorderColor;
float param_23=0.0;
mainTextureSample=sc_SampleTexture(mainTexture,mainTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float3 color=mainTextureSample.xyz;
float4 result=float4(0.0);
#if (GRAY_SCALE)
{
float3 param_24=color;
color=float3(grayscale(param_24));
}
#endif
#if (RG_RB_GB)
{
result=float4(color.xxy*color.yzz,1.0);
}
#else
{
#if (RR_GG_BB)
{
result=float4(color*color,1.0);
}
#else
{
#if (R_G_B)
{
result=float4(color,1.0);
}
#else
{
#if (RY_GY_BY_Y)
{
float4 segmentationMaskSample;
#if (segmentationMaskLayout==2)
{
float2 param_25=segmentationMaskGetDims2D(userUniformsObj);
int param_26=segmentationMaskLayout;
int param_27=segmentationMaskGetStereoViewIndex(in.varStereoViewID);
float2 param_28=in.varPackedTex.zw;
bool param_29=false;
float3x3 param_30=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_31=_2368;
bool param_32=(int(SC_USE_UV_MIN_MAX_segmentationMask)!=0);
float4 param_33=userUniformsObj.segmentationMaskUvMinMax;
bool param_34=(int(SC_USE_CLAMP_TO_BORDER_segmentationMask)!=0);
float4 param_35=userUniformsObj.segmentationMaskBorderColor;
float param_36=0.0;
segmentationMaskSample=sc_SampleTexture(segmentationMaskArrSC,segmentationMaskArrSCSmplr,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36);
}
#else
{
float2 param_37=segmentationMaskGetDims2D(userUniformsObj);
int param_38=segmentationMaskLayout;
int param_39=segmentationMaskGetStereoViewIndex(in.varStereoViewID);
float2 param_40=in.varPackedTex.zw;
bool param_41=false;
float3x3 param_42=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_43=_2395;
bool param_44=(int(SC_USE_UV_MIN_MAX_segmentationMask)!=0);
float4 param_45=userUniformsObj.segmentationMaskUvMinMax;
bool param_46=(int(SC_USE_CLAMP_TO_BORDER_segmentationMask)!=0);
float4 param_47=userUniformsObj.segmentationMaskBorderColor;
float param_48=0.0;
segmentationMaskSample=sc_SampleTexture(segmentationMask,segmentationMaskSmplr,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48);
}
#endif
float mask=segmentationMaskSample.x;
result=float4(color*mask,mask);
}
#else
{
#if (GRAY_SCALE)
{
float4 segmentationMaskSample_1;
#if (segmentationMaskLayout==2)
{
float2 param_49=segmentationMaskGetDims2D(userUniformsObj);
int param_50=segmentationMaskLayout;
int param_51=segmentationMaskGetStereoViewIndex(in.varStereoViewID);
float2 param_52=in.varPackedTex.zw;
bool param_53=false;
float3x3 param_54=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_55=_2435;
bool param_56=(int(SC_USE_UV_MIN_MAX_segmentationMask)!=0);
float4 param_57=userUniformsObj.segmentationMaskUvMinMax;
bool param_58=(int(SC_USE_CLAMP_TO_BORDER_segmentationMask)!=0);
float4 param_59=userUniformsObj.segmentationMaskBorderColor;
float param_60=0.0;
segmentationMaskSample_1=sc_SampleTexture(segmentationMaskArrSC,segmentationMaskArrSCSmplr,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59,param_60);
}
#else
{
float2 param_61=segmentationMaskGetDims2D(userUniformsObj);
int param_62=segmentationMaskLayout;
int param_63=segmentationMaskGetStereoViewIndex(in.varStereoViewID);
float2 param_64=in.varPackedTex.zw;
bool param_65=false;
float3x3 param_66=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_67=_2458;
bool param_68=(int(SC_USE_UV_MIN_MAX_segmentationMask)!=0);
float4 param_69=userUniformsObj.segmentationMaskUvMinMax;
bool param_70=(int(SC_USE_CLAMP_TO_BORDER_segmentationMask)!=0);
float4 param_71=userUniformsObj.segmentationMaskBorderColor;
float param_72=0.0;
segmentationMaskSample_1=sc_SampleTexture(segmentationMask,segmentationMaskSmplr,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71,param_72);
}
#endif
float mask_1=segmentationMaskSample_1.x;
result=float4(color.x,mask_1,color.x*mask_1,color.x*color.x);
}
#else
{
result=float4(1.0,0.0,1.0,1.0);
}
#endif
}
#endif
}
#endif
}
#endif
}
#endif
float4 param_73=result;
sc_writeFragData0(param_73,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
