#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:308 {
//float4 lookupTextureSize:0
//float4 lookupTextureDims:16
//float4 lookupTextureDimsRecip:32
//float4 lookupTextureView:48
//float3x3 lookupTextureTransform:64
//float4 lookupTextureUvMinMax:112
//float4 lookupTextureBorderColor:128
//float4 maskTextureSize:144
//float4 maskTextureDims:160
//float4 maskTextureDimsRecip:176
//float4 maskTextureView:192
//float3x3 maskTextureTransform:208
//float4 maskTextureUvMinMax:256
//float4 maskTextureBorderColor:272
//float softSkinRadius:288
//float softSkinIntensity:292
//float teethWhiteningIntensity:296
//float eyeWhiteningIntensity:300
//float sharpenEyeIntensity:304
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 lookupTextureSize;
float4 lookupTextureDims;
float4 lookupTextureDimsRecip;
float4 lookupTextureView;
float3x3 lookupTextureTransform;
float4 lookupTextureUvMinMax;
float4 lookupTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureDimsRecip;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float softSkinRadius;
float softSkinIntensity;
float teethWhiteningIntensity;
float eyeWhiteningIntensity;
float sharpenEyeIntensity;
};

#ifndef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 0
#elif lookupTextureHasSwappedViews==1
#undef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 1
#endif
#ifndef lookupTextureLayout
#define lookupTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef SOFT_SKIN
#define SOFT_SKIN 0
#elif SOFT_SKIN==1
#undef SOFT_SKIN
#define SOFT_SKIN 1
#endif
#ifndef EYE_SHARPEN
#define EYE_SHARPEN 0
#elif EYE_SHARPEN==1
#undef EYE_SHARPEN
#define EYE_SHARPEN 1
#endif
#ifndef EYE_WHITENING
#define EYE_WHITENING 0
#elif EYE_WHITENING==1
#undef EYE_WHITENING
#define EYE_WHITENING 1
#endif
#ifndef TEETH_WHITENING
#define TEETH_WHITENING 0
#elif TEETH_WHITENING==1
#undef TEETH_WHITENING
#define TEETH_WHITENING 1
#endif
#ifndef ADD_NOISE
#define ADD_NOISE 1
#elif ADD_NOISE==1
#undef ADD_NOISE
#define ADD_NOISE 1
#endif
#ifndef lookupTextureUV
#define lookupTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 0
#elif SC_USE_UV_TRANSFORM_lookupTexture==1
#undef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_U_lookupTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_V_lookupTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 0
#elif SC_USE_UV_MIN_MAX_lookupTexture==1
#undef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 0
#elif SC_USE_CLAMP_TO_BORDER_lookupTexture==1
#undef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 varCustomTex0 [[user(locn10)]];
float4 varCustomTex1 [[user(locn11)]];
float4 varCustomTex2 [[user(locn12)]];
float4 varCustomTex3 [[user(locn13)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 _2491=((v.position.xy/float2(v.position.w))*0.5)+float2(0.5);
out.varPackedTex=float4(_2491.x,_2491.y,out.varPackedTex.z,out.varPackedTex.w);
#if (SOFT_SKIN)
{
float2 _2503=out.varPackedTex.xy+float2(-0.00694444,-0.00390625);
out.varCustomTex0=float4(_2503.x,_2503.y,out.varCustomTex0.z,out.varCustomTex0.w);
float2 _2511=out.varPackedTex.xy+float2(-0.00694444,0.00546875);
out.varCustomTex1=float4(_2511.x,_2511.y,out.varCustomTex1.z,out.varCustomTex1.w);
float2 _2519=out.varPackedTex.xy+float2(0.00972222,-0.00390625);
out.varCustomTex2=float4(_2519.x,_2519.y,out.varCustomTex2.z,out.varCustomTex2.w);
float2 _2526=out.varPackedTex.xy+float2(0.00972222,0.00546875);
out.varCustomTex3=float4(_2526.x,_2526.y,out.varCustomTex3.z,out.varCustomTex3.w);
}
#endif
#if (EYE_SHARPEN)
{
float2 delta=float2(libraryUniformsObj.sc_Camera.aspect/1280.0,0.00078125);
float2 _2548=out.varPackedTex.xy+float2(-delta.x,-delta.y);
out.varCustomTex0=float4(out.varCustomTex0.x,out.varCustomTex0.y,_2548.x,_2548.y);
float2 _2559=out.varPackedTex.xy+float2(delta.x,-delta.y);
out.varCustomTex1=float4(out.varCustomTex1.x,out.varCustomTex1.y,_2559.x,_2559.y);
float2 _2570=out.varPackedTex.xy+float2(-delta.x,delta.y);
out.varCustomTex2=float4(out.varCustomTex2.x,out.varCustomTex2.y,_2570.x,_2570.y);
float2 _2580=out.varPackedTex.xy+float2(delta.x,delta.y);
out.varCustomTex3=float4(out.varCustomTex3.x,out.varCustomTex3.y,_2580.x,_2580.y);
}
#endif
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:308 {
//float4 lookupTextureSize:0
//float4 lookupTextureDims:16
//float4 lookupTextureDimsRecip:32
//float4 lookupTextureView:48
//float3x3 lookupTextureTransform:64
//float4 lookupTextureUvMinMax:112
//float4 lookupTextureBorderColor:128
//float4 maskTextureSize:144
//float4 maskTextureDims:160
//float4 maskTextureDimsRecip:176
//float4 maskTextureView:192
//float3x3 maskTextureTransform:208
//float4 maskTextureUvMinMax:256
//float4 maskTextureBorderColor:272
//float softSkinRadius:288
//float softSkinIntensity:292
//float teethWhiteningIntensity:296
//float eyeWhiteningIntensity:300
//float sharpenEyeIntensity:304
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 lookupTextureSize;
float4 lookupTextureDims;
float4 lookupTextureDimsRecip;
float4 lookupTextureView;
float3x3 lookupTextureTransform;
float4 lookupTextureUvMinMax;
float4 lookupTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureDimsRecip;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float softSkinRadius;
float softSkinIntensity;
float teethWhiteningIntensity;
float eyeWhiteningIntensity;
float sharpenEyeIntensity;
};

#ifndef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 0
#elif lookupTextureHasSwappedViews==1
#undef lookupTextureHasSwappedViews
#define lookupTextureHasSwappedViews 1
#endif
#ifndef lookupTextureLayout
#define lookupTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 0
#elif SC_USE_UV_TRANSFORM_lookupTexture==1
#undef SC_USE_UV_TRANSFORM_lookupTexture
#define SC_USE_UV_TRANSFORM_lookupTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_U_lookupTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_lookupTexture
#define SC_SOFTWARE_WRAP_MODE_V_lookupTexture -1
#endif
constant int2 _2337=int2(SC_SOFTWARE_WRAP_MODE_U_lookupTexture,SC_SOFTWARE_WRAP_MODE_V_lookupTexture);
#ifndef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 0
#elif SC_USE_UV_MIN_MAX_lookupTexture==1
#undef SC_USE_UV_MIN_MAX_lookupTexture
#define SC_USE_UV_MIN_MAX_lookupTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 0
#elif SC_USE_CLAMP_TO_BORDER_lookupTexture==1
#undef SC_USE_CLAMP_TO_BORDER_lookupTexture
#define SC_USE_CLAMP_TO_BORDER_lookupTexture 1
#endif
constant int2 _2371=int2(SC_SOFTWARE_WRAP_MODE_U_lookupTexture,SC_SOFTWARE_WRAP_MODE_V_lookupTexture);
constant int2 _2406=int2(SC_SOFTWARE_WRAP_MODE_U_lookupTexture,SC_SOFTWARE_WRAP_MODE_V_lookupTexture);
constant int2 _2435=int2(SC_SOFTWARE_WRAP_MODE_U_lookupTexture,SC_SOFTWARE_WRAP_MODE_V_lookupTexture);
#ifndef ADD_NOISE
#define ADD_NOISE 1
#elif ADD_NOISE==1
#undef ADD_NOISE
#define ADD_NOISE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
constant int2 _2674=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
constant int2 _2703=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SOFT_SKIN
#define SOFT_SKIN 0
#elif SOFT_SKIN==1
#undef SOFT_SKIN
#define SOFT_SKIN 1
#endif
#ifndef EYE_SHARPEN
#define EYE_SHARPEN 0
#elif EYE_SHARPEN==1
#undef EYE_SHARPEN
#define EYE_SHARPEN 1
#endif
#ifndef EYE_WHITENING
#define EYE_WHITENING 0
#elif EYE_WHITENING==1
#undef EYE_WHITENING
#define EYE_WHITENING 1
#endif
#ifndef TEETH_WHITENING
#define TEETH_WHITENING 0
#elif TEETH_WHITENING==1
#undef TEETH_WHITENING
#define TEETH_WHITENING 1
#endif
#ifndef lookupTextureUV
#define lookupTextureUV 0
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float4 varCustomTex0 [[user(locn10)]];
float4 varCustomTex1 [[user(locn11)]];
float4 varCustomTex2 [[user(locn12)]];
float4 varCustomTex3 [[user(locn13)]];
};

float2 maskTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.maskTextureDims.xy;
}

int maskTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (maskTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float getLuminance(thread const float4& color)
{
return dot(color,float4(0.299,0.587,0.114,0.0));
}

float4 getLuminance4(thread const float4x4& color)
{
return float4(0.299,0.587,0.114,0.0)*color;
}

float4 getWeight(thread const float& intens,thread const float4& nextIntens,constant UserUniforms& userUniformsObj)
{
float4 lg=log(nextIntens/float4(intens+1e-06));
lg*=lg;
return exp(lg*((-1.0)/((2.0*userUniformsObj.softSkinRadius)*userUniformsObj.softSkinRadius)));
}

float rand(thread const float2& co)
{
return fract(sin(dot(co,float2(12.9898,78.233)))*43758.5);
}

float4 softSkin(thread const float4& originalColor,thread const float& factor,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr,constant UserUniforms& userUniformsObj,thread float4& varCustomTex0,thread float4& varCustomTex1,thread float4& varCustomTex2,thread float4& varCustomTex3,thread float4& varPackedTex)
{
float4 screenColor=originalColor;
float4 param=screenColor;
float intens=getLuminance(param);
float sum=1.0;
float2 param_1=varCustomTex0.xy;
float4x4 nextColor;
nextColor[0]=sc_ScreenTextureSampleView(param_1,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float2 param_2=varCustomTex1.xy;
nextColor[1]=sc_ScreenTextureSampleView(param_2,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float2 param_3=varCustomTex2.xy;
nextColor[2]=sc_ScreenTextureSampleView(param_3,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float2 param_4=varCustomTex3.xy;
nextColor[3]=sc_ScreenTextureSampleView(param_4,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float4x4 param_5=nextColor;
float4 nextIntens=getLuminance4(param_5);
float param_6=intens;
float4 param_7=nextIntens;
float4 curr=getWeight(param_6,param_7,userUniformsObj)*0.367879;
sum+=dot(curr,float4(1.0));
screenColor+=(nextColor*curr);
#if (ADD_NOISE)
{
float2 param_8=varPackedTex.xy;
float _noise=(rand(param_8)-0.5)/30.0;
screenColor=(screenColor/float4(sum))+float4(_noise,_noise,_noise,1.0);
}
#else
{
screenColor/=float4(sum);
}
#endif
screenColor=mix(originalColor,screenColor,float4(factor));
return screenColor;
}

float4 sharpen(thread const float4& originalColor,thread const float& factor,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr,thread float4& varCustomTex0,thread float4& varCustomTex1,thread float4& varCustomTex2,thread float4& varCustomTex3)
{
float4 accum=originalColor*5.0;
float2 param=varCustomTex0.zw;
accum-=sc_ScreenTextureSampleView(param,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float2 param_1=varCustomTex1.zw;
accum-=sc_ScreenTextureSampleView(param_1,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float2 param_2=varCustomTex2.zw;
accum-=sc_ScreenTextureSampleView(param_2,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float2 param_3=varCustomTex3.zw;
accum-=sc_ScreenTextureSampleView(param_3,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
float4 result=mix(originalColor,accum,float4(factor));
return fast::clamp(result,float4(0.0),float4(1.0));
}

float2 lookupTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.lookupTextureDims.xy;
}

int lookupTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (lookupTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 mapColor(thread const float4& orgColor,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d_array<float> lookupTextureArrSC,thread const sampler lookupTextureArrSCSmplr,thread texture2d<float> lookupTexture,thread const sampler lookupTextureSmplr)
{
float bValue=(orgColor.z*255.0)/4.0;
float2 mulB=fast::clamp(float2(floor(bValue))+float2(0.0,1.0),float2(0.0),float2(63.0));
float2 row=floor((mulB/float2(8.0))+float2(1e-06));
float4 row_col=float4(row,mulB-(row*8.0));
float4 lookup=((orgColor.yyxx*0.123047)+(row_col*0.125))+float4(0.000976562);
float b1w=bValue-mulB.x;
float3 sampled1=float3(0.0);
float4 lookupTextureSample;
#if (lookupTextureLayout==2)
{
float2 param=lookupTextureGetDims2D(userUniformsObj);
int param_1=lookupTextureLayout;
int param_2=lookupTextureGetStereoViewIndex(varStereoViewID);
float2 param_3=float2(lookup.z,1.0-lookup.x);
bool param_4=(int(SC_USE_UV_TRANSFORM_lookupTexture)!=0);
float3x3 param_5=userUniformsObj.lookupTextureTransform;
int2 param_6=_2337;
bool param_7=(int(SC_USE_UV_MIN_MAX_lookupTexture)!=0);
float4 param_8=userUniformsObj.lookupTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_lookupTexture)!=0);
float4 param_10=userUniformsObj.lookupTextureBorderColor;
float param_11=0.0;
lookupTextureSample=sc_SampleTexture(lookupTextureArrSC,lookupTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=lookupTextureGetDims2D(userUniformsObj);
int param_13=lookupTextureLayout;
int param_14=lookupTextureGetStereoViewIndex(varStereoViewID);
float2 param_15=float2(lookup.z,1.0-lookup.x);
bool param_16=(int(SC_USE_UV_TRANSFORM_lookupTexture)!=0);
float3x3 param_17=userUniformsObj.lookupTextureTransform;
int2 param_18=_2371;
bool param_19=(int(SC_USE_UV_MIN_MAX_lookupTexture)!=0);
float4 param_20=userUniformsObj.lookupTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_lookupTexture)!=0);
float4 param_22=userUniformsObj.lookupTextureBorderColor;
float param_23=0.0;
lookupTextureSample=sc_SampleTexture(lookupTexture,lookupTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
sampled1=lookupTextureSample.xyz;
float3 sampled2=float3(0.0);
float4 lookupTextureSample_1;
#if (lookupTextureLayout==2)
{
float2 param_24=lookupTextureGetDims2D(userUniformsObj);
int param_25=lookupTextureLayout;
int param_26=lookupTextureGetStereoViewIndex(varStereoViewID);
float2 param_27=float2(lookup.w,1.0-lookup.y);
bool param_28=(int(SC_USE_UV_TRANSFORM_lookupTexture)!=0);
float3x3 param_29=userUniformsObj.lookupTextureTransform;
int2 param_30=_2406;
bool param_31=(int(SC_USE_UV_MIN_MAX_lookupTexture)!=0);
float4 param_32=userUniformsObj.lookupTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_lookupTexture)!=0);
float4 param_34=userUniformsObj.lookupTextureBorderColor;
float param_35=0.0;
lookupTextureSample_1=sc_SampleTexture(lookupTextureArrSC,lookupTextureArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=lookupTextureGetDims2D(userUniformsObj);
int param_37=lookupTextureLayout;
int param_38=lookupTextureGetStereoViewIndex(varStereoViewID);
float2 param_39=float2(lookup.w,1.0-lookup.y);
bool param_40=(int(SC_USE_UV_TRANSFORM_lookupTexture)!=0);
float3x3 param_41=userUniformsObj.lookupTextureTransform;
int2 param_42=_2435;
bool param_43=(int(SC_USE_UV_MIN_MAX_lookupTexture)!=0);
float4 param_44=userUniformsObj.lookupTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_lookupTexture)!=0);
float4 param_46=userUniformsObj.lookupTextureBorderColor;
float param_47=0.0;
lookupTextureSample_1=sc_SampleTexture(lookupTexture,lookupTextureSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
sampled2=lookupTextureSample_1.xyz;
float3 res=mix(sampled1,sampled2,float3(b1w));
return float4(res,orgColor.w);
}

float4 whitening(thread const float4& originalColor,thread const float& factor,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d_array<float> lookupTextureArrSC,thread const sampler lookupTextureArrSCSmplr,thread texture2d<float> lookupTexture,thread const sampler lookupTextureSmplr)
{
float4 param=originalColor;
float4 color=mapColor(param,varStereoViewID,userUniformsObj,lookupTextureArrSC,lookupTextureArrSCSmplr,lookupTexture,lookupTextureSmplr);
return mix(originalColor,color,float4(factor));
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],texture2d<float> sc_ScreenTexture [[texture(0)]],texture2d_array<float> sc_ScreenTextureArrSC [[texture(1)]],texture2d<float> lookupTexture [[texture(2)]],texture2d_array<float> lookupTextureArrSC [[texture(3)]],texture2d<float> maskTexture [[texture(4)]],texture2d_array<float> maskTextureArrSC [[texture(5)]],sampler sc_ScreenTextureSmplr [[sampler(0)]],sampler sc_ScreenTextureArrSCSmplr [[sampler(1)]],sampler lookupTextureSmplr [[sampler(2)]],sampler lookupTextureArrSCSmplr [[sampler(3)]],sampler maskTextureSmplr [[sampler(4)]],sampler maskTextureArrSCSmplr [[sampler(5)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 originalColor=getFramebufferColor(in.varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr,FragColor,gl_FragCoord);
float4 res=originalColor;
float4 maskColor=float4(0.0);
float whiteningAlpha=0.0;
float4 maskTextureSample;
#if (maskTextureLayout==2)
{
float2 param=maskTextureGetDims2D(userUniformsObj);
int param_1=maskTextureLayout;
int param_2=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.zw;
bool param_4=(int(SC_USE_UV_TRANSFORM_maskTexture)!=0);
float3x3 param_5=userUniformsObj.maskTextureTransform;
int2 param_6=_2674;
bool param_7=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_8=userUniformsObj.maskTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_10=userUniformsObj.maskTextureBorderColor;
float param_11=0.0;
maskTextureSample=sc_SampleTexture(maskTextureArrSC,maskTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=maskTextureGetDims2D(userUniformsObj);
int param_13=maskTextureLayout;
int param_14=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.zw;
bool param_16=(int(SC_USE_UV_TRANSFORM_maskTexture)!=0);
float3x3 param_17=userUniformsObj.maskTextureTransform;
int2 param_18=_2703;
bool param_19=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_20=userUniformsObj.maskTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_22=userUniformsObj.maskTextureBorderColor;
float param_23=0.0;
maskTextureSample=sc_SampleTexture(maskTexture,maskTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
maskColor=maskTextureSample;
#if (SOFT_SKIN)
{
float4 param_24=res;
float param_25=maskColor.x*userUniformsObj.softSkinIntensity;
res=softSkin(param_24,param_25,in.varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr,userUniformsObj,in.varCustomTex0,in.varCustomTex1,in.varCustomTex2,in.varCustomTex3,in.varPackedTex);
}
#endif
#if (EYE_SHARPEN)
{
float4 param_26=res;
float param_27=maskColor.z*userUniformsObj.sharpenEyeIntensity;
res=sharpen(param_26,param_27,in.varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr,in.varCustomTex0,in.varCustomTex1,in.varCustomTex2,in.varCustomTex3);
}
#endif
#if (EYE_WHITENING)
{
whiteningAlpha+=(maskColor.z*userUniformsObj.eyeWhiteningIntensity);
}
#endif
#if (TEETH_WHITENING)
{
whiteningAlpha+=(maskColor.y*userUniformsObj.teethWhiteningIntensity);
}
#endif
#if (EYE_WHITENING||TEETH_WHITENING)
{
float4 param_28=res;
float param_29=whiteningAlpha;
res=whitening(param_28,param_29,in.varStereoViewID,userUniformsObj,lookupTextureArrSC,lookupTextureArrSCSmplr,lookupTexture,lookupTextureSmplr);
}
#endif
float4 param_30=res;
sc_writeFragData0(param_30,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
