#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:552 {
//float4 screenTextureSize:0
//float4 screenTextureDims:16
//float4 screenTextureDimsRecip:32
//float4 screenTextureView:48
//float3x3 screenTextureTransform:64
//float4 screenTextureUvMinMax:112
//float4 screenTextureBorderColor:128
//float screenTextureLOD:144
//float3x3 meshTransform:160
//float3x3 meshTransformR:208
//float4 inputTextureSize:256
//float4 inputTextureDims:272
//float4 inputTextureDimsRecip:288
//float4 inputTextureView:304
//float3x3 inputTextureTransform:320
//float4 inputTextureUvMinMax:368
//float4 inputTextureBorderColor:384
//float4 inputTextureWarpSize:400
//float4 inputTextureWarpDims:416
//float4 inputTextureWarpDimsRecip:432
//float4 inputTextureWarpView:448
//float3x3 inputTextureWarpTransform:464
//float4 inputTextureWarpUvMinMax:512
//float4 inputTextureWarpBorderColor:528
//float2 inputDenorm:544
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 screenTextureSize;
float4 screenTextureDims;
float4 screenTextureDimsRecip;
float4 screenTextureView;
float3x3 screenTextureTransform;
float4 screenTextureUvMinMax;
float4 screenTextureBorderColor;
float screenTextureLOD;
float3x3 meshTransform;
float3x3 meshTransformR;
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureDimsRecip;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 inputTextureWarpSize;
float4 inputTextureWarpDims;
float4 inputTextureWarpDimsRecip;
float4 inputTextureWarpView;
float3x3 inputTextureWarpTransform;
float4 inputTextureWarpUvMinMax;
float4 inputTextureWarpBorderColor;
float2 inputDenorm;
};

#ifndef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 0
#elif screenTextureHasSwappedViews==1
#undef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 1
#endif
#ifndef screenTextureLayout
#define screenTextureLayout 0
#endif
#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef inputTextureWarpHasSwappedViews
#define inputTextureWarpHasSwappedViews 0
#elif inputTextureWarpHasSwappedViews==1
#undef inputTextureWarpHasSwappedViews
#define inputTextureWarpHasSwappedViews 1
#endif
#ifndef inputTextureWarpLayout
#define inputTextureWarpLayout 0
#endif
#ifndef ENABLE_WARP
#define ENABLE_WARP 0
#elif ENABLE_WARP==1
#undef ENABLE_WARP
#define ENABLE_WARP 1
#endif
#ifndef USE_FLOAT_WARP
#define USE_FLOAT_WARP 0
#elif USE_FLOAT_WARP==1
#undef USE_FLOAT_WARP
#define USE_FLOAT_WARP 1
#endif
#ifndef screenTextureUV
#define screenTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 0
#elif SC_USE_UV_TRANSFORM_screenTexture==1
#undef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_screenTexture
#define SC_SOFTWARE_WRAP_MODE_U_screenTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_screenTexture
#define SC_SOFTWARE_WRAP_MODE_V_screenTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 0
#elif SC_USE_UV_MIN_MAX_screenTexture==1
#undef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 0
#elif SC_USE_CLAMP_TO_BORDER_screenTexture==1
#undef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 1
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef inputTextureWarpUV
#define inputTextureWarpUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTextureWarp
#define SC_USE_UV_TRANSFORM_inputTextureWarp 0
#elif SC_USE_UV_TRANSFORM_inputTextureWarp==1
#undef SC_USE_UV_TRANSFORM_inputTextureWarp
#define SC_USE_UV_TRANSFORM_inputTextureWarp 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTextureWarp
#define SC_SOFTWARE_WRAP_MODE_U_inputTextureWarp -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTextureWarp
#define SC_SOFTWARE_WRAP_MODE_V_inputTextureWarp -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTextureWarp
#define SC_USE_UV_MIN_MAX_inputTextureWarp 0
#elif SC_USE_UV_MIN_MAX_inputTextureWarp==1
#undef SC_USE_UV_MIN_MAX_inputTextureWarp
#define SC_USE_UV_MIN_MAX_inputTextureWarp 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTextureWarp
#define SC_USE_CLAMP_TO_BORDER_inputTextureWarp 0
#elif SC_USE_CLAMP_TO_BORDER_inputTextureWarp==1
#undef SC_USE_CLAMP_TO_BORDER_inputTextureWarp
#define SC_USE_CLAMP_TO_BORDER_inputTextureWarp 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float3 texPos=float3((v.position.xy*0.5)+float2(0.5),1.0);
float2 _2672=float2((userUniformsObj.inputTextureTransform*texPos).xy);
out.varPackedTex=float4(_2672.x,_2672.y,out.varPackedTex.z,out.varPackedTex.w);
float2 _2687=float2((userUniformsObj.meshTransform*float3(v.position.xy,1.0)).xy);
v.position=float4(_2687.x,_2687.y,v.position.z,v.position.w);
v.position=float4(v.position.x,v.position.y,float2(0.0,1.0).x,float2(0.0,1.0).y);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:552 {
//float4 screenTextureSize:0
//float4 screenTextureDims:16
//float4 screenTextureDimsRecip:32
//float4 screenTextureView:48
//float3x3 screenTextureTransform:64
//float4 screenTextureUvMinMax:112
//float4 screenTextureBorderColor:128
//float screenTextureLOD:144
//float3x3 meshTransform:160
//float3x3 meshTransformR:208
//float4 inputTextureSize:256
//float4 inputTextureDims:272
//float4 inputTextureDimsRecip:288
//float4 inputTextureView:304
//float3x3 inputTextureTransform:320
//float4 inputTextureUvMinMax:368
//float4 inputTextureBorderColor:384
//float4 inputTextureWarpSize:400
//float4 inputTextureWarpDims:416
//float4 inputTextureWarpDimsRecip:432
//float4 inputTextureWarpView:448
//float3x3 inputTextureWarpTransform:464
//float4 inputTextureWarpUvMinMax:512
//float4 inputTextureWarpBorderColor:528
//float2 inputDenorm:544
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 screenTextureSize;
float4 screenTextureDims;
float4 screenTextureDimsRecip;
float4 screenTextureView;
float3x3 screenTextureTransform;
float4 screenTextureUvMinMax;
float4 screenTextureBorderColor;
float screenTextureLOD;
float3x3 meshTransform;
float3x3 meshTransformR;
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureDimsRecip;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
float4 inputTextureWarpSize;
float4 inputTextureWarpDims;
float4 inputTextureWarpDimsRecip;
float4 inputTextureWarpView;
float3x3 inputTextureWarpTransform;
float4 inputTextureWarpUvMinMax;
float4 inputTextureWarpBorderColor;
float2 inputDenorm;
};

#ifndef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 0
#elif screenTextureHasSwappedViews==1
#undef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 1
#endif
#ifndef screenTextureLayout
#define screenTextureLayout 0
#endif
#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef inputTextureWarpHasSwappedViews
#define inputTextureWarpHasSwappedViews 0
#elif inputTextureWarpHasSwappedViews==1
#undef inputTextureWarpHasSwappedViews
#define inputTextureWarpHasSwappedViews 1
#endif
#ifndef inputTextureWarpLayout
#define inputTextureWarpLayout 0
#endif
#ifndef ENABLE_WARP
#define ENABLE_WARP 0
#elif ENABLE_WARP==1
#undef ENABLE_WARP
#define ENABLE_WARP 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTextureWarp
#define SC_SOFTWARE_WRAP_MODE_U_inputTextureWarp -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTextureWarp
#define SC_SOFTWARE_WRAP_MODE_V_inputTextureWarp -1
#endif
constant int2 _2453=int2(SC_SOFTWARE_WRAP_MODE_U_inputTextureWarp,SC_SOFTWARE_WRAP_MODE_V_inputTextureWarp);
#ifndef SC_USE_UV_MIN_MAX_inputTextureWarp
#define SC_USE_UV_MIN_MAX_inputTextureWarp 0
#elif SC_USE_UV_MIN_MAX_inputTextureWarp==1
#undef SC_USE_UV_MIN_MAX_inputTextureWarp
#define SC_USE_UV_MIN_MAX_inputTextureWarp 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTextureWarp
#define SC_USE_CLAMP_TO_BORDER_inputTextureWarp 0
#elif SC_USE_CLAMP_TO_BORDER_inputTextureWarp==1
#undef SC_USE_CLAMP_TO_BORDER_inputTextureWarp
#define SC_USE_CLAMP_TO_BORDER_inputTextureWarp 1
#endif
constant int2 _2480=int2(SC_SOFTWARE_WRAP_MODE_U_inputTextureWarp,SC_SOFTWARE_WRAP_MODE_V_inputTextureWarp);
#ifndef USE_FLOAT_WARP
#define USE_FLOAT_WARP 0
#elif USE_FLOAT_WARP==1
#undef USE_FLOAT_WARP
#define USE_FLOAT_WARP 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _2533=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
constant int2 _2559=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_SOFTWARE_WRAP_MODE_U_screenTexture
#define SC_SOFTWARE_WRAP_MODE_U_screenTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_screenTexture
#define SC_SOFTWARE_WRAP_MODE_V_screenTexture -1
#endif
constant int2 _2607=int2(SC_SOFTWARE_WRAP_MODE_U_screenTexture,SC_SOFTWARE_WRAP_MODE_V_screenTexture);
#ifndef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 0
#elif SC_USE_UV_MIN_MAX_screenTexture==1
#undef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 0
#elif SC_USE_CLAMP_TO_BORDER_screenTexture==1
#undef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 1
#endif
constant int2 _2636=int2(SC_SOFTWARE_WRAP_MODE_U_screenTexture,SC_SOFTWARE_WRAP_MODE_V_screenTexture);
#ifndef screenTextureUV
#define screenTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 0
#elif SC_USE_UV_TRANSFORM_screenTexture==1
#undef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 1
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef inputTextureWarpUV
#define inputTextureWarpUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTextureWarp
#define SC_USE_UV_TRANSFORM_inputTextureWarp 0
#elif SC_USE_UV_TRANSFORM_inputTextureWarp==1
#undef SC_USE_UV_TRANSFORM_inputTextureWarp
#define SC_USE_UV_TRANSFORM_inputTextureWarp 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

float2 inputTextureWarpGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureWarpDims.xy;
}

int inputTextureWarpGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureWarpHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 screenTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.screenTextureDims.xy;
}

int screenTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (screenTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> screenTexture [[texture(0)]],texture2d_array<float> screenTextureArrSC [[texture(1)]],texture2d<float> inputTexture [[texture(2)]],texture2d_array<float> inputTextureArrSC [[texture(3)]],texture2d<float> inputTextureWarp [[texture(4)]],texture2d_array<float> inputTextureWarpArrSC [[texture(5)]],sampler screenTextureSmplr [[sampler(0)]],sampler screenTextureArrSCSmplr [[sampler(1)]],sampler inputTextureSmplr [[sampler(2)]],sampler inputTextureArrSCSmplr [[sampler(3)]],sampler inputTextureWarpSmplr [[sampler(4)]],sampler inputTextureWarpArrSCSmplr [[sampler(5)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float2 texCoords=float2(0.0);
#if (ENABLE_WARP)
{
float4 inputTextureWarpSample;
#if (inputTextureWarpLayout==2)
{
float2 param=inputTextureWarpGetDims2D(userUniformsObj);
int param_1=inputTextureWarpLayout;
int param_2=inputTextureWarpGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=false;
float3x3 param_5=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_6=_2453;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTextureWarp)!=0);
float4 param_8=userUniformsObj.inputTextureWarpUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTextureWarp)!=0);
float4 param_10=userUniformsObj.inputTextureWarpBorderColor;
float param_11=0.0;
inputTextureWarpSample=sc_SampleTexture(inputTextureWarpArrSC,inputTextureWarpArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=inputTextureWarpGetDims2D(userUniformsObj);
int param_13=inputTextureWarpLayout;
int param_14=inputTextureWarpGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=false;
float3x3 param_17=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_18=_2480;
bool param_19=(int(SC_USE_UV_MIN_MAX_inputTextureWarp)!=0);
float4 param_20=userUniformsObj.inputTextureWarpUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_inputTextureWarp)!=0);
float4 param_22=userUniformsObj.inputTextureWarpBorderColor;
float param_23=0.0;
inputTextureWarpSample=sc_SampleTexture(inputTextureWarp,inputTextureWarpSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
float4 texWarpColor=inputTextureWarpSample;
float2 warp=float2(0.0);
#if (USE_FLOAT_WARP)
{
warp=texWarpColor.xy/float2(2.0);
}
#else
{
warp=(texWarpColor.xy-float2(0.5))/float2(4.0);
}
#endif
texCoords=in.varPackedTex.xy+warp;
}
#else
{
texCoords=in.varPackedTex.xy;
}
#endif
float4 inputTextureSample;
#if (inputTextureLayout==2)
{
float2 param_24=inputTextureGetDims2D(userUniformsObj);
int param_25=inputTextureLayout;
int param_26=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=texCoords;
bool param_28=false;
float3x3 param_29=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_30=_2533;
bool param_31=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_32=userUniformsObj.inputTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_34=userUniformsObj.inputTextureBorderColor;
float param_35=0.0;
inputTextureSample=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=inputTextureGetDims2D(userUniformsObj);
int param_37=inputTextureLayout;
int param_38=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_39=texCoords;
bool param_40=false;
float3x3 param_41=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_42=_2559;
bool param_43=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_44=userUniformsObj.inputTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_46=userUniformsObj.inputTextureBorderColor;
float param_47=0.0;
inputTextureSample=sc_SampleTexture(inputTexture,inputTextureSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
float4 infColor=(inputTextureSample-float4(userUniformsObj.inputDenorm.y))*userUniformsObj.inputDenorm.x;
float2 scrCoords=(userUniformsObj.meshTransformR*float3(texCoords,1.0)).xy;
float4 screenTextureSample;
#if (screenTextureLayout==2)
{
float2 param_48=screenTextureGetDims2D(userUniformsObj);
int param_49=screenTextureLayout;
int param_50=screenTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_51=scrCoords;
bool param_52=false;
float3x3 param_53=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_54=_2607;
bool param_55=(int(SC_USE_UV_MIN_MAX_screenTexture)!=0);
float4 param_56=userUniformsObj.screenTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_screenTexture)!=0);
float4 param_58=userUniformsObj.screenTextureBorderColor;
float param_59=userUniformsObj.screenTextureLOD;
screenTextureSample=sc_SampleTexture(screenTextureArrSC,screenTextureArrSCSmplr,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
}
#else
{
float2 param_60=screenTextureGetDims2D(userUniformsObj);
int param_61=screenTextureLayout;
int param_62=screenTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_63=scrCoords;
bool param_64=false;
float3x3 param_65=float3x3(float3(1.0,0.0,0.0),float3(0.0,1.0,0.0),float3(0.0,0.0,1.0));
int2 param_66=_2636;
bool param_67=(int(SC_USE_UV_MIN_MAX_screenTexture)!=0);
float4 param_68=userUniformsObj.screenTextureUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_screenTexture)!=0);
float4 param_70=userUniformsObj.screenTextureBorderColor;
float param_71=userUniformsObj.screenTextureLOD;
screenTextureSample=sc_SampleTexture(screenTexture,screenTextureSmplr,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
}
#endif
float4 screenTextureColor=screenTextureSample;
float4 param_72=float4((screenTextureColor.xyz*(1.0-infColor.w))+infColor.xyz,1.0);
sc_writeFragData0(param_72,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
