#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "required2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:208 {
//float3x3 meshTransform:0
//float screenTextureBias:48
//float screenTextureLevel:52
//float4 screenTextureSize:64
//float4 screenTextureDims:80
//float4 screenTextureDimsRecip:96
//float4 screenTextureView:112
//float3x3 screenTextureTransform:128
//float4 screenTextureUvMinMax:176
//float4 screenTextureBorderColor:192
//}
//SG_REFLECTION_END


struct UserUniforms
{
float3x3 meshTransform;
float screenTextureBias;
float screenTextureLevel;
float4 screenTextureSize;
float4 screenTextureDims;
float4 screenTextureDimsRecip;
float4 screenTextureView;
float3x3 screenTextureTransform;
float4 screenTextureUvMinMax;
float4 screenTextureBorderColor;
};

#ifndef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 0
#elif screenTextureHasSwappedViews==1
#undef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 1
#endif
#ifndef screenTextureLayout
#define screenTextureLayout 0
#endif
#ifndef ONLY_VERTEX_ATTRIBUTE
#define ONLY_VERTEX_ATTRIBUTE 0
#elif ONLY_VERTEX_ATTRIBUTE==1
#undef ONLY_VERTEX_ATTRIBUTE
#define ONLY_VERTEX_ATTRIBUTE 1
#endif
#ifndef USE_MESH_TRANSFORM
#define USE_MESH_TRANSFORM 0
#elif USE_MESH_TRANSFORM==1
#undef USE_MESH_TRANSFORM
#define USE_MESH_TRANSFORM 1
#endif
#ifndef USE_MIP_BIAS
#define USE_MIP_BIAS 0
#elif USE_MIP_BIAS==1
#undef USE_MIP_BIAS
#define USE_MIP_BIAS 1
#endif
#ifndef SWAP_R_B_CHANNELS
#define SWAP_R_B_CHANNELS 0
#elif SWAP_R_B_CHANNELS==1
#undef SWAP_R_B_CHANNELS
#define SWAP_R_B_CHANNELS 1
#endif
#ifndef GRAYSCALE_AS_ALPHA
#define GRAYSCALE_AS_ALPHA 0
#elif GRAYSCALE_AS_ALPHA==1
#undef GRAYSCALE_AS_ALPHA
#define GRAYSCALE_AS_ALPHA 1
#endif
#ifndef screenTextureUV
#define screenTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 0
#elif SC_USE_UV_TRANSFORM_screenTexture==1
#undef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_screenTexture
#define SC_SOFTWARE_WRAP_MODE_U_screenTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_screenTexture
#define SC_SOFTWARE_WRAP_MODE_V_screenTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 0
#elif SC_USE_UV_MIN_MAX_screenTexture==1
#undef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 0
#elif SC_USE_CLAMP_TO_BORDER_screenTexture==1
#undef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
float2 texture0;
#if (ONLY_VERTEX_ATTRIBUTE)
{
texture0=(v.position.xy+float2(1.0))*0.5;
}
#else
{
texture0=v.texture0;
}
#endif
v.texture0=float2((userUniformsObj.screenTextureTransform*float3(texture0,1.0)).xy);
float2 param=v.texture0;
v.texture0=sc_platformUVFlip(param);
#if (USE_MESH_TRANSFORM)
{
float2 _2353=float2((userUniformsObj.meshTransform*float3(in.position.xy,1.0)).xy);
v.position=float4(_2353.x,_2353.y,v.position.z,v.position.w);
}
#endif
sc_Vertex_t param_1=v;
sc_ProcessVertex(param_1,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:208 {
//float3x3 meshTransform:0
//float screenTextureBias:48
//float screenTextureLevel:52
//float4 screenTextureSize:64
//float4 screenTextureDims:80
//float4 screenTextureDimsRecip:96
//float4 screenTextureView:112
//float3x3 screenTextureTransform:128
//float4 screenTextureUvMinMax:176
//float4 screenTextureBorderColor:192
//}
//SG_REFLECTION_END


struct UserUniforms
{
float3x3 meshTransform;
float screenTextureBias;
float screenTextureLevel;
float4 screenTextureSize;
float4 screenTextureDims;
float4 screenTextureDimsRecip;
float4 screenTextureView;
float3x3 screenTextureTransform;
float4 screenTextureUvMinMax;
float4 screenTextureBorderColor;
};

#ifndef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 0
#elif screenTextureHasSwappedViews==1
#undef screenTextureHasSwappedViews
#define screenTextureHasSwappedViews 1
#endif
#ifndef screenTextureLayout
#define screenTextureLayout 0
#endif
#ifndef USE_MIP_BIAS
#define USE_MIP_BIAS 0
#elif USE_MIP_BIAS==1
#undef USE_MIP_BIAS
#define USE_MIP_BIAS 1
#endif
#ifndef SWAP_R_B_CHANNELS
#define SWAP_R_B_CHANNELS 0
#elif SWAP_R_B_CHANNELS==1
#undef SWAP_R_B_CHANNELS
#define SWAP_R_B_CHANNELS 1
#endif
#ifndef GRAYSCALE_AS_ALPHA
#define GRAYSCALE_AS_ALPHA 0
#elif GRAYSCALE_AS_ALPHA==1
#undef GRAYSCALE_AS_ALPHA
#define GRAYSCALE_AS_ALPHA 1
#endif
#ifndef USE_MESH_TRANSFORM
#define USE_MESH_TRANSFORM 0
#elif USE_MESH_TRANSFORM==1
#undef USE_MESH_TRANSFORM
#define USE_MESH_TRANSFORM 1
#endif
#ifndef ONLY_VERTEX_ATTRIBUTE
#define ONLY_VERTEX_ATTRIBUTE 0
#elif ONLY_VERTEX_ATTRIBUTE==1
#undef ONLY_VERTEX_ATTRIBUTE
#define ONLY_VERTEX_ATTRIBUTE 1
#endif
#ifndef screenTextureUV
#define screenTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 0
#elif SC_USE_UV_TRANSFORM_screenTexture==1
#undef SC_USE_UV_TRANSFORM_screenTexture
#define SC_USE_UV_TRANSFORM_screenTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_screenTexture
#define SC_SOFTWARE_WRAP_MODE_U_screenTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_screenTexture
#define SC_SOFTWARE_WRAP_MODE_V_screenTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 0
#elif SC_USE_UV_MIN_MAX_screenTexture==1
#undef SC_USE_UV_MIN_MAX_screenTexture
#define SC_USE_UV_MIN_MAX_screenTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 0
#elif SC_USE_CLAMP_TO_BORDER_screenTexture==1
#undef SC_USE_CLAMP_TO_BORDER_screenTexture
#define SC_USE_CLAMP_TO_BORDER_screenTexture 1
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
};

int screenTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (screenTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 screenTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.screenTextureDims.xy;
}

float4 screenTextureSampleViewIndexBias(thread const float2& uv,thread const int& viewIndex,thread const float& bias0,constant UserUniforms& userUniformsObj,thread texture2d_array<float> screenTextureArrSC,thread const sampler screenTextureArrSCSmplr,thread texture2d<float> screenTexture,thread const sampler screenTextureSmplr)
{
#if (screenTextureLayout==2)
{
float2 param=screenTextureGetDims2D(userUniformsObj);
float2 param_1=uv;
int param_2=screenTextureLayout;
int param_3=viewIndex;
float param_4=bias0;
return sc_SampleView(screenTextureArrSC,screenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=screenTextureGetDims2D(userUniformsObj);
float2 param_6=uv;
int param_7=screenTextureLayout;
int param_8=viewIndex;
float param_9=bias0;
return sc_SampleView(screenTexture,screenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

float4 screenTextureSampleViewBias(thread const float2& uv,thread const float& bias0,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d_array<float> screenTextureArrSC,thread const sampler screenTextureArrSCSmplr,thread texture2d<float> screenTexture,thread const sampler screenTextureSmplr)
{
float2 param=uv;
int param_1=screenTextureGetStereoViewIndex(varStereoViewID);
float param_2=bias0;
return screenTextureSampleViewIndexBias(param,param_1,param_2,userUniformsObj,screenTextureArrSC,screenTextureArrSCSmplr,screenTexture,screenTextureSmplr);
}

float4 screenTextureSampleViewIndexLevel(thread const float2& uv,thread const int& viewIndex,thread const float& level,constant UserUniforms& userUniformsObj,thread texture2d_array<float> screenTextureArrSC,thread const sampler screenTextureArrSCSmplr,thread texture2d<float> screenTexture,thread const sampler screenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (screenTextureLayout==2)
{
float2 param=screenTextureGetDims2D(userUniformsObj);
float2 param_1=uv;
int param_2=screenTextureLayout;
int param_3=viewIndex;
float param_4=level;
return sc_SampleViewLevel(screenTextureArrSC,screenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=screenTextureGetDims2D(userUniformsObj);
float2 param_6=uv;
int param_7=screenTextureLayout;
int param_8=viewIndex;
float param_9=level;
return sc_SampleViewLevel(screenTexture,screenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 screenTextureSampleViewLevel(thread const float2& uv,thread const float& level,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d_array<float> screenTextureArrSC,thread const sampler screenTextureArrSCSmplr,thread texture2d<float> screenTexture,thread const sampler screenTextureSmplr)
{
float2 param=uv;
int param_1=screenTextureGetStereoViewIndex(varStereoViewID);
float param_2=level;
return screenTextureSampleViewIndexLevel(param,param_1,param_2,userUniformsObj,screenTextureArrSC,screenTextureArrSCSmplr,screenTexture,screenTextureSmplr);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> screenTexture [[texture(0)]],texture2d_array<float> screenTextureArrSC [[texture(1)]],sampler screenTextureSmplr [[sampler(0)]],sampler screenTextureArrSCSmplr [[sampler(1)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 _2035;
#if (USE_MIP_BIAS)
{
float2 param=in.varPackedTex.xy;
float param_1=userUniformsObj.screenTextureBias;
_2035=screenTextureSampleViewBias(param,param_1,in.varStereoViewID,userUniformsObj,screenTextureArrSC,screenTextureArrSCSmplr,screenTexture,screenTextureSmplr);
}
#else
{
float2 param_2=in.varPackedTex.xy;
float param_3=userUniformsObj.screenTextureLevel;
_2035=screenTextureSampleViewLevel(param_2,param_3,in.varStereoViewID,userUniformsObj,screenTextureArrSC,screenTextureArrSCSmplr,screenTexture,screenTextureSmplr);
}
#endif
float4 screenTextureColor=_2035;
#if (SWAP_R_B_CHANNELS)
{
float4 param_4=screenTextureColor.zyxw;
sc_writeFragData0(param_4,FragColor);
}
#else
{
#if (GRAYSCALE_AS_ALPHA)
{
float4 param_5=float4(1.0,1.0,1.0,screenTextureColor.x);
sc_writeFragData0(param_5,FragColor);
}
#else
{
float4 param_6=screenTextureColor;
sc_writeFragData0(param_6,FragColor);
}
#endif
}
#endif
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
