#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_texture.metal"
#include "std2_fs.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:144 {
//float4 inputTextureSize:0
//float4 inputTextureDims:16
//float4 inputTextureDimsRecip:32
//float4 inputTextureView:48
//float3x3 inputTextureTransform:64
//float4 inputTextureUvMinMax:112
//float4 inputTextureBorderColor:128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureDimsRecip;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef inputTextureUV
#define inputTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
#ifndef SMAA_QUALITY
#define SMAA_QUALITY 0
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float2 varTexCoords [[user(locn10)]];
float4 varOffset0 [[user(locn11)]];
float4 varOffset1 [[user(locn12)]];
float4 varOffset2 [[user(locn13)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varTexCoords=(v.position.xy*0.5)+float2(0.5);
float4 smaaRTMetrics=float4(1.0/userUniformsObj.inputTextureSize.x,1.0/userUniformsObj.inputTextureSize.y,userUniformsObj.inputTextureSize.x,userUniformsObj.inputTextureSize.y);
out.varOffset0=(smaaRTMetrics.xyxy*float4(-1.0,0.0,0.0,1.0))+out.varTexCoords.xyxy;
out.varOffset1=(smaaRTMetrics.xyxy*float4(1.0,0.0,0.0,-1.0))+out.varTexCoords.xyxy;
out.varOffset2=(smaaRTMetrics.xyxy*float4(-2.0,0.0,0.0,2.0))+out.varTexCoords.xyxy;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:144 {
//float4 inputTextureSize:0
//float4 inputTextureDims:16
//float4 inputTextureDimsRecip:32
//float4 inputTextureView:48
//float3x3 inputTextureTransform:64
//float4 inputTextureUvMinMax:112
//float4 inputTextureBorderColor:128
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 inputTextureSize;
float4 inputTextureDims;
float4 inputTextureDimsRecip;
float4 inputTextureView;
float3x3 inputTextureTransform;
float4 inputTextureUvMinMax;
float4 inputTextureBorderColor;
};

#ifndef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 0
#elif inputTextureHasSwappedViews==1
#undef inputTextureHasSwappedViews
#define inputTextureHasSwappedViews 1
#endif
#ifndef inputTextureLayout
#define inputTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 0
#elif SC_USE_UV_TRANSFORM_inputTexture==1
#undef SC_USE_UV_TRANSFORM_inputTexture
#define SC_USE_UV_TRANSFORM_inputTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTexture
#define SC_SOFTWARE_WRAP_MODE_U_inputTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTexture
#define SC_SOFTWARE_WRAP_MODE_V_inputTexture -1
#endif
constant int2 _2082=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 0
#elif SC_USE_UV_MIN_MAX_inputTexture==1
#undef SC_USE_UV_MIN_MAX_inputTexture
#define SC_USE_UV_MIN_MAX_inputTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 0
#elif SC_USE_CLAMP_TO_BORDER_inputTexture==1
#undef SC_USE_CLAMP_TO_BORDER_inputTexture
#define SC_USE_CLAMP_TO_BORDER_inputTexture 1
#endif
constant int2 _2111=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2144=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2169=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2202=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2227=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef SMAA_QUALITY
#define SMAA_QUALITY 0
#endif
constant int2 _2290=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2315=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2348=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2373=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2422=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2447=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2480=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
constant int2 _2505=int2(SC_SOFTWARE_WRAP_MODE_U_inputTexture,SC_SOFTWARE_WRAP_MODE_V_inputTexture);
#ifndef inputTextureUV
#define inputTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 varTexCoords [[user(locn10)]];
float4 varOffset0 [[user(locn11)]];
float4 varOffset1 [[user(locn12)]];
float4 varOffset2 [[user(locn13)]];
};

float2 inputTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTextureDims.xy;
}

int inputTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float getThreshHold(thread const int& smaaQuality)
{
if (smaaQuality==0)
{
return 0.15;
}
else
{
if (smaaQuality==1)
{
return 0.1;
}
else
{
if (smaaQuality==2)
{
return 0.1;
}
else
{
if (smaaQuality==3)
{
return 0.05;
}
else
{
return 0.0;
}
}
}
}
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> inputTexture [[texture(0)]],texture2d_array<float> inputTextureArrSC [[texture(1)]],sampler inputTextureSmplr [[sampler(0)]],sampler inputTextureArrSCSmplr [[sampler(1)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float3 weights=float3(0.2126,0.7152,0.0722);
float L=0.0;
float4 inputTextureSample;
#if (inputTextureLayout==2)
{
float2 param=inputTextureGetDims2D(userUniformsObj);
int param_1=inputTextureLayout;
int param_2=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varTexCoords;
bool param_4=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_5=userUniformsObj.inputTextureTransform;
int2 param_6=_2082;
bool param_7=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_8=userUniformsObj.inputTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_10=userUniformsObj.inputTextureBorderColor;
float param_11=0.0;
inputTextureSample=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=inputTextureGetDims2D(userUniformsObj);
int param_13=inputTextureLayout;
int param_14=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varTexCoords;
bool param_16=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_17=userUniformsObj.inputTextureTransform;
int2 param_18=_2111;
bool param_19=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_20=userUniformsObj.inputTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_22=userUniformsObj.inputTextureBorderColor;
float param_23=0.0;
inputTextureSample=sc_SampleTexture(inputTexture,inputTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
L=dot(inputTextureSample.xyz,weights);
float Lleft=0.0;
float4 inputTextureSample_1;
#if (inputTextureLayout==2)
{
float2 param_24=inputTextureGetDims2D(userUniformsObj);
int param_25=inputTextureLayout;
int param_26=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varOffset0.xy;
bool param_28=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_29=userUniformsObj.inputTextureTransform;
int2 param_30=_2144;
bool param_31=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_32=userUniformsObj.inputTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_34=userUniformsObj.inputTextureBorderColor;
float param_35=0.0;
inputTextureSample_1=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=inputTextureGetDims2D(userUniformsObj);
int param_37=inputTextureLayout;
int param_38=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varOffset0.xy;
bool param_40=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_41=userUniformsObj.inputTextureTransform;
int2 param_42=_2169;
bool param_43=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_44=userUniformsObj.inputTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_46=userUniformsObj.inputTextureBorderColor;
float param_47=0.0;
inputTextureSample_1=sc_SampleTexture(inputTexture,inputTextureSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
Lleft=dot(inputTextureSample_1.xyz,weights);
float Ltop=0.0;
float4 inputTextureSample_2;
#if (inputTextureLayout==2)
{
float2 param_48=inputTextureGetDims2D(userUniformsObj);
int param_49=inputTextureLayout;
int param_50=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_51=in.varOffset0.zw;
bool param_52=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_53=userUniformsObj.inputTextureTransform;
int2 param_54=_2202;
bool param_55=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_56=userUniformsObj.inputTextureUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_58=userUniformsObj.inputTextureBorderColor;
float param_59=0.0;
inputTextureSample_2=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
}
#else
{
float2 param_60=inputTextureGetDims2D(userUniformsObj);
int param_61=inputTextureLayout;
int param_62=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_63=in.varOffset0.zw;
bool param_64=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_65=userUniformsObj.inputTextureTransform;
int2 param_66=_2227;
bool param_67=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_68=userUniformsObj.inputTextureUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_70=userUniformsObj.inputTextureBorderColor;
float param_71=0.0;
inputTextureSample_2=sc_SampleTexture(inputTexture,inputTextureSmplr,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
}
#endif
Ltop=dot(inputTextureSample_2.xyz,weights);
float2 _2260=abs(float2(L)-float2(Lleft,Ltop));
float4 delta;
delta=float4(_2260.x,_2260.y,delta.z,delta.w);
int param_72=SMAA_QUALITY;
float2 threshold=float2(getThreshHold(param_72));
float2 edges=step(threshold,delta.xy);
if (dot(edges,float2(1.0))==0.0)
{
float4 param_73=float4(0.0);
sc_writeFragData0(param_73,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
float Lright=0.0;
float4 inputTextureSample_3;
#if (inputTextureLayout==2)
{
float2 param_74=inputTextureGetDims2D(userUniformsObj);
int param_75=inputTextureLayout;
int param_76=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_77=in.varOffset1.xy;
bool param_78=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_79=userUniformsObj.inputTextureTransform;
int2 param_80=_2290;
bool param_81=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_82=userUniformsObj.inputTextureUvMinMax;
bool param_83=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_84=userUniformsObj.inputTextureBorderColor;
float param_85=0.0;
inputTextureSample_3=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83,param_84,param_85);
}
#else
{
float2 param_86=inputTextureGetDims2D(userUniformsObj);
int param_87=inputTextureLayout;
int param_88=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_89=in.varOffset1.xy;
bool param_90=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_91=userUniformsObj.inputTextureTransform;
int2 param_92=_2315;
bool param_93=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_94=userUniformsObj.inputTextureUvMinMax;
bool param_95=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_96=userUniformsObj.inputTextureBorderColor;
float param_97=0.0;
inputTextureSample_3=sc_SampleTexture(inputTexture,inputTextureSmplr,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95,param_96,param_97);
}
#endif
Lright=dot(inputTextureSample_3.xyz,weights);
float Lbottom=0.0;
float4 inputTextureSample_4;
#if (inputTextureLayout==2)
{
float2 param_98=inputTextureGetDims2D(userUniformsObj);
int param_99=inputTextureLayout;
int param_100=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_101=in.varOffset1.zw;
bool param_102=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_103=userUniformsObj.inputTextureTransform;
int2 param_104=_2348;
bool param_105=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_106=userUniformsObj.inputTextureUvMinMax;
bool param_107=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_108=userUniformsObj.inputTextureBorderColor;
float param_109=0.0;
inputTextureSample_4=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106,param_107,param_108,param_109);
}
#else
{
float2 param_110=inputTextureGetDims2D(userUniformsObj);
int param_111=inputTextureLayout;
int param_112=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_113=in.varOffset1.zw;
bool param_114=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_115=userUniformsObj.inputTextureTransform;
int2 param_116=_2373;
bool param_117=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_118=userUniformsObj.inputTextureUvMinMax;
bool param_119=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_120=userUniformsObj.inputTextureBorderColor;
float param_121=0.0;
inputTextureSample_4=sc_SampleTexture(inputTexture,inputTextureSmplr,param_110,param_111,param_112,param_113,param_114,param_115,param_116,param_117,param_118,param_119,param_120,param_121);
}
#endif
Lbottom=dot(inputTextureSample_4.xyz,weights);
float2 _2405=abs(float2(L)-float2(Lright,Lbottom));
delta=float4(delta.x,delta.y,_2405.x,_2405.y);
float2 maxDelta=fast::max(delta.xy,delta.zw);
float Lleftleft=0.0;
float4 inputTextureSample_5;
#if (inputTextureLayout==2)
{
float2 param_122=inputTextureGetDims2D(userUniformsObj);
int param_123=inputTextureLayout;
int param_124=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_125=in.varOffset2.xy;
bool param_126=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_127=userUniformsObj.inputTextureTransform;
int2 param_128=_2422;
bool param_129=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_130=userUniformsObj.inputTextureUvMinMax;
bool param_131=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_132=userUniformsObj.inputTextureBorderColor;
float param_133=0.0;
inputTextureSample_5=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_122,param_123,param_124,param_125,param_126,param_127,param_128,param_129,param_130,param_131,param_132,param_133);
}
#else
{
float2 param_134=inputTextureGetDims2D(userUniformsObj);
int param_135=inputTextureLayout;
int param_136=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_137=in.varOffset2.xy;
bool param_138=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_139=userUniformsObj.inputTextureTransform;
int2 param_140=_2447;
bool param_141=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_142=userUniformsObj.inputTextureUvMinMax;
bool param_143=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_144=userUniformsObj.inputTextureBorderColor;
float param_145=0.0;
inputTextureSample_5=sc_SampleTexture(inputTexture,inputTextureSmplr,param_134,param_135,param_136,param_137,param_138,param_139,param_140,param_141,param_142,param_143,param_144,param_145);
}
#endif
Lleftleft=dot(inputTextureSample_5.xyz,weights);
float Ltoptop=0.0;
float4 inputTextureSample_6;
#if (inputTextureLayout==2)
{
float2 param_146=inputTextureGetDims2D(userUniformsObj);
int param_147=inputTextureLayout;
int param_148=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_149=in.varOffset2.zw;
bool param_150=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_151=userUniformsObj.inputTextureTransform;
int2 param_152=_2480;
bool param_153=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_154=userUniformsObj.inputTextureUvMinMax;
bool param_155=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_156=userUniformsObj.inputTextureBorderColor;
float param_157=0.0;
inputTextureSample_6=sc_SampleTexture(inputTextureArrSC,inputTextureArrSCSmplr,param_146,param_147,param_148,param_149,param_150,param_151,param_152,param_153,param_154,param_155,param_156,param_157);
}
#else
{
float2 param_158=inputTextureGetDims2D(userUniformsObj);
int param_159=inputTextureLayout;
int param_160=inputTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_161=in.varOffset2.zw;
bool param_162=(int(SC_USE_UV_TRANSFORM_inputTexture)!=0);
float3x3 param_163=userUniformsObj.inputTextureTransform;
int2 param_164=_2505;
bool param_165=(int(SC_USE_UV_MIN_MAX_inputTexture)!=0);
float4 param_166=userUniformsObj.inputTextureUvMinMax;
bool param_167=(int(SC_USE_CLAMP_TO_BORDER_inputTexture)!=0);
float4 param_168=userUniformsObj.inputTextureBorderColor;
float param_169=0.0;
inputTextureSample_6=sc_SampleTexture(inputTexture,inputTextureSmplr,param_158,param_159,param_160,param_161,param_162,param_163,param_164,param_165,param_166,param_167,param_168,param_169);
}
#endif
Ltoptop=dot(inputTextureSample_6.xyz,weights);
float2 _2538=abs(float2(Lleft,Ltop)-float2(Lleftleft,Ltoptop));
delta=float4(delta.x,delta.y,_2538.x,_2538.y);
maxDelta=fast::max(maxDelta,delta.zw);
float finalDelta=fast::max(maxDelta.x,maxDelta.y);
edges*=step(float2(finalDelta),delta.xy*2.0);
float4 param_170=float4(edges.x,edges.y,0.0,0.0);
sc_writeFragData0(param_170,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
