#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1
#define STD_DISABLE_VERTEX_TEXTURE0 1
#define STD_DISABLE_VERTEX_TEXTURE1 1

#include "std2.metal"
#include "std2_fs.metal"
#include "std2_texture.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:296 {
//float4 blendTexSize:0
//float4 blendTexDims:16
//float4 blendTexDimsRecip:32
//float4 blendTexView:48
//float3x3 blendTexTransform:64
//float4 blendTexUvMinMax:112
//float4 blendTexBorderColor:128
//float4 inputTexSize:144
//float4 inputTexDims:160
//float4 inputTexDimsRecip:176
//float4 inputTexView:192
//float3x3 inputTexTransform:208
//float4 inputTexUvMinMax:256
//float4 inputTexBorderColor:272
//float2 inputRTSize:288
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 blendTexSize;
float4 blendTexDims;
float4 blendTexDimsRecip;
float4 blendTexView;
float3x3 blendTexTransform;
float4 blendTexUvMinMax;
float4 blendTexBorderColor;
float4 inputTexSize;
float4 inputTexDims;
float4 inputTexDimsRecip;
float4 inputTexView;
float3x3 inputTexTransform;
float4 inputTexUvMinMax;
float4 inputTexBorderColor;
float2 inputRTSize;
};

#ifndef blendTexHasSwappedViews
#define blendTexHasSwappedViews 0
#elif blendTexHasSwappedViews==1
#undef blendTexHasSwappedViews
#define blendTexHasSwappedViews 1
#endif
#ifndef blendTexLayout
#define blendTexLayout 0
#endif
#ifndef inputTexHasSwappedViews
#define inputTexHasSwappedViews 0
#elif inputTexHasSwappedViews==1
#undef inputTexHasSwappedViews
#define inputTexHasSwappedViews 1
#endif
#ifndef inputTexLayout
#define inputTexLayout 0
#endif
#ifndef SMAA_REPROJECTION
#define SMAA_REPROJECTION 0
#elif SMAA_REPROJECTION==1
#undef SMAA_REPROJECTION
#define SMAA_REPROJECTION 1
#endif
#ifndef blendTexUV
#define blendTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 0
#elif SC_USE_UV_TRANSFORM_blendTex==1
#undef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_blendTex
#define SC_SOFTWARE_WRAP_MODE_U_blendTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_blendTex
#define SC_SOFTWARE_WRAP_MODE_V_blendTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 0
#elif SC_USE_UV_MIN_MAX_blendTex==1
#undef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 0
#elif SC_USE_CLAMP_TO_BORDER_blendTex==1
#undef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 1
#endif
#ifndef inputTexUV
#define inputTexUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 0
#elif SC_USE_UV_TRANSFORM_inputTex==1
#undef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTex
#define SC_SOFTWARE_WRAP_MODE_U_inputTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTex
#define SC_SOFTWARE_WRAP_MODE_V_inputTex -1
#endif
#ifndef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 0
#elif SC_USE_UV_MIN_MAX_inputTex==1
#undef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 0
#elif SC_USE_CLAMP_TO_BORDER_inputTex==1
#undef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 smaaRTMetrics [[user(locn10)]];
float2 varTexCoords [[user(locn11)]];
float4 varOffset0 [[user(locn12)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varTexCoords=(v.position.xy*0.5)+float2(0.5);
out.smaaRTMetrics=float4(1.0/userUniformsObj.inputRTSize.x,1.0/userUniformsObj.inputRTSize.y,userUniformsObj.inputRTSize.x,userUniformsObj.inputRTSize.y);
out.varOffset0=(out.smaaRTMetrics.xyxy*float4(1.0,0.0,0.0,-1.0))+out.varTexCoords.xyxy;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:296 {
//float4 blendTexSize:0
//float4 blendTexDims:16
//float4 blendTexDimsRecip:32
//float4 blendTexView:48
//float3x3 blendTexTransform:64
//float4 blendTexUvMinMax:112
//float4 blendTexBorderColor:128
//float4 inputTexSize:144
//float4 inputTexDims:160
//float4 inputTexDimsRecip:176
//float4 inputTexView:192
//float3x3 inputTexTransform:208
//float4 inputTexUvMinMax:256
//float4 inputTexBorderColor:272
//float2 inputRTSize:288
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 blendTexSize;
float4 blendTexDims;
float4 blendTexDimsRecip;
float4 blendTexView;
float3x3 blendTexTransform;
float4 blendTexUvMinMax;
float4 blendTexBorderColor;
float4 inputTexSize;
float4 inputTexDims;
float4 inputTexDimsRecip;
float4 inputTexView;
float3x3 inputTexTransform;
float4 inputTexUvMinMax;
float4 inputTexBorderColor;
float2 inputRTSize;
};

#ifndef blendTexHasSwappedViews
#define blendTexHasSwappedViews 0
#elif blendTexHasSwappedViews==1
#undef blendTexHasSwappedViews
#define blendTexHasSwappedViews 1
#endif
#ifndef blendTexLayout
#define blendTexLayout 0
#endif
#ifndef inputTexHasSwappedViews
#define inputTexHasSwappedViews 0
#elif inputTexHasSwappedViews==1
#undef inputTexHasSwappedViews
#define inputTexHasSwappedViews 1
#endif
#ifndef inputTexLayout
#define inputTexLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 0
#elif SC_USE_UV_TRANSFORM_blendTex==1
#undef SC_USE_UV_TRANSFORM_blendTex
#define SC_USE_UV_TRANSFORM_blendTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_blendTex
#define SC_SOFTWARE_WRAP_MODE_U_blendTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_blendTex
#define SC_SOFTWARE_WRAP_MODE_V_blendTex -1
#endif
constant int2 _2300=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
#ifndef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 0
#elif SC_USE_UV_MIN_MAX_blendTex==1
#undef SC_USE_UV_MIN_MAX_blendTex
#define SC_USE_UV_MIN_MAX_blendTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 0
#elif SC_USE_CLAMP_TO_BORDER_blendTex==1
#undef SC_USE_CLAMP_TO_BORDER_blendTex
#define SC_USE_CLAMP_TO_BORDER_blendTex 1
#endif
constant int2 _2330=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
constant int2 _2361=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
constant int2 _2386=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
constant int2 _2418=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
constant int2 _2442=int2(SC_SOFTWARE_WRAP_MODE_U_blendTex,SC_SOFTWARE_WRAP_MODE_V_blendTex);
#ifndef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 0
#elif SC_USE_UV_TRANSFORM_inputTex==1
#undef SC_USE_UV_TRANSFORM_inputTex
#define SC_USE_UV_TRANSFORM_inputTex 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_inputTex
#define SC_SOFTWARE_WRAP_MODE_U_inputTex -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_inputTex
#define SC_SOFTWARE_WRAP_MODE_V_inputTex -1
#endif
constant int2 _2483=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
#ifndef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 0
#elif SC_USE_UV_MIN_MAX_inputTex==1
#undef SC_USE_UV_MIN_MAX_inputTex
#define SC_USE_UV_MIN_MAX_inputTex 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 0
#elif SC_USE_CLAMP_TO_BORDER_inputTex==1
#undef SC_USE_CLAMP_TO_BORDER_inputTex
#define SC_USE_CLAMP_TO_BORDER_inputTex 1
#endif
constant int2 _2511=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
#ifndef SMAA_REPROJECTION
#define SMAA_REPROJECTION 0
#elif SMAA_REPROJECTION==1
#undef SMAA_REPROJECTION
#define SMAA_REPROJECTION 1
#endif
constant int2 _2616=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
constant int2 _2641=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
constant int2 _2673=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
constant int2 _2698=int2(SC_SOFTWARE_WRAP_MODE_U_inputTex,SC_SOFTWARE_WRAP_MODE_V_inputTex);
#ifndef blendTexUV
#define blendTexUV 0
#endif
#ifndef inputTexUV
#define inputTexUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 smaaRTMetrics [[user(locn10)]];
float2 varTexCoords [[user(locn11)]];
float4 varOffset0 [[user(locn12)]];
};

float2 blendTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.blendTexDims.xy;
}

int blendTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (blendTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 inputTexGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.inputTexDims.xy;
}

int inputTexGetStereoViewIndex(thread int& varStereoViewID)
{
#if (inputTexHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

void SMAAMovc(thread const float2& cond,thread float2& variable,thread const float2& value)
{
if (cond.x>0.0)
{
variable.x=value.x;
}
if (cond.y>0.0)
{
variable.y=value.y;
}
}

void SMAAMovc(thread const float4& cond,thread float4& variable,thread const float4& value)
{
float2 param=cond.xy;
float2 param_1=variable.xy;
float2 param_2=value.xy;
SMAAMovc(param,param_1,param_2);
variable=float4(param_1.x,param_1.y,variable.z,variable.w);
float2 param_3=cond.zw;
float2 param_4=variable.zw;
float2 param_5=value.zw;
SMAAMovc(param_3,param_4,param_5);
variable=float4(variable.x,variable.y,param_4.x,param_4.y);
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> blendTex [[texture(0)]],texture2d_array<float> blendTexArrSC [[texture(1)]],texture2d<float> inputTex [[texture(2)]],texture2d_array<float> inputTexArrSC [[texture(3)]],sampler blendTexSmplr [[sampler(0)]],sampler blendTexArrSCSmplr [[sampler(1)]],sampler inputTexSmplr [[sampler(2)]],sampler inputTexArrSCSmplr [[sampler(3)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 a=float4(0.0);
float4 color=float4(0.0);
float4 blendTexSample;
#if (blendTexLayout==2)
{
float2 param=blendTexGetDims2D(userUniformsObj);
int param_1=blendTexLayout;
int param_2=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varOffset0.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_5=userUniformsObj.blendTexTransform;
int2 param_6=_2300;
bool param_7=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_8=userUniformsObj.blendTexUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_10=userUniformsObj.blendTexBorderColor;
float param_11=0.0;
blendTexSample=sc_SampleTexture(blendTexArrSC,blendTexArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=blendTexGetDims2D(userUniformsObj);
int param_13=blendTexLayout;
int param_14=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varOffset0.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_17=userUniformsObj.blendTexTransform;
int2 param_18=_2330;
bool param_19=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_20=userUniformsObj.blendTexUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_22=userUniformsObj.blendTexBorderColor;
float param_23=0.0;
blendTexSample=sc_SampleTexture(blendTex,blendTexSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
a.x=blendTexSample.w;
float4 blendTexSample_1;
#if (blendTexLayout==2)
{
float2 param_24=blendTexGetDims2D(userUniformsObj);
int param_25=blendTexLayout;
int param_26=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varOffset0.zw;
bool param_28=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_29=userUniformsObj.blendTexTransform;
int2 param_30=_2361;
bool param_31=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_32=userUniformsObj.blendTexUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_34=userUniformsObj.blendTexBorderColor;
float param_35=0.0;
blendTexSample_1=sc_SampleTexture(blendTexArrSC,blendTexArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=blendTexGetDims2D(userUniformsObj);
int param_37=blendTexLayout;
int param_38=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varOffset0.zw;
bool param_40=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_41=userUniformsObj.blendTexTransform;
int2 param_42=_2386;
bool param_43=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_44=userUniformsObj.blendTexUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_46=userUniformsObj.blendTexBorderColor;
float param_47=0.0;
blendTexSample_1=sc_SampleTexture(blendTex,blendTexSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
a.y=blendTexSample_1.y;
float4 blendTexSample_2;
#if (blendTexLayout==2)
{
float2 param_48=blendTexGetDims2D(userUniformsObj);
int param_49=blendTexLayout;
int param_50=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_51=in.varTexCoords;
bool param_52=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_53=userUniformsObj.blendTexTransform;
int2 param_54=_2418;
bool param_55=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_56=userUniformsObj.blendTexUvMinMax;
bool param_57=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_58=userUniformsObj.blendTexBorderColor;
float param_59=0.0;
blendTexSample_2=sc_SampleTexture(blendTexArrSC,blendTexArrSCSmplr,param_48,param_49,param_50,param_51,param_52,param_53,param_54,param_55,param_56,param_57,param_58,param_59);
}
#else
{
float2 param_60=blendTexGetDims2D(userUniformsObj);
int param_61=blendTexLayout;
int param_62=blendTexGetStereoViewIndex(in.varStereoViewID);
float2 param_63=in.varTexCoords;
bool param_64=(int(SC_USE_UV_TRANSFORM_blendTex)!=0);
float3x3 param_65=userUniformsObj.blendTexTransform;
int2 param_66=_2442;
bool param_67=(int(SC_USE_UV_MIN_MAX_blendTex)!=0);
float4 param_68=userUniformsObj.blendTexUvMinMax;
bool param_69=(int(SC_USE_CLAMP_TO_BORDER_blendTex)!=0);
float4 param_70=userUniformsObj.blendTexBorderColor;
float param_71=0.0;
blendTexSample_2=sc_SampleTexture(blendTex,blendTexSmplr,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67,param_68,param_69,param_70,param_71);
}
#endif
a=float4(a.x,a.y,blendTexSample_2.xz.y,blendTexSample_2.xz.x);
if (dot(a,float4(1.0))<1e-05)
{
float4 inputTexSample;
#if (inputTexLayout==2)
{
float2 param_72=inputTexGetDims2D(userUniformsObj);
int param_73=inputTexLayout;
int param_74=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_75=in.varTexCoords;
bool param_76=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_77=userUniformsObj.inputTexTransform;
int2 param_78=_2483;
bool param_79=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_80=userUniformsObj.inputTexUvMinMax;
bool param_81=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_82=userUniformsObj.inputTexBorderColor;
float param_83=0.0;
inputTexSample=sc_SampleTexture(inputTexArrSC,inputTexArrSCSmplr,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79,param_80,param_81,param_82,param_83);
}
#else
{
float2 param_84=inputTexGetDims2D(userUniformsObj);
int param_85=inputTexLayout;
int param_86=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_87=in.varTexCoords;
bool param_88=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_89=userUniformsObj.inputTexTransform;
int2 param_90=_2511;
bool param_91=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_92=userUniformsObj.inputTexUvMinMax;
bool param_93=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_94=userUniformsObj.inputTexBorderColor;
float param_95=0.0;
inputTexSample=sc_SampleTexture(inputTex,inputTexSmplr,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94,param_95);
}
#endif
#if (SMAA_REPROJECTION)
{
}
#endif
color=inputTexSample;
}
else
{
float h=float(fast::max(a.x,a.z)>fast::max(a.y,a.w));
float4 blendingOffset=float4(0.0,a.y,0.0,a.w);
float2 blendingWeight=a.yw;
float4 param_96=float4(h,h,h,h);
float4 param_97=blendingOffset;
float4 param_98=float4(a.x,0.0,a.z,0.0);
SMAAMovc(param_96,param_97,param_98);
blendingOffset=param_97;
float2 param_99=float2(h,h);
float2 param_100=blendingWeight;
float2 param_101=a.xz;
SMAAMovc(param_99,param_100,param_101);
blendingWeight=param_100;
blendingWeight/=float2(dot(blendingWeight,float2(1.0)));
float4 blendingCoord=(blendingOffset*float4(in.smaaRTMetrics.x,-in.smaaRTMetrics.y,-in.smaaRTMetrics.x,in.smaaRTMetrics.y))+in.varTexCoords.xyxy;
float4 inputTexSample_1;
#if (inputTexLayout==2)
{
float2 param_102=inputTexGetDims2D(userUniformsObj);
int param_103=inputTexLayout;
int param_104=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_105=blendingCoord.xy;
bool param_106=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_107=userUniformsObj.inputTexTransform;
int2 param_108=_2616;
bool param_109=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_110=userUniformsObj.inputTexUvMinMax;
bool param_111=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_112=userUniformsObj.inputTexBorderColor;
float param_113=0.0;
inputTexSample_1=sc_SampleTexture(inputTexArrSC,inputTexArrSCSmplr,param_102,param_103,param_104,param_105,param_106,param_107,param_108,param_109,param_110,param_111,param_112,param_113);
}
#else
{
float2 param_114=inputTexGetDims2D(userUniformsObj);
int param_115=inputTexLayout;
int param_116=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_117=blendingCoord.xy;
bool param_118=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_119=userUniformsObj.inputTexTransform;
int2 param_120=_2641;
bool param_121=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_122=userUniformsObj.inputTexUvMinMax;
bool param_123=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_124=userUniformsObj.inputTexBorderColor;
float param_125=0.0;
inputTexSample_1=sc_SampleTexture(inputTex,inputTexSmplr,param_114,param_115,param_116,param_117,param_118,param_119,param_120,param_121,param_122,param_123,param_124,param_125);
}
#endif
color=inputTexSample_1*blendingWeight.x;
float4 inputTexSample_2;
#if (inputTexLayout==2)
{
float2 param_126=inputTexGetDims2D(userUniformsObj);
int param_127=inputTexLayout;
int param_128=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_129=blendingCoord.zw;
bool param_130=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_131=userUniformsObj.inputTexTransform;
int2 param_132=_2673;
bool param_133=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_134=userUniformsObj.inputTexUvMinMax;
bool param_135=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_136=userUniformsObj.inputTexBorderColor;
float param_137=0.0;
inputTexSample_2=sc_SampleTexture(inputTexArrSC,inputTexArrSCSmplr,param_126,param_127,param_128,param_129,param_130,param_131,param_132,param_133,param_134,param_135,param_136,param_137);
}
#else
{
float2 param_138=inputTexGetDims2D(userUniformsObj);
int param_139=inputTexLayout;
int param_140=inputTexGetStereoViewIndex(in.varStereoViewID);
float2 param_141=blendingCoord.zw;
bool param_142=(int(SC_USE_UV_TRANSFORM_inputTex)!=0);
float3x3 param_143=userUniformsObj.inputTexTransform;
int2 param_144=_2698;
bool param_145=(int(SC_USE_UV_MIN_MAX_inputTex)!=0);
float4 param_146=userUniformsObj.inputTexUvMinMax;
bool param_147=(int(SC_USE_CLAMP_TO_BORDER_inputTex)!=0);
float4 param_148=userUniformsObj.inputTexBorderColor;
float param_149=0.0;
inputTexSample_2=sc_SampleTexture(inputTex,inputTexSmplr,param_138,param_139,param_140,param_141,param_142,param_143,param_144,param_145,param_146,param_147,param_148,param_149);
}
#endif
color+=(inputTexSample_2*blendingWeight.y);
#if (SMAA_REPROJECTION)
{
}
#endif
}
float4 param_150=color;
sc_writeFragData0(param_150,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
