#pragma once
#include <metal_stdlib>
#include <simd/simd.h>
#include "required2.metal"
#include "std2_texture.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float LibraryUniforms:vs22: {
//sc_PointLight_t sc_PointLights:0:[]:32
//float3 sc_PointLights.position:0
//float4 sc_PointLights.color:16
//sc_DirectionalLight_t sc_DirectionalLights::[]:32
//float3 sc_DirectionalLights.direction:0
//float4 sc_DirectionalLights.color:16
//sc_AmbientLight_t sc_AmbientLights::[]:16
//float3 sc_AmbientLights.color:0
//float sc_AmbientLights.intensity:12
//float4 sc_EnvmapDiffuseSize:
//float4 sc_EnvmapSpecularSize:
//float3 sc_EnvmapRotation:
//float sc_EnvmapExposure:
//float3 sc_Sh::[9]:16
//float sc_ShIntensity:
//float4 sc_Time:
//float4 sc_UniformConstants:
//float4 sc_GeometryInfo:
//float4x4 sc_ModelViewProjectionMatrixArray::[]:64
//float4x4 sc_ModelViewProjectionMatrixInverseArray::[]:64
//float4x4 sc_ViewProjectionMatrixArray::[]:64
//float4x4 sc_ViewProjectionMatrixInverseArray::[]:64
//float4x4 sc_ModelViewMatrixArray::[]:64
//float4x4 sc_ModelViewMatrixInverseArray::[]:64
//float3x3 sc_ViewNormalMatrixArray::[]:48
//float3x3 sc_ViewNormalMatrixInverseArray::[]:48
//float4x4 sc_ProjectionMatrixArray::[]:64
//float4x4 sc_ProjectionMatrixInverseArray::[]:64
//float4x4 sc_ViewMatrixArray::[]:64
//float4x4 sc_ViewMatrixInverseArray::[]:64
//float4x4 sc_ModelMatrix:
//float4x4 sc_ModelMatrixInverse:
//float3x3 sc_NormalMatrix:
//float3x3 sc_NormalMatrixInverse:
//float3 sc_LocalAabbMin:
//float3 sc_LocalAabbMax:
//float3 sc_WorldAabbMin:
//float3 sc_WorldAabbMax:
//float4 sc_WindowToViewportTransform:
//sc_Camera_t sc_Camera:
//float3 sc_Camera.position:0
//float sc_Camera.aspect:12
//float2 sc_Camera.clipPlanes:16
//float sc_ShadowDensity:
//float4 sc_ShadowColor:
//float4x4 sc_ProjectorMatrix:
//float _sc_GetFramebufferColorInvalidUsageMarker:
//float shaderComplexityValue:
//float sc_DisableFrustumCullingMarker:
//float4 sc_BoneMatrices::[]:16
//float3x3 sc_SkinBonesNormalMatrices::[]:48
//float4 weights0:
//float4 weights1:
//float4 weights2:
//float4 sc_StereoClipPlanes::[]:16
//int sc_FallbackInstanceID:
//float _sc_framebufferFetchMarker:
//float2 sc_TAAJitterOffset:
//float strandWidth:
//float strandTaper:
//float4 strandDataMapTextureSize:
//float clumpInstanceCount:
//float clumpRadius:
//float clumpTipScale:
//float hairstyleInstanceCount:
//float hairstyleNoise:
//float4 sc_ScreenTextureSize:
//float4 sc_ScreenTextureDims:
//float4 sc_ScreenTextureDimsRecip:
//float4 sc_ScreenTextureView:
//float4 sc_ShadowTextureSize:
//float4 sc_ShadowTextureDims:
//float4 sc_ShadowTextureDimsRecip:
//float4 sc_ShadowTextureView:
//}
//SG_REFLECTION_END


struct sc_PointLight_t
{
float3 position;
float4 color;
};

#ifndef sc_PointLightsCount
#define sc_PointLightsCount 0
#endif

struct sc_DirectionalLight_t
{
float3 direction;
float4 color;
};

#ifndef sc_DirectionalLightsCount
#define sc_DirectionalLightsCount 0
#endif

struct sc_AmbientLight_t
{
float3 color;
float intensity;
};

#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 0
#endif

struct sc_Camera_t
{
float3 position;
float aspect;
float2 clipPlanes;
};

#ifndef sc_SkinBonesCount
#define sc_SkinBonesCount 0
#endif

struct LibraryUniforms
{
sc_PointLight_t sc_PointLights[sc_PointLightsCount+1];
sc_DirectionalLight_t sc_DirectionalLights[sc_DirectionalLightsCount+1];
sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount+1];
float4 sc_EnvmapDiffuseSize;
float4 sc_EnvmapSpecularSize;
float3 sc_EnvmapRotation;
float sc_EnvmapExposure;
float3 sc_Sh[9];
float sc_ShIntensity;
float4 sc_Time;
float4 sc_UniformConstants;
float4 sc_GeometryInfo;
float4x4 sc_ModelViewProjectionMatrixArray[sc_NumStereoViews];
float4x4 sc_ModelViewProjectionMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ViewProjectionMatrixArray[sc_NumStereoViews];
float4x4 sc_ViewProjectionMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ModelViewMatrixArray[sc_NumStereoViews];
float4x4 sc_ModelViewMatrixInverseArray[sc_NumStereoViews];
float3x3 sc_ViewNormalMatrixArray[sc_NumStereoViews];
float3x3 sc_ViewNormalMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ProjectionMatrixArray[sc_NumStereoViews];
float4x4 sc_ProjectionMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ViewMatrixArray[sc_NumStereoViews];
float4x4 sc_ViewMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ModelMatrix;
float4x4 sc_ModelMatrixInverse;
float3x3 sc_NormalMatrix;
float3x3 sc_NormalMatrixInverse;
float3 sc_LocalAabbMin;
float3 sc_LocalAabbMax;
float3 sc_WorldAabbMin;
float3 sc_WorldAabbMax;
float4 sc_WindowToViewportTransform;
sc_Camera_t sc_Camera;
float sc_ShadowDensity;
float4 sc_ShadowColor;
float4x4 sc_ProjectorMatrix;
float _sc_GetFramebufferColorInvalidUsageMarker;
float shaderComplexityValue;
float sc_DisableFrustumCullingMarker;
float4 sc_BoneMatrices[(sc_SkinBonesCount*3)+1];
float3x3 sc_SkinBonesNormalMatrices[sc_SkinBonesCount+1];
float4 weights0;
float4 weights1;
float4 weights2;
float4 sc_StereoClipPlanes[sc_NumStereoViews];
int sc_FallbackInstanceID;
float _sc_framebufferFetchMarker;
float2 sc_TAAJitterOffset;
float strandWidth;
float strandTaper;
float4 strandDataMapTextureSize;
float clumpInstanceCount;
float clumpRadius;
float clumpTipScale;
float hairstyleInstanceCount;
float hairstyleNoise;
float4 sc_ScreenTextureSize;
float4 sc_ScreenTextureDims;
float4 sc_ScreenTextureDimsRecip;
float4 sc_ScreenTextureView;
float4 sc_ShadowTextureSize;
float4 sc_ShadowTextureDims;
float4 sc_ShadowTextureDimsRecip;
float4 sc_ShadowTextureView;
};

#ifndef sc_ScreenTextureHasSwappedViews
#define sc_ScreenTextureHasSwappedViews 0
#elif sc_ScreenTextureHasSwappedViews==1
#undef sc_ScreenTextureHasSwappedViews
#define sc_ScreenTextureHasSwappedViews 1
#endif
#ifndef sc_ScreenTextureLayout
#define sc_ScreenTextureLayout 0
#endif
#ifndef sc_ShadowTextureHasSwappedViews
#define sc_ShadowTextureHasSwappedViews 0
#elif sc_ShadowTextureHasSwappedViews==1
#undef sc_ShadowTextureHasSwappedViews
#define sc_ShadowTextureHasSwappedViews 1
#endif
#ifndef sc_ShadowTextureLayout
#define sc_ShadowTextureLayout 0
#endif
#ifndef SC_DEVICE_CLASS
#define SC_DEVICE_CLASS -1
#endif
#ifndef sc_RenderingSpace
#define sc_RenderingSpace -1
#endif
#ifndef sc_StereoRendering_IsClipDistanceEnabled
#define sc_StereoRendering_IsClipDistanceEnabled 0
#endif
#ifndef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 0
#elif SC_GL_FRAGMENT_PRECISION_HIGH==1
#undef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 1
#endif
#ifndef ENABLE_STIPPLE_PATTERN_TEST
#define ENABLE_STIPPLE_PATTERN_TEST 0
#elif ENABLE_STIPPLE_PATTERN_TEST==1
#undef ENABLE_STIPPLE_PATTERN_TEST
#define ENABLE_STIPPLE_PATTERN_TEST 1
#endif
#ifndef sc_IsEditor
#define sc_IsEditor 0
#elif sc_IsEditor==1
#undef sc_IsEditor
#define sc_IsEditor 1
#endif
#ifndef sc_FramebufferFetch
#define sc_FramebufferFetch 0
#elif sc_FramebufferFetch==1
#undef sc_FramebufferFetch
#define sc_FramebufferFetch 1
#endif
#ifndef sc_AmbientLightMode0
#define sc_AmbientLightMode0 0
#endif
#ifndef sc_AmbientLightMode1
#define sc_AmbientLightMode1 0
#endif
#ifndef sc_AmbientLightMode2
#define sc_AmbientLightMode2 0
#endif
#ifndef sc_AmbientLightMode_Constant
#define sc_AmbientLightMode_Constant 0
#endif
#ifndef sc_AmbientLightMode_SphericalHarmonics
#define sc_AmbientLightMode_SphericalHarmonics 0
#endif
#ifndef sc_AmbientLightMode_EnvironmentMap
#define sc_AmbientLightMode_EnvironmentMap 0
#endif
#ifndef sc_AmbientLightMode_FromCamera
#define sc_AmbientLightMode_FromCamera 0
#endif
#ifndef sc_EnvLightMode
#define sc_EnvLightMode 0
#endif
#ifndef sc_RenderAlphaToColor
#define sc_RenderAlphaToColor 0
#elif sc_RenderAlphaToColor==1
#undef sc_RenderAlphaToColor
#define sc_RenderAlphaToColor 1
#endif
#ifndef sc_ProjectiveShadowsCaster
#define sc_ProjectiveShadowsCaster 0
#elif sc_ProjectiveShadowsCaster==1
#undef sc_ProjectiveShadowsCaster
#define sc_ProjectiveShadowsCaster 1
#endif
#ifndef sc_ProjectiveShadowsReceiver
#define sc_ProjectiveShadowsReceiver 0
#elif sc_ProjectiveShadowsReceiver==1
#undef sc_ProjectiveShadowsReceiver
#define sc_ProjectiveShadowsReceiver 1
#endif
#ifndef sc_MaxTextureImageUnits
#define sc_MaxTextureImageUnits 0
#endif
#ifndef sc_HasDiffuseEnvmap
#define sc_HasDiffuseEnvmap 0
#elif sc_HasDiffuseEnvmap==1
#undef sc_HasDiffuseEnvmap
#define sc_HasDiffuseEnvmap 1
#endif
#ifndef sc_ShaderComplexityAnalyzer
#define sc_ShaderComplexityAnalyzer 0
#elif sc_ShaderComplexityAnalyzer==1
#undef sc_ShaderComplexityAnalyzer
#define sc_ShaderComplexityAnalyzer 1
#endif
#ifndef UseViewSpaceDepthVariant
#define UseViewSpaceDepthVariant 1
#elif UseViewSpaceDepthVariant==1
#undef UseViewSpaceDepthVariant
#define UseViewSpaceDepthVariant 1
#endif
#ifndef sc_OITDepthBoundsPass
#define sc_OITDepthBoundsPass 0
#elif sc_OITDepthBoundsPass==1
#undef sc_OITDepthBoundsPass
#define sc_OITDepthBoundsPass 1
#endif
#ifndef sc_OITDepthPrepass
#define sc_OITDepthPrepass 0
#elif sc_OITDepthPrepass==1
#undef sc_OITDepthPrepass
#define sc_OITDepthPrepass 1
#endif
#ifndef sc_OITDepthGatherPass
#define sc_OITDepthGatherPass 0
#elif sc_OITDepthGatherPass==1
#undef sc_OITDepthGatherPass
#define sc_OITDepthGatherPass 1
#endif
#ifndef sc_OITCompositingPass
#define sc_OITCompositingPass 0
#elif sc_OITCompositingPass==1
#undef sc_OITCompositingPass
#define sc_OITCompositingPass 1
#endif
#ifndef sc_OITFrontLayerPass
#define sc_OITFrontLayerPass 0
#elif sc_OITFrontLayerPass==1
#undef sc_OITFrontLayerPass
#define sc_OITFrontLayerPass 1
#endif
#ifndef sc_OITMaxLayers4
#define sc_OITMaxLayers4 0
#elif sc_OITMaxLayers4==1
#undef sc_OITMaxLayers4
#define sc_OITMaxLayers4 1
#endif
#ifndef sc_OITMaxLayers4Plus1
#define sc_OITMaxLayers4Plus1 0
#elif sc_OITMaxLayers4Plus1==1
#undef sc_OITMaxLayers4Plus1
#define sc_OITMaxLayers4Plus1 1
#endif
#ifndef sc_OITMaxLayers8
#define sc_OITMaxLayers8 0
#elif sc_OITMaxLayers8==1
#undef sc_OITMaxLayers8
#define sc_OITMaxLayers8 1
#endif
#ifndef sc_OITMaxLayersVisualizeLayerCount
#define sc_OITMaxLayersVisualizeLayerCount 0
#elif sc_OITMaxLayersVisualizeLayerCount==1
#undef sc_OITMaxLayersVisualizeLayerCount
#define sc_OITMaxLayersVisualizeLayerCount 1
#endif
#ifndef sc_BlendMode_Disabled
#define sc_BlendMode_Disabled 0
#elif sc_BlendMode_Disabled==1
#undef sc_BlendMode_Disabled
#define sc_BlendMode_Disabled 1
#endif
#ifndef sc_BlendMode_Normal
#define sc_BlendMode_Normal 0
#elif sc_BlendMode_Normal==1
#undef sc_BlendMode_Normal
#define sc_BlendMode_Normal 1
#endif
#ifndef sc_BlendMode_Multiply
#define sc_BlendMode_Multiply 0
#elif sc_BlendMode_Multiply==1
#undef sc_BlendMode_Multiply
#define sc_BlendMode_Multiply 1
#endif
#ifndef sc_BlendMode_Add
#define sc_BlendMode_Add 0
#elif sc_BlendMode_Add==1
#undef sc_BlendMode_Add
#define sc_BlendMode_Add 1
#endif
#ifndef sc_BlendMode_Screen
#define sc_BlendMode_Screen 0
#elif sc_BlendMode_Screen==1
#undef sc_BlendMode_Screen
#define sc_BlendMode_Screen 1
#endif
#ifndef sc_BlendMode_PremultipliedAlpha
#define sc_BlendMode_PremultipliedAlpha 0
#elif sc_BlendMode_PremultipliedAlpha==1
#undef sc_BlendMode_PremultipliedAlpha
#define sc_BlendMode_PremultipliedAlpha 1
#endif
#ifndef sc_BlendMode_AlphaToCoverage
#define sc_BlendMode_AlphaToCoverage 0
#elif sc_BlendMode_AlphaToCoverage==1
#undef sc_BlendMode_AlphaToCoverage
#define sc_BlendMode_AlphaToCoverage 1
#endif
#ifndef sc_BlendMode_MultiplyOriginal
#define sc_BlendMode_MultiplyOriginal 0
#elif sc_BlendMode_MultiplyOriginal==1
#undef sc_BlendMode_MultiplyOriginal
#define sc_BlendMode_MultiplyOriginal 1
#endif
#ifndef sc_BlendMode_AddWithAlphaFactor
#define sc_BlendMode_AddWithAlphaFactor 0
#elif sc_BlendMode_AddWithAlphaFactor==1
#undef sc_BlendMode_AddWithAlphaFactor
#define sc_BlendMode_AddWithAlphaFactor 1
#endif
#ifndef sc_BlendMode_Min
#define sc_BlendMode_Min 0
#elif sc_BlendMode_Min==1
#undef sc_BlendMode_Min
#define sc_BlendMode_Min 1
#endif
#ifndef sc_BlendMode_Max
#define sc_BlendMode_Max 0
#elif sc_BlendMode_Max==1
#undef sc_BlendMode_Max
#define sc_BlendMode_Max 1
#endif
#ifndef sc_BlendMode_AlphaTest
#define sc_BlendMode_AlphaTest 0
#elif sc_BlendMode_AlphaTest==1
#undef sc_BlendMode_AlphaTest
#define sc_BlendMode_AlphaTest 1
#endif
#ifndef sc_BlendMode_ColoredGlass
#define sc_BlendMode_ColoredGlass 0
#elif sc_BlendMode_ColoredGlass==1
#undef sc_BlendMode_ColoredGlass
#define sc_BlendMode_ColoredGlass 1
#endif
#ifndef sc_BlendMode_PremultipliedAlphaHardware
#define sc_BlendMode_PremultipliedAlphaHardware 0
#elif sc_BlendMode_PremultipliedAlphaHardware==1
#undef sc_BlendMode_PremultipliedAlphaHardware
#define sc_BlendMode_PremultipliedAlphaHardware 1
#endif
#ifndef sc_BlendMode_Custom
#define sc_BlendMode_Custom 0
#elif sc_BlendMode_Custom==1
#undef sc_BlendMode_Custom
#define sc_BlendMode_Custom 1
#endif
#ifndef sc_BlendMode_Software
#define sc_BlendMode_Software 0
#elif sc_BlendMode_Software==1
#undef sc_BlendMode_Software
#define sc_BlendMode_Software 1
#endif
#ifndef sc_BlendMode_Hardware
#define sc_BlendMode_Hardware 0
#elif sc_BlendMode_Hardware==1
#undef sc_BlendMode_Hardware
#define sc_BlendMode_Hardware 1
#endif

struct sc_AmbientLightCompatibility_t
{
float3 color;
};

float2 sc_ScreenTextureGetDims2D(constant LibraryUniforms& libraryUniformsObj)
{
return libraryUniformsObj.sc_ScreenTextureDims.xy;
}

int sc_ScreenTextureGetStereoViewIndex()
{
#if (sc_ScreenTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

float4 sc_ScreenTextureSampleLevel(thread const float2& uv,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ScreenTextureLayout==2)
{
float2 param=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ScreenTextureLayout;
int param_3=0;
float param_4=level;
return sc_SampleViewLevel(sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ScreenTextureLayout;
int param_8=0;
float param_9=level;
return sc_SampleViewLevel(sc_ScreenTexture,sc_ScreenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ScreenTextureSampleBias(thread const float2& uv,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
float2 param=uv;
float param_1=bias0;
return sc_ScreenTextureSampleLevel(param,param_1,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ScreenTextureSampleViewIndexLevel(thread const float2& uv,thread const int& viewIndex,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ScreenTextureLayout==2)
{
float2 param=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ScreenTextureLayout;
int param_3=viewIndex;
float param_4=level;
return sc_SampleViewLevel(sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ScreenTextureLayout;
int param_8=viewIndex;
float param_9=level;
return sc_SampleViewLevel(sc_ScreenTexture,sc_ScreenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ScreenTextureSampleViewLevel(thread const float2& uv,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=sc_ScreenTextureGetStereoViewIndex();
float param_2=level;
return sc_ScreenTextureSampleViewIndexLevel(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float4 sc_ScreenTextureSampleViewIndexBias(thread const float2& uv,thread const int& viewIndex,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
float2 param=uv;
int param_1=viewIndex;
float param_2=bias0;
return sc_ScreenTextureSampleViewIndexLevel(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ScreenTextureSampleViewBias(thread const float2& uv,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=sc_ScreenTextureGetStereoViewIndex();
float param_2=bias0;
return sc_ScreenTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float4 sc_ScreenTextureSampleViewIndex(thread const float2& uv,thread const int& viewIndex,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=viewIndex;
float param_2=0.0;
return sc_ScreenTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float4 sc_ScreenTextureSampleView(thread const float2& uv,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=sc_ScreenTextureGetStereoViewIndex();
return sc_ScreenTextureSampleViewIndex(param,param_1,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float2 sc_ShadowTextureGetDims2D(constant LibraryUniforms& libraryUniformsObj)
{
return libraryUniformsObj.sc_ShadowTextureDims.xy;
}

int sc_ShadowTextureGetStereoViewIndex()
{
#if (sc_ShadowTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex();
}
#else
{
return sc_GetStereoViewIndex();
}
#endif
}

float4 sc_ShadowTextureSampleLevel(thread const float2& uv,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ShadowTextureLayout==2)
{
float2 param=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ShadowTextureLayout;
int param_3=0;
float param_4=level;
return sc_SampleViewLevel(sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ShadowTextureLayout;
int param_8=0;
float param_9=level;
return sc_SampleViewLevel(sc_ShadowTexture,sc_ShadowTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ShadowTextureSampleBias(thread const float2& uv,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
float2 param=uv;
float param_1=bias0;
return sc_ShadowTextureSampleLevel(param,param_1,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ShadowTextureSampleViewIndexLevel(thread const float2& uv,thread const int& viewIndex,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ShadowTextureLayout==2)
{
float2 param=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ShadowTextureLayout;
int param_3=viewIndex;
float param_4=level;
return sc_SampleViewLevel(sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ShadowTextureLayout;
int param_8=viewIndex;
float param_9=level;
return sc_SampleViewLevel(sc_ShadowTexture,sc_ShadowTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ShadowTextureSampleViewLevel(thread const float2& uv,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=sc_ShadowTextureGetStereoViewIndex();
float param_2=level;
return sc_ShadowTextureSampleViewIndexLevel(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

float4 sc_ShadowTextureSampleViewIndexBias(thread const float2& uv,thread const int& viewIndex,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
float2 param=uv;
int param_1=viewIndex;
float param_2=bias0;
return sc_ShadowTextureSampleViewIndexLevel(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ShadowTextureSampleViewBias(thread const float2& uv,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=sc_ShadowTextureGetStereoViewIndex();
float param_2=bias0;
return sc_ShadowTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

float4 sc_ShadowTextureSampleViewIndex(thread const float2& uv,thread const int& viewIndex,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=viewIndex;
float param_2=0.0;
return sc_ShadowTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

float4 sc_ShadowTextureSampleView(thread const float2& uv,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=sc_ShadowTextureGetStereoViewIndex();
return sc_ShadowTextureSampleViewIndex(param,param_1,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float LibraryUniforms:fs22: {
//sc_PointLight_t sc_PointLights:0:[]:32
//float3 sc_PointLights.position:0
//float4 sc_PointLights.color:16
//sc_DirectionalLight_t sc_DirectionalLights::[]:32
//float3 sc_DirectionalLights.direction:0
//float4 sc_DirectionalLights.color:16
//sc_AmbientLight_t sc_AmbientLights::[]:16
//float3 sc_AmbientLights.color:0
//float sc_AmbientLights.intensity:12
//float4 sc_EnvmapDiffuseSize:
//float4 sc_EnvmapSpecularSize:
//float3 sc_EnvmapRotation:
//float sc_EnvmapExposure:
//float3 sc_Sh::[9]:16
//float sc_ShIntensity:
//float4 sc_Time:
//float4 sc_UniformConstants:
//float4 sc_GeometryInfo:
//float4x4 sc_ModelViewProjectionMatrixArray::[]:64
//float4x4 sc_ModelViewProjectionMatrixInverseArray::[]:64
//float4x4 sc_ViewProjectionMatrixArray::[]:64
//float4x4 sc_ViewProjectionMatrixInverseArray::[]:64
//float4x4 sc_ModelViewMatrixArray::[]:64
//float4x4 sc_ModelViewMatrixInverseArray::[]:64
//float3x3 sc_ViewNormalMatrixArray::[]:48
//float3x3 sc_ViewNormalMatrixInverseArray::[]:48
//float4x4 sc_ProjectionMatrixArray::[]:64
//float4x4 sc_ProjectionMatrixInverseArray::[]:64
//float4x4 sc_ViewMatrixArray::[]:64
//float4x4 sc_ViewMatrixInverseArray::[]:64
//float4x4 sc_ModelMatrix:
//float4x4 sc_ModelMatrixInverse:
//float3x3 sc_NormalMatrix:
//float3x3 sc_NormalMatrixInverse:
//float3 sc_LocalAabbMin:
//float3 sc_LocalAabbMax:
//float3 sc_WorldAabbMin:
//float3 sc_WorldAabbMax:
//float4 sc_WindowToViewportTransform:
//sc_Camera_t sc_Camera:
//float3 sc_Camera.position:0
//float sc_Camera.aspect:12
//float2 sc_Camera.clipPlanes:16
//float sc_ShadowDensity:
//float4 sc_ShadowColor:
//float4x4 sc_ProjectorMatrix:
//float _sc_GetFramebufferColorInvalidUsageMarker:
//float shaderComplexityValue:
//float sc_DisableFrustumCullingMarker:
//float4 sc_BoneMatrices::[]:16
//float3x3 sc_SkinBonesNormalMatrices::[]:48
//float4 weights0:
//float4 weights1:
//float4 weights2:
//float4 sc_StereoClipPlanes::[]:16
//int sc_FallbackInstanceID:
//float _sc_framebufferFetchMarker:
//float2 sc_TAAJitterOffset:
//float strandWidth:
//float strandTaper:
//float4 strandDataMapTextureSize:
//float clumpInstanceCount:
//float clumpRadius:
//float clumpTipScale:
//float hairstyleInstanceCount:
//float hairstyleNoise:
//float4 sc_ScreenTextureSize:
//float4 sc_ScreenTextureDims:
//float4 sc_ScreenTextureDimsRecip:
//float4 sc_ScreenTextureView:
//float4 sc_ShadowTextureSize:
//float4 sc_ShadowTextureDims:
//float4 sc_ShadowTextureDimsRecip:
//float4 sc_ShadowTextureView:
//}
//SG_REFLECTION_END


struct sc_PointLight_t
{
float3 position;
float4 color;
};

#ifndef sc_PointLightsCount
#define sc_PointLightsCount 0
#endif

struct sc_DirectionalLight_t
{
float3 direction;
float4 color;
};

#ifndef sc_DirectionalLightsCount
#define sc_DirectionalLightsCount 0
#endif

struct sc_AmbientLight_t
{
float3 color;
float intensity;
};

#ifndef sc_AmbientLightsCount
#define sc_AmbientLightsCount 0
#endif

struct sc_Camera_t
{
float3 position;
float aspect;
float2 clipPlanes;
};

#ifndef sc_SkinBonesCount
#define sc_SkinBonesCount 0
#endif

struct LibraryUniforms
{
sc_PointLight_t sc_PointLights[sc_PointLightsCount+1];
sc_DirectionalLight_t sc_DirectionalLights[sc_DirectionalLightsCount+1];
sc_AmbientLight_t sc_AmbientLights[sc_AmbientLightsCount+1];
float4 sc_EnvmapDiffuseSize;
float4 sc_EnvmapSpecularSize;
float3 sc_EnvmapRotation;
float sc_EnvmapExposure;
float3 sc_Sh[9];
float sc_ShIntensity;
float4 sc_Time;
float4 sc_UniformConstants;
float4 sc_GeometryInfo;
float4x4 sc_ModelViewProjectionMatrixArray[sc_NumStereoViews];
float4x4 sc_ModelViewProjectionMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ViewProjectionMatrixArray[sc_NumStereoViews];
float4x4 sc_ViewProjectionMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ModelViewMatrixArray[sc_NumStereoViews];
float4x4 sc_ModelViewMatrixInverseArray[sc_NumStereoViews];
float3x3 sc_ViewNormalMatrixArray[sc_NumStereoViews];
float3x3 sc_ViewNormalMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ProjectionMatrixArray[sc_NumStereoViews];
float4x4 sc_ProjectionMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ViewMatrixArray[sc_NumStereoViews];
float4x4 sc_ViewMatrixInverseArray[sc_NumStereoViews];
float4x4 sc_ModelMatrix;
float4x4 sc_ModelMatrixInverse;
float3x3 sc_NormalMatrix;
float3x3 sc_NormalMatrixInverse;
float3 sc_LocalAabbMin;
float3 sc_LocalAabbMax;
float3 sc_WorldAabbMin;
float3 sc_WorldAabbMax;
float4 sc_WindowToViewportTransform;
sc_Camera_t sc_Camera;
float sc_ShadowDensity;
float4 sc_ShadowColor;
float4x4 sc_ProjectorMatrix;
float _sc_GetFramebufferColorInvalidUsageMarker;
float shaderComplexityValue;
float sc_DisableFrustumCullingMarker;
float4 sc_BoneMatrices[(sc_SkinBonesCount*3)+1];
float3x3 sc_SkinBonesNormalMatrices[sc_SkinBonesCount+1];
float4 weights0;
float4 weights1;
float4 weights2;
float4 sc_StereoClipPlanes[sc_NumStereoViews];
int sc_FallbackInstanceID;
float _sc_framebufferFetchMarker;
float2 sc_TAAJitterOffset;
float strandWidth;
float strandTaper;
float4 strandDataMapTextureSize;
float clumpInstanceCount;
float clumpRadius;
float clumpTipScale;
float hairstyleInstanceCount;
float hairstyleNoise;
float4 sc_ScreenTextureSize;
float4 sc_ScreenTextureDims;
float4 sc_ScreenTextureDimsRecip;
float4 sc_ScreenTextureView;
float4 sc_ShadowTextureSize;
float4 sc_ShadowTextureDims;
float4 sc_ShadowTextureDimsRecip;
float4 sc_ShadowTextureView;
};

#ifndef sc_ScreenTextureHasSwappedViews
#define sc_ScreenTextureHasSwappedViews 0
#elif sc_ScreenTextureHasSwappedViews==1
#undef sc_ScreenTextureHasSwappedViews
#define sc_ScreenTextureHasSwappedViews 1
#endif
#ifndef sc_ScreenTextureLayout
#define sc_ScreenTextureLayout 0
#endif
#ifndef sc_ShadowTextureHasSwappedViews
#define sc_ShadowTextureHasSwappedViews 0
#elif sc_ShadowTextureHasSwappedViews==1
#undef sc_ShadowTextureHasSwappedViews
#define sc_ShadowTextureHasSwappedViews 1
#endif
#ifndef sc_ShadowTextureLayout
#define sc_ShadowTextureLayout 0
#endif
#ifndef SC_DEVICE_CLASS
#define SC_DEVICE_CLASS -1
#endif
#ifndef sc_RenderingSpace
#define sc_RenderingSpace -1
#endif
#ifndef sc_StereoRendering_IsClipDistanceEnabled
#define sc_StereoRendering_IsClipDistanceEnabled 0
#endif
#ifndef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 0
#elif SC_GL_FRAGMENT_PRECISION_HIGH==1
#undef SC_GL_FRAGMENT_PRECISION_HIGH
#define SC_GL_FRAGMENT_PRECISION_HIGH 1
#endif
#ifndef ENABLE_STIPPLE_PATTERN_TEST
#define ENABLE_STIPPLE_PATTERN_TEST 0
#elif ENABLE_STIPPLE_PATTERN_TEST==1
#undef ENABLE_STIPPLE_PATTERN_TEST
#define ENABLE_STIPPLE_PATTERN_TEST 1
#endif
#ifndef sc_IsEditor
#define sc_IsEditor 0
#elif sc_IsEditor==1
#undef sc_IsEditor
#define sc_IsEditor 1
#endif
#ifndef sc_FramebufferFetch
#define sc_FramebufferFetch 0
#elif sc_FramebufferFetch==1
#undef sc_FramebufferFetch
#define sc_FramebufferFetch 1
#endif
#ifndef sc_AmbientLightMode0
#define sc_AmbientLightMode0 0
#endif
#ifndef sc_AmbientLightMode1
#define sc_AmbientLightMode1 0
#endif
#ifndef sc_AmbientLightMode2
#define sc_AmbientLightMode2 0
#endif
#ifndef sc_AmbientLightMode_Constant
#define sc_AmbientLightMode_Constant 0
#endif
#ifndef sc_AmbientLightMode_SphericalHarmonics
#define sc_AmbientLightMode_SphericalHarmonics 0
#endif
#ifndef sc_AmbientLightMode_EnvironmentMap
#define sc_AmbientLightMode_EnvironmentMap 0
#endif
#ifndef sc_AmbientLightMode_FromCamera
#define sc_AmbientLightMode_FromCamera 0
#endif
#ifndef sc_EnvLightMode
#define sc_EnvLightMode 0
#endif
#ifndef sc_RenderAlphaToColor
#define sc_RenderAlphaToColor 0
#elif sc_RenderAlphaToColor==1
#undef sc_RenderAlphaToColor
#define sc_RenderAlphaToColor 1
#endif
#ifndef sc_ProjectiveShadowsCaster
#define sc_ProjectiveShadowsCaster 0
#elif sc_ProjectiveShadowsCaster==1
#undef sc_ProjectiveShadowsCaster
#define sc_ProjectiveShadowsCaster 1
#endif
#ifndef sc_ProjectiveShadowsReceiver
#define sc_ProjectiveShadowsReceiver 0
#elif sc_ProjectiveShadowsReceiver==1
#undef sc_ProjectiveShadowsReceiver
#define sc_ProjectiveShadowsReceiver 1
#endif
#ifndef sc_MaxTextureImageUnits
#define sc_MaxTextureImageUnits 0
#endif
#ifndef sc_HasDiffuseEnvmap
#define sc_HasDiffuseEnvmap 0
#elif sc_HasDiffuseEnvmap==1
#undef sc_HasDiffuseEnvmap
#define sc_HasDiffuseEnvmap 1
#endif
#ifndef sc_ShaderComplexityAnalyzer
#define sc_ShaderComplexityAnalyzer 0
#elif sc_ShaderComplexityAnalyzer==1
#undef sc_ShaderComplexityAnalyzer
#define sc_ShaderComplexityAnalyzer 1
#endif
#ifndef UseViewSpaceDepthVariant
#define UseViewSpaceDepthVariant 1
#elif UseViewSpaceDepthVariant==1
#undef UseViewSpaceDepthVariant
#define UseViewSpaceDepthVariant 1
#endif
#ifndef sc_OITDepthBoundsPass
#define sc_OITDepthBoundsPass 0
#elif sc_OITDepthBoundsPass==1
#undef sc_OITDepthBoundsPass
#define sc_OITDepthBoundsPass 1
#endif
#ifndef sc_OITDepthPrepass
#define sc_OITDepthPrepass 0
#elif sc_OITDepthPrepass==1
#undef sc_OITDepthPrepass
#define sc_OITDepthPrepass 1
#endif
#ifndef sc_OITDepthGatherPass
#define sc_OITDepthGatherPass 0
#elif sc_OITDepthGatherPass==1
#undef sc_OITDepthGatherPass
#define sc_OITDepthGatherPass 1
#endif
#ifndef sc_OITCompositingPass
#define sc_OITCompositingPass 0
#elif sc_OITCompositingPass==1
#undef sc_OITCompositingPass
#define sc_OITCompositingPass 1
#endif
#ifndef sc_OITFrontLayerPass
#define sc_OITFrontLayerPass 0
#elif sc_OITFrontLayerPass==1
#undef sc_OITFrontLayerPass
#define sc_OITFrontLayerPass 1
#endif
#ifndef sc_OITMaxLayers4
#define sc_OITMaxLayers4 0
#elif sc_OITMaxLayers4==1
#undef sc_OITMaxLayers4
#define sc_OITMaxLayers4 1
#endif
#ifndef sc_OITMaxLayers4Plus1
#define sc_OITMaxLayers4Plus1 0
#elif sc_OITMaxLayers4Plus1==1
#undef sc_OITMaxLayers4Plus1
#define sc_OITMaxLayers4Plus1 1
#endif
#ifndef sc_OITMaxLayers8
#define sc_OITMaxLayers8 0
#elif sc_OITMaxLayers8==1
#undef sc_OITMaxLayers8
#define sc_OITMaxLayers8 1
#endif
#ifndef sc_OITMaxLayersVisualizeLayerCount
#define sc_OITMaxLayersVisualizeLayerCount 0
#elif sc_OITMaxLayersVisualizeLayerCount==1
#undef sc_OITMaxLayersVisualizeLayerCount
#define sc_OITMaxLayersVisualizeLayerCount 1
#endif
#ifndef sc_BlendMode_Disabled
#define sc_BlendMode_Disabled 0
#elif sc_BlendMode_Disabled==1
#undef sc_BlendMode_Disabled
#define sc_BlendMode_Disabled 1
#endif
#ifndef sc_BlendMode_Normal
#define sc_BlendMode_Normal 0
#elif sc_BlendMode_Normal==1
#undef sc_BlendMode_Normal
#define sc_BlendMode_Normal 1
#endif
#ifndef sc_BlendMode_Multiply
#define sc_BlendMode_Multiply 0
#elif sc_BlendMode_Multiply==1
#undef sc_BlendMode_Multiply
#define sc_BlendMode_Multiply 1
#endif
#ifndef sc_BlendMode_Add
#define sc_BlendMode_Add 0
#elif sc_BlendMode_Add==1
#undef sc_BlendMode_Add
#define sc_BlendMode_Add 1
#endif
#ifndef sc_BlendMode_Screen
#define sc_BlendMode_Screen 0
#elif sc_BlendMode_Screen==1
#undef sc_BlendMode_Screen
#define sc_BlendMode_Screen 1
#endif
#ifndef sc_BlendMode_PremultipliedAlpha
#define sc_BlendMode_PremultipliedAlpha 0
#elif sc_BlendMode_PremultipliedAlpha==1
#undef sc_BlendMode_PremultipliedAlpha
#define sc_BlendMode_PremultipliedAlpha 1
#endif
#ifndef sc_BlendMode_AlphaToCoverage
#define sc_BlendMode_AlphaToCoverage 0
#elif sc_BlendMode_AlphaToCoverage==1
#undef sc_BlendMode_AlphaToCoverage
#define sc_BlendMode_AlphaToCoverage 1
#endif
#ifndef sc_BlendMode_MultiplyOriginal
#define sc_BlendMode_MultiplyOriginal 0
#elif sc_BlendMode_MultiplyOriginal==1
#undef sc_BlendMode_MultiplyOriginal
#define sc_BlendMode_MultiplyOriginal 1
#endif
#ifndef sc_BlendMode_AddWithAlphaFactor
#define sc_BlendMode_AddWithAlphaFactor 0
#elif sc_BlendMode_AddWithAlphaFactor==1
#undef sc_BlendMode_AddWithAlphaFactor
#define sc_BlendMode_AddWithAlphaFactor 1
#endif
#ifndef sc_BlendMode_Min
#define sc_BlendMode_Min 0
#elif sc_BlendMode_Min==1
#undef sc_BlendMode_Min
#define sc_BlendMode_Min 1
#endif
#ifndef sc_BlendMode_Max
#define sc_BlendMode_Max 0
#elif sc_BlendMode_Max==1
#undef sc_BlendMode_Max
#define sc_BlendMode_Max 1
#endif
#ifndef sc_BlendMode_AlphaTest
#define sc_BlendMode_AlphaTest 0
#elif sc_BlendMode_AlphaTest==1
#undef sc_BlendMode_AlphaTest
#define sc_BlendMode_AlphaTest 1
#endif
#ifndef sc_BlendMode_ColoredGlass
#define sc_BlendMode_ColoredGlass 0
#elif sc_BlendMode_ColoredGlass==1
#undef sc_BlendMode_ColoredGlass
#define sc_BlendMode_ColoredGlass 1
#endif
#ifndef sc_BlendMode_PremultipliedAlphaHardware
#define sc_BlendMode_PremultipliedAlphaHardware 0
#elif sc_BlendMode_PremultipliedAlphaHardware==1
#undef sc_BlendMode_PremultipliedAlphaHardware
#define sc_BlendMode_PremultipliedAlphaHardware 1
#endif
#ifndef sc_BlendMode_Custom
#define sc_BlendMode_Custom 0
#elif sc_BlendMode_Custom==1
#undef sc_BlendMode_Custom
#define sc_BlendMode_Custom 1
#endif
#ifndef sc_BlendMode_Software
#define sc_BlendMode_Software 0
#elif sc_BlendMode_Software==1
#undef sc_BlendMode_Software
#define sc_BlendMode_Software 1
#endif
#ifndef sc_BlendMode_Hardware
#define sc_BlendMode_Hardware 0
#elif sc_BlendMode_Hardware==1
#undef sc_BlendMode_Hardware
#define sc_BlendMode_Hardware 1
#endif

struct sc_AmbientLightCompatibility_t
{
float3 color;
};

float2 sc_ScreenTextureGetDims2D(constant LibraryUniforms& libraryUniformsObj)
{
return libraryUniformsObj.sc_ScreenTextureDims.xy;
}

int sc_ScreenTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_ScreenTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 sc_ScreenTextureSampleLevel(thread const float2& uv,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ScreenTextureLayout==2)
{
float2 param=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ScreenTextureLayout;
int param_3=0;
float param_4=level;
return sc_SampleViewLevel(sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ScreenTextureLayout;
int param_8=0;
float param_9=level;
return sc_SampleViewLevel(sc_ScreenTexture,sc_ScreenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ScreenTextureSampleBias(thread const float2& uv,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_ScreenTextureLayout==2)
{
float2 param=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ScreenTextureLayout;
int param_3=0;
float param_4=bias0;
return sc_SampleView(sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ScreenTextureLayout;
int param_8=0;
float param_9=bias0;
return sc_SampleView(sc_ScreenTexture,sc_ScreenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

float4 sc_ScreenTextureSampleViewIndexLevel(thread const float2& uv,thread const int& viewIndex,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ScreenTextureLayout==2)
{
float2 param=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ScreenTextureLayout;
int param_3=viewIndex;
float param_4=level;
return sc_SampleViewLevel(sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ScreenTextureLayout;
int param_8=viewIndex;
float param_9=level;
return sc_SampleViewLevel(sc_ScreenTexture,sc_ScreenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ScreenTextureSampleViewLevel(thread const float2& uv,thread const float& level,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=sc_ScreenTextureGetStereoViewIndex(varStereoViewID);
float param_2=level;
return sc_ScreenTextureSampleViewIndexLevel(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float4 sc_ScreenTextureSampleViewIndexBias(thread const float2& uv,thread const int& viewIndex,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
#if (sc_ScreenTextureLayout==2)
{
float2 param=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ScreenTextureLayout;
int param_3=viewIndex;
float param_4=bias0;
return sc_SampleView(sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ScreenTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ScreenTextureLayout;
int param_8=viewIndex;
float param_9=bias0;
return sc_SampleView(sc_ScreenTexture,sc_ScreenTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

float4 sc_ScreenTextureSampleViewBias(thread const float2& uv,thread const float& bias0,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=sc_ScreenTextureGetStereoViewIndex(varStereoViewID);
float param_2=bias0;
return sc_ScreenTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float4 sc_ScreenTextureSampleViewIndex(thread const float2& uv,thread const int& viewIndex,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=viewIndex;
float param_2=0.0;
return sc_ScreenTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float4 sc_ScreenTextureSampleView(thread const float2& uv,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr)
{
float2 param=uv;
int param_1=sc_ScreenTextureGetStereoViewIndex(varStereoViewID);
return sc_ScreenTextureSampleViewIndex(param,param_1,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}

float2 sc_ShadowTextureGetDims2D(constant LibraryUniforms& libraryUniformsObj)
{
return libraryUniformsObj.sc_ShadowTextureDims.xy;
}

int sc_ShadowTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (sc_ShadowTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float4 sc_ShadowTextureSampleLevel(thread const float2& uv,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ShadowTextureLayout==2)
{
float2 param=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ShadowTextureLayout;
int param_3=0;
float param_4=level;
return sc_SampleViewLevel(sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ShadowTextureLayout;
int param_8=0;
float param_9=level;
return sc_SampleViewLevel(sc_ShadowTexture,sc_ShadowTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ShadowTextureSampleBias(thread const float2& uv,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_ShadowTextureLayout==2)
{
float2 param=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ShadowTextureLayout;
int param_3=0;
float param_4=bias0;
return sc_SampleView(sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ShadowTextureLayout;
int param_8=0;
float param_9=bias0;
return sc_SampleView(sc_ShadowTexture,sc_ShadowTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

float4 sc_ShadowTextureSampleViewIndexLevel(thread const float2& uv,thread const int& viewIndex,thread const float& level,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_CanUseTextureLod)
{
#if (sc_ShadowTextureLayout==2)
{
float2 param=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ShadowTextureLayout;
int param_3=viewIndex;
float param_4=level;
return sc_SampleViewLevel(sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ShadowTextureLayout;
int param_8=viewIndex;
float param_9=level;
return sc_SampleViewLevel(sc_ShadowTexture,sc_ShadowTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}
#else
{
return float4(0.0);
}
#endif
}

float4 sc_ShadowTextureSampleViewLevel(thread const float2& uv,thread const float& level,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=sc_ShadowTextureGetStereoViewIndex(varStereoViewID);
float param_2=level;
return sc_ShadowTextureSampleViewIndexLevel(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

float4 sc_ShadowTextureSampleViewIndexBias(thread const float2& uv,thread const int& viewIndex,thread const float& bias0,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
#if (sc_ShadowTextureLayout==2)
{
float2 param=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_1=uv;
int param_2=sc_ShadowTextureLayout;
int param_3=viewIndex;
float param_4=bias0;
return sc_SampleView(sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,param,param_1,param_2,param_3,param_4);
}
#else
{
float2 param_5=sc_ShadowTextureGetDims2D(libraryUniformsObj);
float2 param_6=uv;
int param_7=sc_ShadowTextureLayout;
int param_8=viewIndex;
float param_9=bias0;
return sc_SampleView(sc_ShadowTexture,sc_ShadowTextureSmplr,param_5,param_6,param_7,param_8,param_9);
}
#endif
}

float4 sc_ShadowTextureSampleViewBias(thread const float2& uv,thread const float& bias0,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=sc_ShadowTextureGetStereoViewIndex(varStereoViewID);
float param_2=bias0;
return sc_ShadowTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

float4 sc_ShadowTextureSampleViewIndex(thread const float2& uv,thread const int& viewIndex,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=viewIndex;
float param_2=0.0;
return sc_ShadowTextureSampleViewIndexBias(param,param_1,param_2,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

float4 sc_ShadowTextureSampleView(thread const float2& uv,thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ShadowTextureArrSC,thread const sampler sc_ShadowTextureArrSCSmplr,thread texture2d<float> sc_ShadowTexture,thread const sampler sc_ShadowTextureSmplr)
{
float2 param=uv;
int param_1=sc_ShadowTextureGetStereoViewIndex(varStereoViewID);
return sc_ShadowTextureSampleViewIndex(param,param_1,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr);
}

} // FRAGMENT SHADER
