#pragma once
#include <metal_stdlib>
#include <simd/simd.h>
#include "std2.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END


} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//output vec4 FragColor:0:[4]
//SG_REFLECTION_END

#ifndef sc_UseFramebufferFetchMarker
#define sc_UseFramebufferFetchMarker 0
#elif sc_UseFramebufferFetchMarker==1
#undef sc_UseFramebufferFetchMarker
#define sc_UseFramebufferFetchMarker 1
#endif
#ifndef sc_GetFramebufferColorInvalidUsageMarker
#define sc_GetFramebufferColorInvalidUsageMarker 0
#elif sc_GetFramebufferColorInvalidUsageMarker==1
#undef sc_GetFramebufferColorInvalidUsageMarker
#define sc_GetFramebufferColorInvalidUsageMarker 1
#endif
#ifndef sc_FragDataCount
#define sc_FragDataCount 0
#endif

void sc_writeFragData0(thread const float4& col,thread float4 (&FragColor)[4])
{
FragColor[0]=col;
}

void sc_writeFragData1(thread const float4& col,thread float4 (&FragColor)[4])
{
FragColor[1]=col;
}

void sc_writeFragData2(thread const float4& col,thread float4 (&FragColor)[4])
{
FragColor[2]=col;
}

void sc_writeFragData3(thread const float4& col,thread float4 (&FragColor)[4])
{
FragColor[3]=col;
}

float4 sc_readFragData0_Platform(thread float4 (&FragColor)[4])
{
return FragColor[0];
}

float4 sc_readFragData1_Platform(thread float4 (&FragColor)[4])
{
return FragColor[1];
}

float4 sc_readFragData2_Platform(thread float4 (&FragColor)[4])
{
return FragColor[2];
}

float4 sc_readFragData3_Platform(thread float4 (&FragColor)[4])
{
return FragColor[3];
}

float4 sc_readFragData0(constant LibraryUniforms& libraryUniformsObj,thread float4 (&FragColor)[4])
{
float4 result=sc_readFragData0_Platform(FragColor);
#if (sc_UseFramebufferFetchMarker)
{
result.x+=libraryUniformsObj._sc_framebufferFetchMarker;
}
#endif
return result;
}

float4 sc_readFragData1(constant LibraryUniforms& libraryUniformsObj,thread float4 (&FragColor)[4])
{
float4 result=sc_readFragData1_Platform(FragColor);
#if (sc_UseFramebufferFetchMarker)
{
result.x+=libraryUniformsObj._sc_framebufferFetchMarker;
}
#endif
return result;
}

float4 sc_readFragData2(constant LibraryUniforms& libraryUniformsObj,thread float4 (&FragColor)[4])
{
float4 result=sc_readFragData2_Platform(FragColor);
#if (sc_UseFramebufferFetchMarker)
{
result.x+=libraryUniformsObj._sc_framebufferFetchMarker;
}
#endif
return result;
}

float4 sc_readFragData3(constant LibraryUniforms& libraryUniformsObj,thread float4 (&FragColor)[4])
{
float4 result=sc_readFragData3_Platform(FragColor);
#if (sc_UseFramebufferFetchMarker)
{
result.x+=libraryUniformsObj._sc_framebufferFetchMarker;
}
#endif
return result;
}

float2 sc_GetGlobalScreenCoords(constant LibraryUniforms& libraryUniformsObj,thread float4& gl_FragCoord)
{
return (gl_FragCoord.xy*libraryUniformsObj.sc_WindowToViewportTransform.xy)+libraryUniformsObj.sc_WindowToViewportTransform.zw;
}

float2 sc_GetViewScreenCoords(thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread float4& gl_FragCoord)
{
float2 param=sc_GetGlobalScreenCoords(libraryUniformsObj,gl_FragCoord);
return sc_ScreenCoordsGlobalToView(param,varStereoViewID);
}

float2 getScreenUV(thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread float4& gl_FragCoord)
{
return sc_GetViewScreenCoords(varStereoViewID,libraryUniformsObj,gl_FragCoord);
}

float4 sc_GetFramebufferColor(thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr,thread float4 (&FragColor)[4],thread float4& gl_FragCoord)
{
float4 result;
#if (sc_FramebufferFetch)
{
result=sc_readFragData0(libraryUniformsObj,FragColor);
}
#else
{
float2 param=sc_GetViewScreenCoords(varStereoViewID,libraryUniformsObj,gl_FragCoord);
result=sc_ScreenTextureSampleView(param,varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr);
}
#endif
#if (((sc_IsEditor&&sc_GetFramebufferColorInvalidUsageMarker)&&(!sc_BlendMode_Software))&&(!sc_BlendMode_ColoredGlass))
{
result.x+=libraryUniformsObj._sc_GetFramebufferColorInvalidUsageMarker;
}
#endif
return result;
}

float4 getFramebufferColor(thread int& varStereoViewID,constant LibraryUniforms& libraryUniformsObj,thread texture2d_array<float> sc_ScreenTextureArrSC,thread const sampler sc_ScreenTextureArrSCSmplr,thread texture2d<float> sc_ScreenTexture,thread const sampler sc_ScreenTextureSmplr,thread float4 (&FragColor)[4],thread float4& gl_FragCoord)
{
return sc_GetFramebufferColor(varStereoViewID,libraryUniformsObj,sc_ScreenTextureArrSC,sc_ScreenTextureArrSCSmplr,sc_ScreenTexture,sc_ScreenTextureSmplr,FragColor,gl_FragCoord);
}

float4 sc_ApplyBlendModeModifications(thread const float4& color)
{
#if (sc_BlendMode_MultiplyOriginal)
{
return float4(mix(float3(1.0),color.xyz,float3(color.w)),color.w);
}
#else
{
#if (sc_BlendMode_Screen||sc_BlendMode_PremultipliedAlphaHardware)
{
return float4(color.xyz*color.w,color.w);
}
#else
{
return color;
}
#endif
}
#endif
}

void sc_DiscardStereoFragment(thread float& varClipDistance)
{
#if ((sc_StereoRenderingMode==1)&&(sc_StereoRendering_IsClipDistanceEnabled==1))
{
if (varClipDistance<0.0)
{
discard_fragment();
}
}
#endif
}

float4 getPixelRenderingCost(constant LibraryUniforms& libraryUniformsObj)
{
#if (sc_ShaderComplexityAnalyzer)
{
return float4(libraryUniformsObj.shaderComplexityValue/255.0,0.0,0.0,1.0);
}
#else
{
return float4(0.0);
}
#endif
}

void sc_MainInjector()
{
}

void sc_CallLensFragmentMain()
{
}

void sc_StereoFragmentMain(thread float& varClipDistance)
{
sc_DiscardStereoFragment(varClipDistance);
sc_CallLensFragmentMain();
}

} // FRAGMENT SHADER
