#pragma once
#include <metal_stdlib>
#include <simd/simd.h>
    #ifndef sc_TextureRenderingLayout_Regular
        #define sc_TextureRenderingLayout_Regular 0
        #define sc_TextureRenderingLayout_StereoInstancedClipped 1
        #define sc_TextureRenderingLayout_StereoMultiview 2
    #endif

#define depthToGlobal depthScreenToViewSpace

#define depthToLocal depthViewToScreenSpace

#include "required2.metal"
#include "std2_stereo_view_index.metal"
#include "std2_texture_sub.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END


float4 sc_textureLodLegacy(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLodLegacyArr(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv.xy,uint(round(uv.z)),level(lod));
}

float4 sc_textureLod(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLod(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv.xy,uint(round(uv.z)),level(lod));
}

float4 sc_textureBiasOrLod(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const float& biasOrLod)
{
float2 param=texSize;
float2 param_1=uv;
float param_2=biasOrLod;
return sc_textureLod(tex,texSmplr,param,param_1,param_2);
}

float4 sc_textureBiasOrLod(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float3& uv,thread const float& biasOrLod)
{
float2 param=texSize;
float3 param_1=uv;
float param_2=biasOrLod;
return sc_textureLod(tex,texSmplr,param,param_1,param_2);
}

float4 sc_textureLod(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLod(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv.xy,uint(round(uv.z)),level(lod));
}

float4 sc_textureLod(thread const texture3d<float> tex,thread const sampler texSmplr,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLod(thread const texturecube<float> tex,thread const sampler texSmplr,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float2 sc_SamplingCoordsGlobalToView(thread float3& uvi,thread const int& renderingLayout,thread const int& viewIndex)
{
if (renderingLayout==1)
{
uvi.y=((2.0*uvi.y)+float(viewIndex))-1.0;
}
return uvi.xy;
}

float2 sc_ScreenCoordsGlobalToView(thread const float2& uv)
{
#if (sc_StereoRenderingMode==1)
{
float3 uvi=float3(uv,0.0);
int instancedClippedLayout=1;
int viewIndex=sc_GetStereoViewIndex();
float3 param=float3(uv,0.0);
int param_1=instancedClippedLayout;
int param_2=viewIndex;
float2 _361=sc_SamplingCoordsGlobalToView(param,param_1,param_2);
return _361;
}
#else
{
return uv;
}
#endif
}

float3 sc_SamplingCoordsViewToGlobal(thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex)
{
if (renderingLayout==0)
{
return float3(uv,0.0);
}
else
{
if (renderingLayout==1)
{
return float3(uv.x,(uv.y*0.5)+(0.5-(float(viewIndex)*0.5)),0.0);
}
else
{
return float3(uv,float(viewIndex));
}
}
}

float4 sc_SampleViewLevel(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& level)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float2 param_4=uvi.xy;
float param_5=level;
return sc_textureLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& bias0)
{
float2 param=texSize;
float2 param_1=uv;
int param_2=renderingLayout;
int param_3=viewIndex;
float param_4=bias0;
return sc_SampleViewLevel(tex,texSmplr,param,param_1,param_2,param_3,param_4);
}

float4 sc_SampleView(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex)
{
float2 param=texSize;
float2 param_1=uv;
int param_2=renderingLayout;
int param_3=viewIndex;
float param_4=0.0;
return sc_SampleView(tex,texSmplr,param,param_1,param_2,param_3,param_4);
}

float4 sc_SampleViewLevel(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& level)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float3 param_4=uvi;
float param_5=level;
return sc_textureLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& bias0)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float3 param_4=uvi;
float param_5=bias0;
return sc_textureBiasOrLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex)
{
float2 param=texSize;
float2 param_1=uv;
int param_2=renderingLayout;
int param_3=viewIndex;
float param_4=0.0;
return sc_SampleView(tex,texSmplr,param,param_1,param_2,param_3,param_4);
}

void sc_ClampUV(thread float& value,thread const float& minValue,thread const float& maxValue,thread const bool& useClampToBorder,thread float& clampToBorderFactor)
{
float clampedValue=fast::clamp(value,minValue,maxValue);
float factor=step(abs(value-clampedValue),1e-05);
clampToBorderFactor*=(factor+((1.0-float(useClampToBorder))*(1.0-factor)));
value=clampedValue;
}

float2 sc_platformUVFlip(thread const float2& uv)
{
return float2(uv.x,1.0-uv.y);
}

void sc_SoftwareWrap(thread float& uv,thread const int& softwareWrapMode,thread const bool& useClampToBorder,thread float& clampToBorderFactor)
{
if ((softwareWrapMode==0)||(softwareWrapMode==3))
{
float param=uv;
float param_1=0.0;
float param_2=1.0;
bool param_3=useClampToBorder;
float param_4=clampToBorderFactor;
sc_ClampUV(param,param_1,param_2,param_3,param_4);
uv=param;
clampToBorderFactor=param_4;
}
else
{
if (softwareWrapMode==1)
{
uv=fract(uv);
}
else
{
if (softwareWrapMode==2)
{
float uvFract=fract(uv);
float uvInt=uv-uvFract;
float uvOdd=step(0.25,fract(uvInt*0.5));
uv=mix(uvFract,1.0-uvFract,fast::clamp(uvOdd,0.0,1.0));
}
}
}
}

float2 quantizeUV(thread const float2& uv)
{
return uv;
}

float4 sc_SampleTexture(thread const texture2d<float> sampler_,thread const sampler sampler_Smplr,thread const float2& samplerDims,thread const int& renderingLayout,thread const int& viewIndex,thread const float2& uv,thread const bool& useUvTransform,thread const float3x3& uvTransform,thread const int2& softwareWrapModes,thread const bool& useUvMinMax,thread const float4& uvMinMax,thread const bool& useClampToBorder,thread const float4& borderColor,thread const float& mipBias)
{
float2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=float2((uvTransform*float3(_uv,1.0)).xy);
}
float2 param_18=_uv;
_uv=quantizeUV(param_18);
float2 param_19=_uv;
_uv=sc_platformUVFlip(param_19);
float2 param_20=samplerDims;
float2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=mipBias;
float4 tex=sc_SampleView(sampler_,sampler_Smplr,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,float4(clampToBorderFactor));
}
return tex;
}

float4 sc_SampleTexture(thread const texture2d_array<float> sampler_,thread const sampler sampler_Smplr,thread const float2& samplerDims,thread const int& renderingLayout,thread const int& viewIndex,thread const float2& uv,thread const bool& useUvTransform,thread const float3x3& uvTransform,thread const int2& softwareWrapModes,thread const bool& useUvMinMax,thread const float4& uvMinMax,thread const bool& useClampToBorder,thread const float4& borderColor,thread const float& mipBias)
{
float2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=float2((uvTransform*float3(_uv,1.0)).xy);
}
float2 param_18=_uv;
_uv=quantizeUV(param_18);
float2 param_19=_uv;
_uv=sc_platformUVFlip(param_19);
float2 param_20=samplerDims;
float2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=mipBias;
float4 tex=sc_SampleView(sampler_,sampler_Smplr,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,float4(clampToBorderFactor));
}
return tex;
}

float4 sampleTextureWithTransform(thread const texture2d_array<float> samp,thread const sampler sampSmplr,thread float3& uv,thread const bool& useLOD,thread const float& lod,thread const bool& useUvTransform,thread const float3x3& uvTransform)
{
if (useUvTransform)
{
float2 _820=float2((uvTransform*float3(uv.xy,1.0)).xy);
uv=float3(_820.x,_820.y,uv.z);
}
float2 param=uv.xy;
float2 _826=quantizeUV(param);
uv=float3(_826.x,_826.y,uv.z);
if (useLOD)
{
float3 param_1=uv;
float param_2=lod;
return sc_textureLod(samp,sampSmplr,param_1,param_2);
}
else
{
return samp.sample(sampSmplr,uv.xy,uint(round(uv.z)),level(0.0));
}
}

float depthScreenToViewSpace(thread float& depth,thread const float2& projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
depth=(depth*2.0)-1.0;
return m32/((-depth)-m22);
}

float depthViewToScreenSpace(thread float& depth,thread const float2& projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
float _869;
if (depth!=0.0)
{
_869=(-m22)-(m32/depth);
}
else
{
_869=0.0;
}
depth=_869;
return (depth*0.5)+0.5;
}

float4 sampleTextureWithTransform(thread const texture2d<float> samp,thread const sampler sampSmplr,thread float2& uv,thread const bool& useUvTransform,thread const float3x3& uvTransform)
{
if (useUvTransform)
{
uv=float2((uvTransform*float3(uv,1.0)).xy);
}
float2 param=uv;
uv=quantizeUV(param);
return samp.sample(sampSmplr,uv,level(0.0));
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//SG_REFLECTION_END


float4 sc_textureLodLegacy(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLodLegacyArr(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv.xy,uint(round(uv.z)),level(lod));
}

float4 sc_textureLod(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLod(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv.xy,uint(round(uv.z)),level(lod));
}

float4 sc_textureBiasOrLod(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const float& biasOrLod)
{
return tex.sample(texSmplr,uv,bias(biasOrLod));
}

float4 sc_textureBiasOrLod(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float3& uv,thread const float& biasOrLod)
{
float2 param=texSize;
float3 param_1=uv;
float param_2=biasOrLod;
return sc_textureLod(tex,texSmplr,param,param_1,param_2);
}

float4 sc_textureLod(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLod(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv.xy,uint(round(uv.z)),level(lod));
}

float4 sc_textureLod(thread const texture3d<float> tex,thread const sampler texSmplr,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float4 sc_textureLod(thread const texturecube<float> tex,thread const sampler texSmplr,thread const float3& uv,thread const float& lod)
{
return tex.sample(texSmplr,uv,level(lod));
}

float2 sc_SamplingCoordsGlobalToView(thread float3& uvi,thread const int& renderingLayout,thread const int& viewIndex)
{
if (renderingLayout==1)
{
uvi.y=((2.0*uvi.y)+float(viewIndex))-1.0;
}
return uvi.xy;
}

float2 sc_ScreenCoordsGlobalToView(thread const float2& uv,thread int& varStereoViewID)
{
#if (sc_StereoRenderingMode==1)
{
float3 uvi=float3(uv,0.0);
int instancedClippedLayout=1;
int viewIndex=sc_GetStereoViewIndex(varStereoViewID);
float3 param=float3(uv,0.0);
int param_1=instancedClippedLayout;
int param_2=viewIndex;
float2 _360=sc_SamplingCoordsGlobalToView(param,param_1,param_2);
return _360;
}
#else
{
return uv;
}
#endif
}

float3 sc_SamplingCoordsViewToGlobal(thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex)
{
if (renderingLayout==0)
{
return float3(uv,0.0);
}
else
{
if (renderingLayout==1)
{
return float3(uv.x,(uv.y*0.5)+(0.5-(float(viewIndex)*0.5)),0.0);
}
else
{
return float3(uv,float(viewIndex));
}
}
}

float4 sc_SampleViewLevel(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& level)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float2 param_4=uvi.xy;
float param_5=level;
return sc_textureLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& bias0)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float2 param_4=uvi.xy;
float param_5=bias0;
return sc_textureBiasOrLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex)
{
float2 param=texSize;
float2 param_1=uv;
int param_2=renderingLayout;
int param_3=viewIndex;
float param_4=0.0;
return sc_SampleView(tex,texSmplr,param,param_1,param_2,param_3,param_4);
}

float4 sc_SampleViewLevel(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& level)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float3 param_4=uvi;
float param_5=level;
return sc_textureLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex,thread const float& bias0)
{
float2 param=uv;
int param_1=renderingLayout;
int param_2=viewIndex;
float3 uvi=sc_SamplingCoordsViewToGlobal(param,param_1,param_2);
float2 param_3=texSize;
float3 param_4=uvi;
float param_5=bias0;
return sc_textureBiasOrLod(tex,texSmplr,param_3,param_4,param_5);
}

float4 sc_SampleView(thread const texture2d_array<float> tex,thread const sampler texSmplr,thread const float2& texSize,thread const float2& uv,thread const int& renderingLayout,thread const int& viewIndex)
{
float2 param=texSize;
float2 param_1=uv;
int param_2=renderingLayout;
int param_3=viewIndex;
float param_4=0.0;
return sc_SampleView(tex,texSmplr,param,param_1,param_2,param_3,param_4);
}

void sc_ClampUV(thread float& value,thread const float& minValue,thread const float& maxValue,thread const bool& useClampToBorder,thread float& clampToBorderFactor)
{
float clampedValue=fast::clamp(value,minValue,maxValue);
float factor=step(abs(value-clampedValue),1e-05);
clampToBorderFactor*=(factor+((1.0-float(useClampToBorder))*(1.0-factor)));
value=clampedValue;
}

float2 sc_platformUVFlip(thread const float2& uv)
{
return float2(uv.x,1.0-uv.y);
}

void sc_SoftwareWrap(thread float& uv,thread const int& softwareWrapMode,thread const bool& useClampToBorder,thread float& clampToBorderFactor)
{
if ((softwareWrapMode==0)||(softwareWrapMode==3))
{
float param=uv;
float param_1=0.0;
float param_2=1.0;
bool param_3=useClampToBorder;
float param_4=clampToBorderFactor;
sc_ClampUV(param,param_1,param_2,param_3,param_4);
uv=param;
clampToBorderFactor=param_4;
}
else
{
if (softwareWrapMode==1)
{
uv=fract(uv);
}
else
{
if (softwareWrapMode==2)
{
float uvFract=fract(uv);
float uvInt=uv-uvFract;
float uvOdd=step(0.25,fract(uvInt*0.5));
uv=mix(uvFract,1.0-uvFract,fast::clamp(uvOdd,0.0,1.0));
}
}
}
}

float2 quantizeUV(thread const float2& uv)
{
return uv;
}

float4 sc_SampleTexture(thread const texture2d<float> sampler_,thread const sampler sampler_Smplr,thread const float2& samplerDims,thread const int& renderingLayout,thread const int& viewIndex,thread const float2& uv,thread const bool& useUvTransform,thread const float3x3& uvTransform,thread const int2& softwareWrapModes,thread const bool& useUvMinMax,thread const float4& uvMinMax,thread const bool& useClampToBorder,thread const float4& borderColor,thread const float& mipBias)
{
float2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=float2((uvTransform*float3(_uv,1.0)).xy);
}
float2 param_18=_uv;
_uv=quantizeUV(param_18);
float2 param_19=_uv;
_uv=sc_platformUVFlip(param_19);
float2 param_20=samplerDims;
float2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=mipBias;
float4 tex=sc_SampleView(sampler_,sampler_Smplr,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,float4(clampToBorderFactor));
}
return tex;
}

float4 sc_SampleTexture(thread const texture2d_array<float> sampler_,thread const sampler sampler_Smplr,thread const float2& samplerDims,thread const int& renderingLayout,thread const int& viewIndex,thread const float2& uv,thread const bool& useUvTransform,thread const float3x3& uvTransform,thread const int2& softwareWrapModes,thread const bool& useUvMinMax,thread const float4& uvMinMax,thread const bool& useClampToBorder,thread const float4& borderColor,thread const float& mipBias)
{
float2 _uv=uv;
float clampToBorderFactor=1.0;
bool useClampToBorderForWrap=useClampToBorder&&(!useUvMinMax);
float param=_uv.x;
int param_1=softwareWrapModes.x;
bool param_2=useClampToBorderForWrap;
float param_3=clampToBorderFactor;
sc_SoftwareWrap(param,param_1,param_2,param_3);
_uv.x=param;
clampToBorderFactor=param_3;
float param_4=_uv.y;
int param_5=softwareWrapModes.y;
bool param_6=useClampToBorderForWrap;
float param_7=clampToBorderFactor;
sc_SoftwareWrap(param_4,param_5,param_6,param_7);
_uv.y=param_4;
clampToBorderFactor=param_7;
if (useUvMinMax)
{
float param_8=_uv.x;
float param_9=uvMinMax.x;
float param_10=uvMinMax.z;
bool param_11=useClampToBorder;
float param_12=clampToBorderFactor;
sc_ClampUV(param_8,param_9,param_10,param_11,param_12);
_uv.x=param_8;
clampToBorderFactor=param_12;
float param_13=_uv.y;
float param_14=uvMinMax.y;
float param_15=uvMinMax.w;
bool param_16=useClampToBorder;
float param_17=clampToBorderFactor;
sc_ClampUV(param_13,param_14,param_15,param_16,param_17);
_uv.y=param_13;
clampToBorderFactor=param_17;
}
if (useUvTransform)
{
_uv=float2((uvTransform*float3(_uv,1.0)).xy);
}
float2 param_18=_uv;
_uv=quantizeUV(param_18);
float2 param_19=_uv;
_uv=sc_platformUVFlip(param_19);
float2 param_20=samplerDims;
float2 param_21=_uv;
int param_22=renderingLayout;
int param_23=viewIndex;
float param_24=mipBias;
float4 tex=sc_SampleView(sampler_,sampler_Smplr,param_20,param_21,param_22,param_23,param_24);
if (useClampToBorder)
{
tex=mix(borderColor,tex,float4(clampToBorderFactor));
}
return tex;
}

float4 sampleTextureWithTransform(thread const texture2d_array<float> samp,thread const sampler sampSmplr,thread float3& uv,thread const bool& useLOD,thread const float& lod,thread const bool& useUvTransform,thread const float3x3& uvTransform)
{
if (useUvTransform)
{
float2 _824=float2((uvTransform*float3(uv.xy,1.0)).xy);
uv=float3(_824.x,_824.y,uv.z);
}
float2 param=uv.xy;
float2 _830=quantizeUV(param);
uv=float3(_830.x,_830.y,uv.z);
if (useLOD)
{
float3 param_1=uv;
float param_2=lod;
return sc_textureLod(samp,sampSmplr,param_1,param_2);
}
else
{
return samp.sample(sampSmplr,uv.xy,uint(round(uv.z)));
}
}

float depthScreenToViewSpace(thread float& depth,thread const float2& projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
depth=(depth*2.0)-1.0;
return m32/((-depth)-m22);
}

float depthViewToScreenSpace(thread float& depth,thread const float2& projectionMatrixTerms)
{
float m22=projectionMatrixTerms.x;
float m32=projectionMatrixTerms.y;
float _873;
if (depth!=0.0)
{
_873=(-m22)-(m32/depth);
}
else
{
_873=0.0;
}
depth=_873;
return (depth*0.5)+0.5;
}

float4 sampleTextureWithTransform(thread const texture2d<float> samp,thread const sampler sampSmplr,thread float2& uv,thread const bool& useUvTransform,thread const float3x3& uvTransform)
{
if (useUvTransform)
{
uv=float2((uvTransform*float3(uv,1.0)).xy);
}
float2 param=uv;
uv=quantizeUV(param);
return samp.sample(sampSmplr,uv);
}

} // FRAGMENT SHADER
