#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define STD_DISABLE_VERTEX_NORMAL 1
#define STD_DISABLE_VERTEX_TANGENT 1

#include "std2.metal"
#include "std2_vs.metal"
#include "std2_fs.metal"
#include "std2_shadows.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:vs21:304 {
//float4 mainTextureSize:0
//float4 mainTextureDims:16
//float4 mainTextureDimsRecip:32
//float4 mainTextureView:48
//float3x3 mainTextureTransform:64
//float4 mainTextureUvMinMax:112
//float4 mainTextureBorderColor:128
//float4 maskTextureSize:144
//float4 maskTextureDims:160
//float4 maskTextureDimsRecip:176
//float4 maskTextureView:192
//float3x3 maskTextureTransform:208
//float4 maskTextureUvMinMax:256
//float4 maskTextureBorderColor:272
//float4 mainColor:288
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureDimsRecip;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureDimsRecip;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float4 mainColor;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef ENABLESHADOWS
#define ENABLESHADOWS 0
#elif ENABLESHADOWS==1
#undef ENABLESHADOWS
#define ENABLESHADOWS 1
#endif
#ifndef NOTEXTURE
#define NOTEXTURE 0
#elif NOTEXTURE==1
#undef NOTEXTURE
#define NOTEXTURE 1
#endif
#ifndef NOMASK
#define NOMASK 0
#elif NOMASK==1
#undef NOMASK
#define NOMASK 1
#endif
#ifndef EMOCHECKERS
#define EMOCHECKERS 0
#elif EMOCHECKERS==1
#undef EMOCHECKERS
#define EMOCHECKERS 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:304 {
//float4 mainTextureSize:0
//float4 mainTextureDims:16
//float4 mainTextureDimsRecip:32
//float4 mainTextureView:48
//float3x3 mainTextureTransform:64
//float4 mainTextureUvMinMax:112
//float4 mainTextureBorderColor:128
//float4 maskTextureSize:144
//float4 maskTextureDims:160
//float4 maskTextureDimsRecip:176
//float4 maskTextureView:192
//float3x3 maskTextureTransform:208
//float4 maskTextureUvMinMax:256
//float4 maskTextureBorderColor:272
//float4 mainColor:288
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureDimsRecip;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float4 maskTextureSize;
float4 maskTextureDims;
float4 maskTextureDimsRecip;
float4 maskTextureView;
float3x3 maskTextureTransform;
float4 maskTextureUvMinMax;
float4 maskTextureBorderColor;
float4 mainColor;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 0
#elif maskTextureHasSwappedViews==1
#undef maskTextureHasSwappedViews
#define maskTextureHasSwappedViews 1
#endif
#ifndef maskTextureLayout
#define maskTextureLayout 0
#endif
#ifndef EMOCHECKERS
#define EMOCHECKERS 0
#elif EMOCHECKERS==1
#undef EMOCHECKERS
#define EMOCHECKERS 1
#endif
#ifndef NOTEXTURE
#define NOTEXTURE 0
#elif NOTEXTURE==1
#undef NOTEXTURE
#define NOTEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _2270=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
constant int2 _2300=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef NOMASK
#define NOMASK 0
#elif NOMASK==1
#undef NOMASK
#define NOMASK 1
#endif
#ifndef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 0
#elif SC_USE_UV_TRANSFORM_maskTexture==1
#undef SC_USE_UV_TRANSFORM_maskTexture
#define SC_USE_UV_TRANSFORM_maskTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_maskTexture
#define SC_SOFTWARE_WRAP_MODE_U_maskTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_maskTexture
#define SC_SOFTWARE_WRAP_MODE_V_maskTexture -1
#endif
constant int2 _2339=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 0
#elif SC_USE_UV_MIN_MAX_maskTexture==1
#undef SC_USE_UV_MIN_MAX_maskTexture
#define SC_USE_UV_MIN_MAX_maskTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 0
#elif SC_USE_CLAMP_TO_BORDER_maskTexture==1
#undef SC_USE_CLAMP_TO_BORDER_maskTexture
#define SC_USE_CLAMP_TO_BORDER_maskTexture 1
#endif
constant int2 _2368=int2(SC_SOFTWARE_WRAP_MODE_U_maskTexture,SC_SOFTWARE_WRAP_MODE_V_maskTexture);
#ifndef ENABLESHADOWS
#define ENABLESHADOWS 0
#elif ENABLESHADOWS==1
#undef ENABLESHADOWS
#define ENABLESHADOWS 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef maskTextureUV
#define maskTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float2 varShadowTex [[user(locn2)]];
float4 varPackedTex [[user(locn6)]];
};

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 maskTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.maskTextureDims.xy;
}

int maskTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (maskTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],texture2d<float> sc_ShadowTexture [[texture(0)]],texture2d_array<float> sc_ShadowTextureArrSC [[texture(1)]],texture2d<float> mainTexture [[texture(2)]],texture2d_array<float> mainTextureArrSC [[texture(3)]],texture2d<float> maskTexture [[texture(4)]],texture2d_array<float> maskTextureArrSC [[texture(5)]],sampler sc_ShadowTextureSmplr [[sampler(0)]],sampler sc_ShadowTextureArrSCSmplr [[sampler(1)]],sampler mainTextureSmplr [[sampler(2)]],sampler mainTextureArrSCSmplr [[sampler(3)]],sampler maskTextureSmplr [[sampler(4)]],sampler maskTextureArrSCSmplr [[sampler(5)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 color=float4(0.0);
#if (EMOCHECKERS)
{
float r=abs(dot(step(float2(0.5),fract(in.varPackedTex.xy*2.0)),float2(1.0))-1.0);
color=float4(r,0.0,r,1.0);
}
#else
{
color=userUniformsObj.mainColor;
#if (!NOTEXTURE)
{
float4 mainTextureSample;
#if (mainTextureLayout==2)
{
float2 param=mainTextureGetDims2D(userUniformsObj);
int param_1=mainTextureLayout;
int param_2=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_3=in.varPackedTex.xy;
bool param_4=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_5=userUniformsObj.mainTextureTransform;
int2 param_6=_2270;
bool param_7=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_8=userUniformsObj.mainTextureUvMinMax;
bool param_9=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureBorderColor;
float param_11=0.0;
mainTextureSample=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param,param_1,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11);
}
#else
{
float2 param_12=mainTextureGetDims2D(userUniformsObj);
int param_13=mainTextureLayout;
int param_14=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_15=in.varPackedTex.xy;
bool param_16=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_17=userUniformsObj.mainTextureTransform;
int2 param_18=_2300;
bool param_19=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_20=userUniformsObj.mainTextureUvMinMax;
bool param_21=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_22=userUniformsObj.mainTextureBorderColor;
float param_23=0.0;
mainTextureSample=sc_SampleTexture(mainTexture,mainTextureSmplr,param_12,param_13,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23);
}
#endif
color*=mainTextureSample;
}
#endif
#if (!NOMASK)
{
float4 maskTextureSample;
#if (maskTextureLayout==2)
{
float2 param_24=maskTextureGetDims2D(userUniformsObj);
int param_25=maskTextureLayout;
int param_26=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_27=in.varPackedTex.zw;
bool param_28=(int(SC_USE_UV_TRANSFORM_maskTexture)!=0);
float3x3 param_29=userUniformsObj.maskTextureTransform;
int2 param_30=_2339;
bool param_31=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_32=userUniformsObj.maskTextureUvMinMax;
bool param_33=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_34=userUniformsObj.maskTextureBorderColor;
float param_35=0.0;
maskTextureSample=sc_SampleTexture(maskTextureArrSC,maskTextureArrSCSmplr,param_24,param_25,param_26,param_27,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35);
}
#else
{
float2 param_36=maskTextureGetDims2D(userUniformsObj);
int param_37=maskTextureLayout;
int param_38=maskTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_39=in.varPackedTex.zw;
bool param_40=(int(SC_USE_UV_TRANSFORM_maskTexture)!=0);
float3x3 param_41=userUniformsObj.maskTextureTransform;
int2 param_42=_2368;
bool param_43=(int(SC_USE_UV_MIN_MAX_maskTexture)!=0);
float4 param_44=userUniformsObj.maskTextureUvMinMax;
bool param_45=(int(SC_USE_CLAMP_TO_BORDER_maskTexture)!=0);
float4 param_46=userUniformsObj.maskTextureBorderColor;
float param_47=0.0;
maskTextureSample=sc_SampleTexture(maskTexture,maskTextureSmplr,param_36,param_37,param_38,param_39,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47);
}
#endif
color.w*=maskTextureSample.x;
}
#endif
}
#endif
#if (ENABLESHADOWS)
{
#if (sc_ProjectiveShadowsReceiver)
{
float3 _2405=color.xyz*evaluateShadow(in.varStereoViewID,libraryUniformsObj,sc_ShadowTextureArrSC,sc_ShadowTextureArrSCSmplr,sc_ShadowTexture,sc_ShadowTextureSmplr,in.varShadowTex);
color=float4(_2405.x,_2405.y,_2405.z,color.w);
}
#endif
#if (sc_ProjectiveShadowsCaster)
{
float4 param_48=color;
color=evaluateShadowCasterColor(param_48,libraryUniformsObj);
}
#endif
}
#endif
float4 param_49=color;
sc_writeFragData0(param_49,FragColor);
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
