#pragma once
#pragma clang diagnostic ignored "-Wmissing-prototypes"

#include <metal_stdlib>
#include <simd/simd.h>
#define SC_USE_USER_DEFINED_VS_MAIN 1;
#define STD_DISABLE_VERTEX_NORMAL 1;
#define STD_DISABLE_VERTEX_TANGENT 1;

#include "std2.metal"
#include "std2_fs.metal"
#include "std2_vs.metal"

using namespace metal;

namespace SNAP_VS {


//SG_REFLECTION_BEGIN
//attribute float passIdentifierAttr:15:
//attribute float sdfOffsetAttr:16:
//ubo float UserUniforms:vs21:932 {
//float4 mainTextureSize:0
//float4 mainTextureDims:16
//float4 mainTextureDimsRecip:32
//float4 mainTextureView:48
//float3x3 mainTextureTransform:64
//float4 mainTextureUvMinMax:112
//float4 mainTextureBorderColor:128
//float4 colorTextureSize:144
//float4 colorTextureDims:160
//float4 colorTextureDimsRecip:176
//float4 colorTextureView:192
//float3x3 colorTextureTransform:208
//float4 colorTextureUvMinMax:256
//float4 colorTextureBorderColor:272
//float4 mainFillTextureSize:288
//float4 mainFillTextureDims:304
//float4 mainFillTextureDimsRecip:320
//float4 mainFillTextureView:336
//float3x3 mainFillTextureTransform:352
//float4 mainFillTextureUvMinMax:400
//float4 mainFillTextureBorderColor:416
//float4 shadowFillTextureSize:432
//float4 shadowFillTextureDims:448
//float4 shadowFillTextureDimsRecip:464
//float4 shadowFillTextureView:480
//float3x3 shadowFillTextureTransform:496
//float4 shadowFillTextureUvMinMax:544
//float4 shadowFillTextureBorderColor:560
//float4 outlineFillTextureSize:576
//float4 outlineFillTextureDims:592
//float4 outlineFillTextureDimsRecip:608
//float4 outlineFillTextureView:624
//float3x3 outlineFillTextureTransform:640
//float4 outlineFillTextureUvMinMax:688
//float4 outlineFillTextureBorderColor:704
//float4 backgroundFillTextureSize:720
//float4 backgroundFillTextureDims:736
//float4 backgroundFillTextureDimsRecip:752
//float4 backgroundFillTextureView:768
//float3x3 backgroundFillTextureTransform:784
//float4 backgroundFillTextureUvMinMax:832
//float4 backgroundFillTextureBorderColor:848
//float4 mainColor:864
//float4 shadowColor:880
//float4 outlineColor:896
//float4 backgroundColor:912
//float multisampleBlend:928
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureDimsRecip;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float4 colorTextureSize;
float4 colorTextureDims;
float4 colorTextureDimsRecip;
float4 colorTextureView;
float3x3 colorTextureTransform;
float4 colorTextureUvMinMax;
float4 colorTextureBorderColor;
float4 mainFillTextureSize;
float4 mainFillTextureDims;
float4 mainFillTextureDimsRecip;
float4 mainFillTextureView;
float3x3 mainFillTextureTransform;
float4 mainFillTextureUvMinMax;
float4 mainFillTextureBorderColor;
float4 shadowFillTextureSize;
float4 shadowFillTextureDims;
float4 shadowFillTextureDimsRecip;
float4 shadowFillTextureView;
float3x3 shadowFillTextureTransform;
float4 shadowFillTextureUvMinMax;
float4 shadowFillTextureBorderColor;
float4 outlineFillTextureSize;
float4 outlineFillTextureDims;
float4 outlineFillTextureDimsRecip;
float4 outlineFillTextureView;
float3x3 outlineFillTextureTransform;
float4 outlineFillTextureUvMinMax;
float4 outlineFillTextureBorderColor;
float4 backgroundFillTextureSize;
float4 backgroundFillTextureDims;
float4 backgroundFillTextureDimsRecip;
float4 backgroundFillTextureView;
float3x3 backgroundFillTextureTransform;
float4 backgroundFillTextureUvMinMax;
float4 backgroundFillTextureBorderColor;
float4 mainColor;
float4 shadowColor;
float4 outlineColor;
float4 backgroundColor;
float multisampleBlend;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 0
#elif colorTextureHasSwappedViews==1
#undef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 1
#endif
#ifndef colorTextureLayout
#define colorTextureLayout 0
#endif
#ifndef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 0
#elif mainFillTextureHasSwappedViews==1
#undef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 1
#endif
#ifndef mainFillTextureLayout
#define mainFillTextureLayout 0
#endif
#ifndef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 0
#elif shadowFillTextureHasSwappedViews==1
#undef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 1
#endif
#ifndef shadowFillTextureLayout
#define shadowFillTextureLayout 0
#endif
#ifndef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 0
#elif outlineFillTextureHasSwappedViews==1
#undef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 1
#endif
#ifndef outlineFillTextureLayout
#define outlineFillTextureLayout 0
#endif
#ifndef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 0
#elif backgroundFillTextureHasSwappedViews==1
#undef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 1
#endif
#ifndef backgroundFillTextureLayout
#define backgroundFillTextureLayout 0
#endif
#ifndef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 0
#elif MAIN_FILL_COLOR==1
#undef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 1
#endif
#ifndef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 0
#elif MAIN_FILL_TEXTURE==1
#undef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 1
#endif
#ifndef ENABLE_SHADOW
#define ENABLE_SHADOW 0
#elif ENABLE_SHADOW==1
#undef ENABLE_SHADOW
#define ENABLE_SHADOW 1
#endif
#ifndef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 0
#elif SHADOW_FILL_COLOR==1
#undef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 1
#endif
#ifndef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 0
#elif SHADOW_FILL_TEXTURE==1
#undef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 1
#endif
#ifndef ENABLE_OUTLINE
#define ENABLE_OUTLINE 0
#elif ENABLE_OUTLINE==1
#undef ENABLE_OUTLINE
#define ENABLE_OUTLINE 1
#endif
#ifndef ENABLE_SDF
#define ENABLE_SDF 0
#elif ENABLE_SDF==1
#undef ENABLE_SDF
#define ENABLE_SDF 1
#endif
#ifndef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 0
#elif OUTLINE_FILL_COLOR==1
#undef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 1
#endif
#ifndef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 0
#elif OUTLINE_FILL_TEXTURE==1
#undef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 1
#endif
#ifndef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 0
#elif ENABLE_BACKGROUND==1
#undef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 1
#endif
#ifndef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 0
#elif BACKGROUND_FILL_COLOR==1
#undef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 1
#endif
#ifndef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 0
#elif BACKGROUND_FILL_TEXTURE==1
#undef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 1
#endif
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
#ifndef colorTextureUV
#define colorTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 0
#elif SC_USE_UV_TRANSFORM_colorTexture==1
#undef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_colorTexture
#define SC_SOFTWARE_WRAP_MODE_U_colorTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_colorTexture
#define SC_SOFTWARE_WRAP_MODE_V_colorTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 0
#elif SC_USE_UV_MIN_MAX_colorTexture==1
#undef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 0
#elif SC_USE_CLAMP_TO_BORDER_colorTexture==1
#undef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 1
#endif
#ifndef mainFillTextureUV
#define mainFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 0
#elif SC_USE_UV_TRANSFORM_mainFillTexture==1
#undef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 0
#elif SC_USE_UV_MIN_MAX_mainFillTexture==1
#undef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 1
#endif
#ifndef shadowFillTextureUV
#define shadowFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 0
#elif SC_USE_UV_TRANSFORM_shadowFillTexture==1
#undef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 0
#elif SC_USE_UV_MIN_MAX_shadowFillTexture==1
#undef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_shadowFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 1
#endif
#ifndef outlineFillTextureUV
#define outlineFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 0
#elif SC_USE_UV_TRANSFORM_outlineFillTexture==1
#undef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 0
#elif SC_USE_UV_MIN_MAX_outlineFillTexture==1
#undef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_outlineFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 1
#endif
#ifndef backgroundFillTextureUV
#define backgroundFillTextureUV 0
#endif
#ifndef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 0
#elif SC_USE_UV_TRANSFORM_backgroundFillTexture==1
#undef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture -1
#endif
#ifndef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 0
#elif SC_USE_UV_MIN_MAX_backgroundFillTexture==1
#undef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backgroundFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 1
#endif

struct main_vert_out
{
int varStereoViewID [[user(locn0)]];
float varClipDistance [[user(locn1)]];
float2 varShadowTex [[user(locn2)]];
float3 varPos [[user(locn3)]];
float3 varNormal [[user(locn4)]];
float4 varTangent [[user(locn5)]];
float4 varPackedTex [[user(locn6)]];
float4 varScreenPos [[user(locn7)]];
float2 varScreenTexturePos [[user(locn8)]];
float varViewSpaceDepth [[user(locn9)]];
float varPassIdentifier [[user(locn10)]];
float varSdfOffset [[user(locn11)]];
float4 gl_Position [[position]];
};

struct main_vert_in
{
float4 position [[attribute(0)]];
float3 normal [[attribute(1)]];
float4 tangent [[attribute(2)]];
float2 texture0 [[attribute(3)]];
float2 texture1 [[attribute(4)]];
float4 boneData [[attribute(5)]];
float3 blendShape0Pos [[attribute(6)]];
float3 blendShape1Pos [[attribute(7)]];
float3 blendShape2Pos [[attribute(8)]];
float3 blendShape3Pos [[attribute(9)]];
float3 blendShape4Pos [[attribute(10)]];
float3 blendShape5Pos [[attribute(11)]];
float3 blendShape0Normal [[attribute(12)]];
float3 blendShape1Normal [[attribute(13)]];
float3 blendShape2Normal [[attribute(14)]];
float passIdentifierAttr [[attribute(15)]];
float sdfOffsetAttr [[attribute(16)]];
};

vertex main_vert_out main_vert(main_vert_in in [[stage_in]],constant LibraryUniforms& libraryUniformsObj [[buffer(22)]],uint gl_InstanceIndex [[instance_id]])
{
main_vert_out out={};
sc_Vertex_t v=sc_LoadVertexAttributes(libraryUniformsObj,in.position,in.normal,in.tangent,in.texture0,in.texture1);
sc_Vertex_t param=v;
sc_ProcessVertex(param,libraryUniformsObj,out.varClipDistance,out.varStereoViewID,out.gl_Position,in.boneData,in.blendShape0Pos,in.blendShape0Normal,in.blendShape1Pos,in.blendShape1Normal,in.blendShape2Pos,in.blendShape2Normal,in.blendShape3Pos,in.blendShape4Pos,in.blendShape5Pos,in.tangent,out.varPos,out.varNormal,out.varTangent,out.varPackedTex,out.varScreenPos,out.varScreenTexturePos,out.varShadowTex,out.varViewSpaceDepth);
out.varPassIdentifier=in.passIdentifierAttr;
out.varSdfOffset=in.sdfOffsetAttr;
return out;
}

} // VERTEX SHADER


namespace SNAP_FS {


//SG_REFLECTION_BEGIN
//ubo float UserUniforms:fs21:932 {
//float4 mainTextureSize:0
//float4 mainTextureDims:16
//float4 mainTextureDimsRecip:32
//float4 mainTextureView:48
//float3x3 mainTextureTransform:64
//float4 mainTextureUvMinMax:112
//float4 mainTextureBorderColor:128
//float4 colorTextureSize:144
//float4 colorTextureDims:160
//float4 colorTextureDimsRecip:176
//float4 colorTextureView:192
//float3x3 colorTextureTransform:208
//float4 colorTextureUvMinMax:256
//float4 colorTextureBorderColor:272
//float4 mainFillTextureSize:288
//float4 mainFillTextureDims:304
//float4 mainFillTextureDimsRecip:320
//float4 mainFillTextureView:336
//float3x3 mainFillTextureTransform:352
//float4 mainFillTextureUvMinMax:400
//float4 mainFillTextureBorderColor:416
//float4 shadowFillTextureSize:432
//float4 shadowFillTextureDims:448
//float4 shadowFillTextureDimsRecip:464
//float4 shadowFillTextureView:480
//float3x3 shadowFillTextureTransform:496
//float4 shadowFillTextureUvMinMax:544
//float4 shadowFillTextureBorderColor:560
//float4 outlineFillTextureSize:576
//float4 outlineFillTextureDims:592
//float4 outlineFillTextureDimsRecip:608
//float4 outlineFillTextureView:624
//float3x3 outlineFillTextureTransform:640
//float4 outlineFillTextureUvMinMax:688
//float4 outlineFillTextureBorderColor:704
//float4 backgroundFillTextureSize:720
//float4 backgroundFillTextureDims:736
//float4 backgroundFillTextureDimsRecip:752
//float4 backgroundFillTextureView:768
//float3x3 backgroundFillTextureTransform:784
//float4 backgroundFillTextureUvMinMax:832
//float4 backgroundFillTextureBorderColor:848
//float4 mainColor:864
//float4 shadowColor:880
//float4 outlineColor:896
//float4 backgroundColor:912
//float multisampleBlend:928
//}
//SG_REFLECTION_END


struct UserUniforms
{
float4 mainTextureSize;
float4 mainTextureDims;
float4 mainTextureDimsRecip;
float4 mainTextureView;
float3x3 mainTextureTransform;
float4 mainTextureUvMinMax;
float4 mainTextureBorderColor;
float4 colorTextureSize;
float4 colorTextureDims;
float4 colorTextureDimsRecip;
float4 colorTextureView;
float3x3 colorTextureTransform;
float4 colorTextureUvMinMax;
float4 colorTextureBorderColor;
float4 mainFillTextureSize;
float4 mainFillTextureDims;
float4 mainFillTextureDimsRecip;
float4 mainFillTextureView;
float3x3 mainFillTextureTransform;
float4 mainFillTextureUvMinMax;
float4 mainFillTextureBorderColor;
float4 shadowFillTextureSize;
float4 shadowFillTextureDims;
float4 shadowFillTextureDimsRecip;
float4 shadowFillTextureView;
float3x3 shadowFillTextureTransform;
float4 shadowFillTextureUvMinMax;
float4 shadowFillTextureBorderColor;
float4 outlineFillTextureSize;
float4 outlineFillTextureDims;
float4 outlineFillTextureDimsRecip;
float4 outlineFillTextureView;
float3x3 outlineFillTextureTransform;
float4 outlineFillTextureUvMinMax;
float4 outlineFillTextureBorderColor;
float4 backgroundFillTextureSize;
float4 backgroundFillTextureDims;
float4 backgroundFillTextureDimsRecip;
float4 backgroundFillTextureView;
float3x3 backgroundFillTextureTransform;
float4 backgroundFillTextureUvMinMax;
float4 backgroundFillTextureBorderColor;
float4 mainColor;
float4 shadowColor;
float4 outlineColor;
float4 backgroundColor;
float multisampleBlend;
};

#ifndef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 0
#elif mainTextureHasSwappedViews==1
#undef mainTextureHasSwappedViews
#define mainTextureHasSwappedViews 1
#endif
#ifndef mainTextureLayout
#define mainTextureLayout 0
#endif
#ifndef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 0
#elif colorTextureHasSwappedViews==1
#undef colorTextureHasSwappedViews
#define colorTextureHasSwappedViews 1
#endif
#ifndef colorTextureLayout
#define colorTextureLayout 0
#endif
#ifndef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 0
#elif mainFillTextureHasSwappedViews==1
#undef mainFillTextureHasSwappedViews
#define mainFillTextureHasSwappedViews 1
#endif
#ifndef mainFillTextureLayout
#define mainFillTextureLayout 0
#endif
#ifndef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 0
#elif shadowFillTextureHasSwappedViews==1
#undef shadowFillTextureHasSwappedViews
#define shadowFillTextureHasSwappedViews 1
#endif
#ifndef shadowFillTextureLayout
#define shadowFillTextureLayout 0
#endif
#ifndef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 0
#elif outlineFillTextureHasSwappedViews==1
#undef outlineFillTextureHasSwappedViews
#define outlineFillTextureHasSwappedViews 1
#endif
#ifndef outlineFillTextureLayout
#define outlineFillTextureLayout 0
#endif
#ifndef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 0
#elif backgroundFillTextureHasSwappedViews==1
#undef backgroundFillTextureHasSwappedViews
#define backgroundFillTextureHasSwappedViews 1
#endif
#ifndef backgroundFillTextureLayout
#define backgroundFillTextureLayout 0
#endif
#ifndef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 0
#elif SC_USE_UV_TRANSFORM_mainTexture==1
#undef SC_USE_UV_TRANSFORM_mainTexture
#define SC_USE_UV_TRANSFORM_mainTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainTexture -1
#endif
constant int2 _3136=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 0
#elif SC_USE_UV_MIN_MAX_mainTexture==1
#undef SC_USE_UV_MIN_MAX_mainTexture
#define SC_USE_UV_MIN_MAX_mainTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainTexture
#define SC_USE_CLAMP_TO_BORDER_mainTexture 1
#endif
constant int2 _3166=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3202=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3227=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3263=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3288=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3324=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3349=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 0
#elif MAIN_FILL_COLOR==1
#undef MAIN_FILL_COLOR
#define MAIN_FILL_COLOR 1
#endif
#ifndef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 0
#elif MAIN_FILL_TEXTURE==1
#undef MAIN_FILL_TEXTURE
#define MAIN_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 0
#elif SC_USE_UV_TRANSFORM_mainFillTexture==1
#undef SC_USE_UV_TRANSFORM_mainFillTexture
#define SC_USE_UV_TRANSFORM_mainFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_mainFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_mainFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_mainFillTexture -1
#endif
constant int2 _3449=int2(SC_SOFTWARE_WRAP_MODE_U_mainFillTexture,SC_SOFTWARE_WRAP_MODE_V_mainFillTexture);
#ifndef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 0
#elif SC_USE_UV_MIN_MAX_mainFillTexture==1
#undef SC_USE_UV_MIN_MAX_mainFillTexture
#define SC_USE_UV_MIN_MAX_mainFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_mainFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_mainFillTexture
#define SC_USE_CLAMP_TO_BORDER_mainFillTexture 1
#endif
constant int2 _3477=int2(SC_SOFTWARE_WRAP_MODE_U_mainFillTexture,SC_SOFTWARE_WRAP_MODE_V_mainFillTexture);
#ifndef ENABLE_SHADOW
#define ENABLE_SHADOW 0
#elif ENABLE_SHADOW==1
#undef ENABLE_SHADOW
#define ENABLE_SHADOW 1
#endif
#ifndef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 0
#elif SHADOW_FILL_COLOR==1
#undef SHADOW_FILL_COLOR
#define SHADOW_FILL_COLOR 1
#endif
#ifndef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 0
#elif SHADOW_FILL_TEXTURE==1
#undef SHADOW_FILL_TEXTURE
#define SHADOW_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 0
#elif SC_USE_UV_TRANSFORM_shadowFillTexture==1
#undef SC_USE_UV_TRANSFORM_shadowFillTexture
#define SC_USE_UV_TRANSFORM_shadowFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture -1
#endif
constant int2 _3540=int2(SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture,SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture);
#ifndef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 0
#elif SC_USE_UV_MIN_MAX_shadowFillTexture==1
#undef SC_USE_UV_MIN_MAX_shadowFillTexture
#define SC_USE_UV_MIN_MAX_shadowFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_shadowFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_shadowFillTexture
#define SC_USE_CLAMP_TO_BORDER_shadowFillTexture 1
#endif
constant int2 _3568=int2(SC_SOFTWARE_WRAP_MODE_U_shadowFillTexture,SC_SOFTWARE_WRAP_MODE_V_shadowFillTexture);
#ifndef ENABLE_OUTLINE
#define ENABLE_OUTLINE 0
#elif ENABLE_OUTLINE==1
#undef ENABLE_OUTLINE
#define ENABLE_OUTLINE 1
#endif
#ifndef ENABLE_SDF
#define ENABLE_SDF 0
#elif ENABLE_SDF==1
#undef ENABLE_SDF
#define ENABLE_SDF 1
#endif
#ifndef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 0
#elif OUTLINE_FILL_COLOR==1
#undef OUTLINE_FILL_COLOR
#define OUTLINE_FILL_COLOR 1
#endif
#ifndef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 0
#elif OUTLINE_FILL_TEXTURE==1
#undef OUTLINE_FILL_TEXTURE
#define OUTLINE_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 0
#elif SC_USE_UV_TRANSFORM_outlineFillTexture==1
#undef SC_USE_UV_TRANSFORM_outlineFillTexture
#define SC_USE_UV_TRANSFORM_outlineFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture -1
#endif
constant int2 _3638=int2(SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture,SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture);
#ifndef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 0
#elif SC_USE_UV_MIN_MAX_outlineFillTexture==1
#undef SC_USE_UV_MIN_MAX_outlineFillTexture
#define SC_USE_UV_MIN_MAX_outlineFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_outlineFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_outlineFillTexture
#define SC_USE_CLAMP_TO_BORDER_outlineFillTexture 1
#endif
constant int2 _3665=int2(SC_SOFTWARE_WRAP_MODE_U_outlineFillTexture,SC_SOFTWARE_WRAP_MODE_V_outlineFillTexture);
#ifndef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 0
#elif ENABLE_BACKGROUND==1
#undef ENABLE_BACKGROUND
#define ENABLE_BACKGROUND 1
#endif
#ifndef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 0
#elif BACKGROUND_FILL_COLOR==1
#undef BACKGROUND_FILL_COLOR
#define BACKGROUND_FILL_COLOR 1
#endif
#ifndef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 0
#elif BACKGROUND_FILL_TEXTURE==1
#undef BACKGROUND_FILL_TEXTURE
#define BACKGROUND_FILL_TEXTURE 1
#endif
#ifndef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 0
#elif SC_USE_UV_TRANSFORM_backgroundFillTexture==1
#undef SC_USE_UV_TRANSFORM_backgroundFillTexture
#define SC_USE_UV_TRANSFORM_backgroundFillTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture
#define SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture -1
#endif
constant int2 _3731=int2(SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture,SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture);
#ifndef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 0
#elif SC_USE_UV_MIN_MAX_backgroundFillTexture==1
#undef SC_USE_UV_MIN_MAX_backgroundFillTexture
#define SC_USE_UV_MIN_MAX_backgroundFillTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 0
#elif SC_USE_CLAMP_TO_BORDER_backgroundFillTexture==1
#undef SC_USE_CLAMP_TO_BORDER_backgroundFillTexture
#define SC_USE_CLAMP_TO_BORDER_backgroundFillTexture 1
#endif
constant int2 _3759=int2(SC_SOFTWARE_WRAP_MODE_U_backgroundFillTexture,SC_SOFTWARE_WRAP_MODE_V_backgroundFillTexture);
#ifndef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 0
#elif SC_USE_UV_TRANSFORM_colorTexture==1
#undef SC_USE_UV_TRANSFORM_colorTexture
#define SC_USE_UV_TRANSFORM_colorTexture 1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_U_colorTexture
#define SC_SOFTWARE_WRAP_MODE_U_colorTexture -1
#endif
#ifndef SC_SOFTWARE_WRAP_MODE_V_colorTexture
#define SC_SOFTWARE_WRAP_MODE_V_colorTexture -1
#endif
constant int2 _3800=int2(SC_SOFTWARE_WRAP_MODE_U_colorTexture,SC_SOFTWARE_WRAP_MODE_V_colorTexture);
#ifndef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 0
#elif SC_USE_UV_MIN_MAX_colorTexture==1
#undef SC_USE_UV_MIN_MAX_colorTexture
#define SC_USE_UV_MIN_MAX_colorTexture 1
#endif
#ifndef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 0
#elif SC_USE_CLAMP_TO_BORDER_colorTexture==1
#undef SC_USE_CLAMP_TO_BORDER_colorTexture
#define SC_USE_CLAMP_TO_BORDER_colorTexture 1
#endif
constant int2 _3829=int2(SC_SOFTWARE_WRAP_MODE_U_colorTexture,SC_SOFTWARE_WRAP_MODE_V_colorTexture);
constant int2 _3877=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3902=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3958=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
constant int2 _3983=int2(SC_SOFTWARE_WRAP_MODE_U_mainTexture,SC_SOFTWARE_WRAP_MODE_V_mainTexture);
#ifndef mainTextureUV
#define mainTextureUV 0
#endif
#ifndef colorTextureUV
#define colorTextureUV 0
#endif
#ifndef mainFillTextureUV
#define mainFillTextureUV 0
#endif
#ifndef shadowFillTextureUV
#define shadowFillTextureUV 0
#endif
#ifndef outlineFillTextureUV
#define outlineFillTextureUV 0
#endif
#ifndef backgroundFillTextureUV
#define backgroundFillTextureUV 0
#endif

struct main_frag_out
{
float4 FragColor_0 [[color(0)]];
float4 FragColor_1 [[color(1)]];
float4 FragColor_2 [[color(2)]];
float4 FragColor_3 [[color(3)]];
};

struct main_frag_in
{
int varStereoViewID [[user(locn0)]];
float4 varPackedTex [[user(locn6)]];
float varPassIdentifier [[user(locn10)]];
float varSdfOffset [[user(locn11)]];
};

bool isPass(thread const float& pass,thread const float& identifier)
{
float _2067=identifier;
float _2068=pass;
bool _2071=_2067>(_2068-0.05);
bool _2078;
if (_2071)
{
_2078=identifier<(pass+0.05);
}
else
{
_2078=_2071;
}
if (_2078)
{
return true;
}
return false;
}

float2 mainFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainFillTextureDims.xy;
}

int mainFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 shadowFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.shadowFillTextureDims.xy;
}

int shadowFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (shadowFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 outlineFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.outlineFillTextureDims.xy;
}

int outlineFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (outlineFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 backgroundFillTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.backgroundFillTextureDims.xy;
}

int backgroundFillTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (backgroundFillTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 colorTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.colorTextureDims.xy;
}

int colorTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (colorTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float2 mainTextureGetDims2D(constant UserUniforms& userUniformsObj)
{
return userUniformsObj.mainTextureDims.xy;
}

int mainTextureGetStereoViewIndex(thread int& varStereoViewID)
{
#if (mainTextureHasSwappedViews)
{
return 1-sc_GetStereoViewIndex(varStereoViewID);
}
#else
{
return sc_GetStereoViewIndex(varStereoViewID);
}
#endif
}

float calculateSdfOpacity(thread const float& _distance,thread const float& sdfEdge)
{
float w=fwidth(_distance);
return smoothstep(sdfEdge-w,sdfEdge+w,_distance);
}

float calculateSdfOpacityMultisampled(thread const float& dist,thread const float& sdfEdge,thread const float& multisampleBlend,thread int& varStereoViewID,constant UserUniforms& userUniformsObj,thread texture2d_array<float> mainTextureArrSC,thread const sampler mainTextureArrSCSmplr,thread texture2d<float> mainTexture,thread const sampler mainTextureSmplr,thread float4& varPackedTex)
{
float param=dist;
float param_1=sdfEdge;
float opacity=calculateSdfOpacity(param,param_1);
if (multisampleBlend>0.0)
{
float dscale=0.353553;
float2 duv=(dfdx(varPackedTex.xy)+dfdy(varPackedTex.xy))*dscale;
float4 box=float4(varPackedTex.xy-duv,varPackedTex.xy+duv);
float multisampleOpacity=opacity;
float singleSampleOpacity=opacity;
float4 mainTextureSample;
#if (mainTextureLayout==2)
{
float2 param_2=mainTextureGetDims2D(userUniformsObj);
int param_3=mainTextureLayout;
int param_4=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_5=box.xw;
bool param_6=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_7=userUniformsObj.mainTextureTransform;
int2 param_8=_3136;
bool param_9=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_10=userUniformsObj.mainTextureUvMinMax;
bool param_11=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_12=userUniformsObj.mainTextureBorderColor;
float param_13=0.0;
mainTextureSample=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param_2,param_3,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13);
}
#else
{
float2 param_14=mainTextureGetDims2D(userUniformsObj);
int param_15=mainTextureLayout;
int param_16=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_17=box.xw;
bool param_18=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_19=userUniformsObj.mainTextureTransform;
int2 param_20=_3166;
bool param_21=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_22=userUniformsObj.mainTextureUvMinMax;
bool param_23=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_24=userUniformsObj.mainTextureBorderColor;
float param_25=0.0;
mainTextureSample=sc_SampleTexture(mainTexture,mainTextureSmplr,param_14,param_15,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24,param_25);
}
#endif
float param_26=mainTextureSample.x;
float param_27=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_26,param_27);
float4 mainTextureSample_1;
#if (mainTextureLayout==2)
{
float2 param_28=mainTextureGetDims2D(userUniformsObj);
int param_29=mainTextureLayout;
int param_30=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_31=box.xy;
bool param_32=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_33=userUniformsObj.mainTextureTransform;
int2 param_34=_3202;
bool param_35=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_36=userUniformsObj.mainTextureUvMinMax;
bool param_37=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_38=userUniformsObj.mainTextureBorderColor;
float param_39=0.0;
mainTextureSample_1=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param_28,param_29,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37,param_38,param_39);
}
#else
{
float2 param_40=mainTextureGetDims2D(userUniformsObj);
int param_41=mainTextureLayout;
int param_42=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_43=box.xy;
bool param_44=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_45=userUniformsObj.mainTextureTransform;
int2 param_46=_3227;
bool param_47=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_48=userUniformsObj.mainTextureUvMinMax;
bool param_49=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_50=userUniformsObj.mainTextureBorderColor;
float param_51=0.0;
mainTextureSample_1=sc_SampleTexture(mainTexture,mainTextureSmplr,param_40,param_41,param_42,param_43,param_44,param_45,param_46,param_47,param_48,param_49,param_50,param_51);
}
#endif
float param_52=mainTextureSample_1.x;
float param_53=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_52,param_53);
float4 mainTextureSample_2;
#if (mainTextureLayout==2)
{
float2 param_54=mainTextureGetDims2D(userUniformsObj);
int param_55=mainTextureLayout;
int param_56=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_57=box.zy;
bool param_58=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_59=userUniformsObj.mainTextureTransform;
int2 param_60=_3263;
bool param_61=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_62=userUniformsObj.mainTextureUvMinMax;
bool param_63=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_64=userUniformsObj.mainTextureBorderColor;
float param_65=0.0;
mainTextureSample_2=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param_54,param_55,param_56,param_57,param_58,param_59,param_60,param_61,param_62,param_63,param_64,param_65);
}
#else
{
float2 param_66=mainTextureGetDims2D(userUniformsObj);
int param_67=mainTextureLayout;
int param_68=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_69=box.zy;
bool param_70=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_71=userUniformsObj.mainTextureTransform;
int2 param_72=_3288;
bool param_73=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_74=userUniformsObj.mainTextureUvMinMax;
bool param_75=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_76=userUniformsObj.mainTextureBorderColor;
float param_77=0.0;
mainTextureSample_2=sc_SampleTexture(mainTexture,mainTextureSmplr,param_66,param_67,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76,param_77);
}
#endif
float param_78=mainTextureSample_2.x;
float param_79=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_78,param_79);
float4 mainTextureSample_3;
#if (mainTextureLayout==2)
{
float2 param_80=mainTextureGetDims2D(userUniformsObj);
int param_81=mainTextureLayout;
int param_82=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_83=box.zw;
bool param_84=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_85=userUniformsObj.mainTextureTransform;
int2 param_86=_3324;
bool param_87=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_88=userUniformsObj.mainTextureUvMinMax;
bool param_89=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_90=userUniformsObj.mainTextureBorderColor;
float param_91=0.0;
mainTextureSample_3=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param_80,param_81,param_82,param_83,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91);
}
#else
{
float2 param_92=mainTextureGetDims2D(userUniformsObj);
int param_93=mainTextureLayout;
int param_94=mainTextureGetStereoViewIndex(varStereoViewID);
float2 param_95=box.zw;
bool param_96=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_97=userUniformsObj.mainTextureTransform;
int2 param_98=_3349;
bool param_99=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_100=userUniformsObj.mainTextureUvMinMax;
bool param_101=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_102=userUniformsObj.mainTextureBorderColor;
float param_103=0.0;
mainTextureSample_3=sc_SampleTexture(mainTexture,mainTextureSmplr,param_92,param_93,param_94,param_95,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103);
}
#endif
float param_104=mainTextureSample_3.x;
float param_105=sdfEdge;
multisampleOpacity+=calculateSdfOpacity(param_104,param_105);
multisampleOpacity*=0.2;
opacity=mix(singleSampleOpacity,multisampleOpacity,multisampleBlend);
}
return opacity;
}

fragment main_frag_out main_frag(main_frag_in in [[stage_in]],constant UserUniforms& userUniformsObj [[buffer(21)]],texture2d<float> mainTexture [[texture(0)]],texture2d_array<float> mainTextureArrSC [[texture(1)]],texture2d<float> colorTexture [[texture(2)]],texture2d_array<float> colorTextureArrSC [[texture(3)]],texture2d<float> mainFillTexture [[texture(4)]],texture2d_array<float> mainFillTextureArrSC [[texture(5)]],texture2d<float> shadowFillTexture [[texture(6)]],texture2d_array<float> shadowFillTextureArrSC [[texture(7)]],texture2d<float> outlineFillTexture [[texture(8)]],texture2d_array<float> outlineFillTextureArrSC [[texture(9)]],texture2d<float> backgroundFillTexture [[texture(10)]],texture2d_array<float> backgroundFillTextureArrSC [[texture(11)]],sampler mainTextureSmplr [[sampler(0)]],sampler mainTextureArrSCSmplr [[sampler(1)]],sampler colorTextureSmplr [[sampler(2)]],sampler colorTextureArrSCSmplr [[sampler(3)]],sampler mainFillTextureSmplr [[sampler(4)]],sampler mainFillTextureArrSCSmplr [[sampler(5)]],sampler shadowFillTextureSmplr [[sampler(6)]],sampler shadowFillTextureArrSCSmplr [[sampler(7)]],sampler outlineFillTextureSmplr [[sampler(8)]],sampler outlineFillTextureArrSCSmplr [[sampler(9)]],sampler backgroundFillTextureSmplr [[sampler(10)]],sampler backgroundFillTextureArrSCSmplr [[sampler(11)]],float4 gl_FragCoord [[position]])
{
main_frag_out out={};
float4 FragColor[4]={};
float4 fillColor=float4(1.0);
float2 fillUv=in.varPackedTex.zw;
fillUv.x=fract(fillUv.x);
fillUv.y=fract(fillUv.y);
float sdfEdge=0.5;
float param=0.0;
float param_1=in.varPassIdentifier;
bool _3407=isPass(param,param_1);
bool _3416;
if (!_3407)
{
float param_2=0.1;
float param_3=in.varPassIdentifier;
_3416=isPass(param_2,param_3);
}
else
{
_3416=_3407;
}
if (_3416)
{
#if (MAIN_FILL_COLOR)
{
fillColor=userUniformsObj.mainColor;
}
#else
{
#if (MAIN_FILL_TEXTURE)
{
fillUv=float2((userUniformsObj.mainFillTextureTransform*float3(fillUv,1.0)).xy);
float4 mainFillTextureSample;
#if (mainFillTextureLayout==2)
{
float2 param_4=mainFillTextureGetDims2D(userUniformsObj);
int param_5=mainFillTextureLayout;
int param_6=mainFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_7=fillUv;
bool param_8=(int(SC_USE_UV_TRANSFORM_mainFillTexture)!=0);
float3x3 param_9=userUniformsObj.mainFillTextureTransform;
int2 param_10=_3449;
bool param_11=(int(SC_USE_UV_MIN_MAX_mainFillTexture)!=0);
float4 param_12=userUniformsObj.mainFillTextureUvMinMax;
bool param_13=(int(SC_USE_CLAMP_TO_BORDER_mainFillTexture)!=0);
float4 param_14=userUniformsObj.mainFillTextureBorderColor;
float param_15=0.0;
mainFillTextureSample=sc_SampleTexture(mainFillTextureArrSC,mainFillTextureArrSCSmplr,param_4,param_5,param_6,param_7,param_8,param_9,param_10,param_11,param_12,param_13,param_14,param_15);
}
#else
{
float2 param_16=mainFillTextureGetDims2D(userUniformsObj);
int param_17=mainFillTextureLayout;
int param_18=mainFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_19=fillUv;
bool param_20=(int(SC_USE_UV_TRANSFORM_mainFillTexture)!=0);
float3x3 param_21=userUniformsObj.mainFillTextureTransform;
int2 param_22=_3477;
bool param_23=(int(SC_USE_UV_MIN_MAX_mainFillTexture)!=0);
float4 param_24=userUniformsObj.mainFillTextureUvMinMax;
bool param_25=(int(SC_USE_CLAMP_TO_BORDER_mainFillTexture)!=0);
float4 param_26=userUniformsObj.mainFillTextureBorderColor;
float param_27=0.0;
mainFillTextureSample=sc_SampleTexture(mainFillTexture,mainFillTextureSmplr,param_16,param_17,param_18,param_19,param_20,param_21,param_22,param_23,param_24,param_25,param_26,param_27);
}
#endif
fillColor=mainFillTextureSample;
}
#endif
}
#endif
}
else
{
bool _3507;
#if (ENABLE_SHADOW)
{
float param_28=0.2;
float param_29=in.varPassIdentifier;
_3507=isPass(param_28,param_29);
}
#else
{
_3507=(int(ENABLE_SHADOW)!=0);
}
#endif
if (_3507)
{
#if (SHADOW_FILL_COLOR)
{
fillColor=userUniformsObj.shadowColor;
}
#else
{
#if (SHADOW_FILL_TEXTURE)
{
fillUv=float2((userUniformsObj.shadowFillTextureTransform*float3(fillUv,1.0)).xy);
float4 shadowFillTextureSample;
#if (shadowFillTextureLayout==2)
{
float2 param_30=shadowFillTextureGetDims2D(userUniformsObj);
int param_31=shadowFillTextureLayout;
int param_32=shadowFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_33=fillUv;
bool param_34=(int(SC_USE_UV_TRANSFORM_shadowFillTexture)!=0);
float3x3 param_35=userUniformsObj.shadowFillTextureTransform;
int2 param_36=_3540;
bool param_37=(int(SC_USE_UV_MIN_MAX_shadowFillTexture)!=0);
float4 param_38=userUniformsObj.shadowFillTextureUvMinMax;
bool param_39=(int(SC_USE_CLAMP_TO_BORDER_shadowFillTexture)!=0);
float4 param_40=userUniformsObj.shadowFillTextureBorderColor;
float param_41=0.0;
shadowFillTextureSample=sc_SampleTexture(shadowFillTextureArrSC,shadowFillTextureArrSCSmplr,param_30,param_31,param_32,param_33,param_34,param_35,param_36,param_37,param_38,param_39,param_40,param_41);
}
#else
{
float2 param_42=shadowFillTextureGetDims2D(userUniformsObj);
int param_43=shadowFillTextureLayout;
int param_44=shadowFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_45=fillUv;
bool param_46=(int(SC_USE_UV_TRANSFORM_shadowFillTexture)!=0);
float3x3 param_47=userUniformsObj.shadowFillTextureTransform;
int2 param_48=_3568;
bool param_49=(int(SC_USE_UV_MIN_MAX_shadowFillTexture)!=0);
float4 param_50=userUniformsObj.shadowFillTextureUvMinMax;
bool param_51=(int(SC_USE_CLAMP_TO_BORDER_shadowFillTexture)!=0);
float4 param_52=userUniformsObj.shadowFillTextureBorderColor;
float param_53=0.0;
shadowFillTextureSample=sc_SampleTexture(shadowFillTexture,shadowFillTextureSmplr,param_42,param_43,param_44,param_45,param_46,param_47,param_48,param_49,param_50,param_51,param_52,param_53);
}
#endif
fillColor=shadowFillTextureSample;
}
#endif
}
#endif
}
else
{
bool _3599;
#if (ENABLE_OUTLINE)
{
float param_54=0.3;
float param_55=in.varPassIdentifier;
_3599=isPass(param_54,param_55);
}
#else
{
_3599=(int(ENABLE_OUTLINE)!=0);
}
#endif
if (_3599)
{
#if (ENABLE_SDF)
{
sdfEdge-=in.varSdfOffset;
}
#endif
#if (OUTLINE_FILL_COLOR)
{
fillColor=userUniformsObj.outlineColor;
}
#else
{
#if (OUTLINE_FILL_TEXTURE)
{
fillUv=float2((userUniformsObj.outlineFillTextureTransform*float3(fillUv,1.0)).xy);
float4 outlineFillTextureSample;
#if (outlineFillTextureLayout==2)
{
float2 param_56=outlineFillTextureGetDims2D(userUniformsObj);
int param_57=outlineFillTextureLayout;
int param_58=outlineFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_59=fillUv;
bool param_60=(int(SC_USE_UV_TRANSFORM_outlineFillTexture)!=0);
float3x3 param_61=userUniformsObj.outlineFillTextureTransform;
int2 param_62=_3638;
bool param_63=(int(SC_USE_UV_MIN_MAX_outlineFillTexture)!=0);
float4 param_64=userUniformsObj.outlineFillTextureUvMinMax;
bool param_65=(int(SC_USE_CLAMP_TO_BORDER_outlineFillTexture)!=0);
float4 param_66=userUniformsObj.outlineFillTextureBorderColor;
float param_67=0.0;
outlineFillTextureSample=sc_SampleTexture(outlineFillTextureArrSC,outlineFillTextureArrSCSmplr,param_56,param_57,param_58,param_59,param_60,param_61,param_62,param_63,param_64,param_65,param_66,param_67);
}
#else
{
float2 param_68=outlineFillTextureGetDims2D(userUniformsObj);
int param_69=outlineFillTextureLayout;
int param_70=outlineFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_71=fillUv;
bool param_72=(int(SC_USE_UV_TRANSFORM_outlineFillTexture)!=0);
float3x3 param_73=userUniformsObj.outlineFillTextureTransform;
int2 param_74=_3665;
bool param_75=(int(SC_USE_UV_MIN_MAX_outlineFillTexture)!=0);
float4 param_76=userUniformsObj.outlineFillTextureUvMinMax;
bool param_77=(int(SC_USE_CLAMP_TO_BORDER_outlineFillTexture)!=0);
float4 param_78=userUniformsObj.outlineFillTextureBorderColor;
float param_79=0.0;
outlineFillTextureSample=sc_SampleTexture(outlineFillTexture,outlineFillTextureSmplr,param_68,param_69,param_70,param_71,param_72,param_73,param_74,param_75,param_76,param_77,param_78,param_79);
}
#endif
fillColor=outlineFillTextureSample;
}
#endif
}
#endif
}
else
{
bool _3696;
#if (ENABLE_BACKGROUND)
{
float param_80=0.4;
float param_81=in.varPassIdentifier;
_3696=isPass(param_80,param_81);
}
#else
{
_3696=(int(ENABLE_BACKGROUND)!=0);
}
#endif
if (_3696)
{
#if (BACKGROUND_FILL_COLOR)
{
float4 param_82=userUniformsObj.backgroundColor;
sc_writeFragData0(param_82,FragColor);
}
#else
{
#if (BACKGROUND_FILL_TEXTURE)
{
fillUv=float2((userUniformsObj.backgroundFillTextureTransform*float3(fillUv,1.0)).xy);
float4 backgroundFillTextureSample;
#if (backgroundFillTextureLayout==2)
{
float2 param_83=backgroundFillTextureGetDims2D(userUniformsObj);
int param_84=backgroundFillTextureLayout;
int param_85=backgroundFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_86=fillUv;
bool param_87=(int(SC_USE_UV_TRANSFORM_backgroundFillTexture)!=0);
float3x3 param_88=userUniformsObj.backgroundFillTextureTransform;
int2 param_89=_3731;
bool param_90=(int(SC_USE_UV_MIN_MAX_backgroundFillTexture)!=0);
float4 param_91=userUniformsObj.backgroundFillTextureUvMinMax;
bool param_92=(int(SC_USE_CLAMP_TO_BORDER_backgroundFillTexture)!=0);
float4 param_93=userUniformsObj.backgroundFillTextureBorderColor;
float param_94=0.0;
backgroundFillTextureSample=sc_SampleTexture(backgroundFillTextureArrSC,backgroundFillTextureArrSCSmplr,param_83,param_84,param_85,param_86,param_87,param_88,param_89,param_90,param_91,param_92,param_93,param_94);
}
#else
{
float2 param_95=backgroundFillTextureGetDims2D(userUniformsObj);
int param_96=backgroundFillTextureLayout;
int param_97=backgroundFillTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_98=fillUv;
bool param_99=(int(SC_USE_UV_TRANSFORM_backgroundFillTexture)!=0);
float3x3 param_100=userUniformsObj.backgroundFillTextureTransform;
int2 param_101=_3759;
bool param_102=(int(SC_USE_UV_MIN_MAX_backgroundFillTexture)!=0);
float4 param_103=userUniformsObj.backgroundFillTextureUvMinMax;
bool param_104=(int(SC_USE_CLAMP_TO_BORDER_backgroundFillTexture)!=0);
float4 param_105=userUniformsObj.backgroundFillTextureBorderColor;
float param_106=0.0;
backgroundFillTextureSample=sc_SampleTexture(backgroundFillTexture,backgroundFillTextureSmplr,param_95,param_96,param_97,param_98,param_99,param_100,param_101,param_102,param_103,param_104,param_105,param_106);
}
#endif
float4 param_107=backgroundFillTextureSample;
sc_writeFragData0(param_107,FragColor);
}
#endif
}
#endif
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}
}
}
}
float param_108=0.1;
float param_109=in.varPassIdentifier;
if (isPass(param_108,param_109))
{
float4 colorTextureSample;
#if (colorTextureLayout==2)
{
float2 param_110=colorTextureGetDims2D(userUniformsObj);
int param_111=colorTextureLayout;
int param_112=colorTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_113=in.varPackedTex.xy;
bool param_114=(int(SC_USE_UV_TRANSFORM_colorTexture)!=0);
float3x3 param_115=userUniformsObj.colorTextureTransform;
int2 param_116=_3800;
bool param_117=(int(SC_USE_UV_MIN_MAX_colorTexture)!=0);
float4 param_118=userUniformsObj.colorTextureUvMinMax;
bool param_119=(int(SC_USE_CLAMP_TO_BORDER_colorTexture)!=0);
float4 param_120=userUniformsObj.colorTextureBorderColor;
float param_121=0.0;
colorTextureSample=sc_SampleTexture(colorTextureArrSC,colorTextureArrSCSmplr,param_110,param_111,param_112,param_113,param_114,param_115,param_116,param_117,param_118,param_119,param_120,param_121);
}
#else
{
float2 param_122=colorTextureGetDims2D(userUniformsObj);
int param_123=colorTextureLayout;
int param_124=colorTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_125=in.varPackedTex.xy;
bool param_126=(int(SC_USE_UV_TRANSFORM_colorTexture)!=0);
float3x3 param_127=userUniformsObj.colorTextureTransform;
int2 param_128=_3829;
bool param_129=(int(SC_USE_UV_MIN_MAX_colorTexture)!=0);
float4 param_130=userUniformsObj.colorTextureUvMinMax;
bool param_131=(int(SC_USE_CLAMP_TO_BORDER_colorTexture)!=0);
float4 param_132=userUniformsObj.colorTextureBorderColor;
float param_133=0.0;
colorTextureSample=sc_SampleTexture(colorTexture,colorTextureSmplr,param_122,param_123,param_124,param_125,param_126,param_127,param_128,param_129,param_130,param_131,param_132,param_133);
}
#endif
float preMultipliedAlpha=colorTextureSample.w*fillColor.w;
float4 param_134=float4(colorTextureSample.xyz*preMultipliedAlpha,preMultipliedAlpha);
sc_writeFragData0(param_134,FragColor);
}
else
{
#if (ENABLE_SDF)
{
float4 mainTextureSample;
#if (mainTextureLayout==2)
{
float2 param_135=mainTextureGetDims2D(userUniformsObj);
int param_136=mainTextureLayout;
int param_137=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_138=in.varPackedTex.xy;
bool param_139=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_140=userUniformsObj.mainTextureTransform;
int2 param_141=_3877;
bool param_142=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_143=userUniformsObj.mainTextureUvMinMax;
bool param_144=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_145=userUniformsObj.mainTextureBorderColor;
float param_146=0.0;
mainTextureSample=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param_135,param_136,param_137,param_138,param_139,param_140,param_141,param_142,param_143,param_144,param_145,param_146);
}
#else
{
float2 param_147=mainTextureGetDims2D(userUniformsObj);
int param_148=mainTextureLayout;
int param_149=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_150=in.varPackedTex.xy;
bool param_151=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_152=userUniformsObj.mainTextureTransform;
int2 param_153=_3902;
bool param_154=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_155=userUniformsObj.mainTextureUvMinMax;
bool param_156=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_157=userUniformsObj.mainTextureBorderColor;
float param_158=0.0;
mainTextureSample=sc_SampleTexture(mainTexture,mainTextureSmplr,param_147,param_148,param_149,param_150,param_151,param_152,param_153,param_154,param_155,param_156,param_157,param_158);
}
#endif
float param_159=mainTextureSample.x;
float param_160=sdfEdge;
float param_161=userUniformsObj.multisampleBlend;
float sdfOpacity=calculateSdfOpacityMultisampled(param_159,param_160,param_161,in.varStereoViewID,userUniformsObj,mainTextureArrSC,mainTextureArrSCSmplr,mainTexture,mainTextureSmplr,in.varPackedTex);
float preMultipliedAlpha_1=fillColor.w*sdfOpacity;
float4 param_162=float4(fillColor.xyz*preMultipliedAlpha_1,preMultipliedAlpha_1);
sc_writeFragData0(param_162,FragColor);
}
#else
{
float4 mainTextureSample_1;
#if (mainTextureLayout==2)
{
float2 param_163=mainTextureGetDims2D(userUniformsObj);
int param_164=mainTextureLayout;
int param_165=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_166=in.varPackedTex.xy;
bool param_167=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_168=userUniformsObj.mainTextureTransform;
int2 param_169=_3958;
bool param_170=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_171=userUniformsObj.mainTextureUvMinMax;
bool param_172=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_173=userUniformsObj.mainTextureBorderColor;
float param_174=0.0;
mainTextureSample_1=sc_SampleTexture(mainTextureArrSC,mainTextureArrSCSmplr,param_163,param_164,param_165,param_166,param_167,param_168,param_169,param_170,param_171,param_172,param_173,param_174);
}
#else
{
float2 param_175=mainTextureGetDims2D(userUniformsObj);
int param_176=mainTextureLayout;
int param_177=mainTextureGetStereoViewIndex(in.varStereoViewID);
float2 param_178=in.varPackedTex.xy;
bool param_179=(int(SC_USE_UV_TRANSFORM_mainTexture)!=0);
float3x3 param_180=userUniformsObj.mainTextureTransform;
int2 param_181=_3983;
bool param_182=(int(SC_USE_UV_MIN_MAX_mainTexture)!=0);
float4 param_183=userUniformsObj.mainTextureUvMinMax;
bool param_184=(int(SC_USE_CLAMP_TO_BORDER_mainTexture)!=0);
float4 param_185=userUniformsObj.mainTextureBorderColor;
float param_186=0.0;
mainTextureSample_1=sc_SampleTexture(mainTexture,mainTextureSmplr,param_175,param_176,param_177,param_178,param_179,param_180,param_181,param_182,param_183,param_184,param_185,param_186);
}
#endif
float preMultipliedAlpha_2=mainTextureSample_1.x*fillColor.w;
float4 param_187=float4(fillColor.xyz*preMultipliedAlpha_2,preMultipliedAlpha_2);
sc_writeFragData0(param_187,FragColor);
}
#endif
}
out.FragColor_0=FragColor[0];
out.FragColor_1=FragColor[1];
out.FragColor_2=FragColor[2];
out.FragColor_3=FragColor[3];
return out;
}

} // FRAGMENT SHADER
